/**
 * sert à l'affichage de la fenètre principale et à celle où la
 * navigation clavier est nécessaire : recherche et remplacement.
 */
package macpre;

import java.awt.*;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.event.MouseWheelEvent;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
//import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
//import javax.swing.JViewport;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;
import static macpre.LeTimer.monPanneau;

public class PanneauClavier extends Panneau {
//================ dimensions visibles ===========
	//   int largeurVisible, hauteurVisible; // renseignées par sa fenetre

	int nombreDeFrappes; // compte le nombre de frappes pour sauver
	int xPosCarAvant, yPosCarAvant, xPosCar, yPosCar;
	ConnectProcessor maConnect;
	String aspellPret;
	LeTimerGlo monTemps;
	LeTimer monTempsPresse;

//============== panneau-clavier ===========================
	int[] leTrucDep, leTrucArr;
	Coordonnees coordDeb, coordArr;

	public PanneauClavier(PretexFrame leFrame, int largeur, int hauteur) {
		super(leFrame);
		largeurEcran = largeur;
		longueurEcran = hauteur; // uniquement de l'image
		chargeLeDicoNrc();
		leTrucDep = new int[2];
		monTemps = new LeTimerGlo(1, this);
		monTemps.monPaneClav = this;
		monTempsPresse = new LeTimer(1);
		monTempsPresse.monPanneau = this;
	}

	void initLaClasseNrc() {
		chargeLeDicoNrc();
	}

	@Override
	public void paint(Graphics g) {
		if (monFrame.fenetrePrincipale.maVue == null) {
			monFrame.fenetrePrincipale.maVue = monFrame.fenetrePrincipale.getViewport();
		}
		Point lePoint = monFrame.fenetrePrincipale.maVue.getViewPosition();
		int positionX = lePoint.x, positionY = lePoint.y;
		largeurVisible = monFrame.fenetrePrincipale.maVue.getWidth();
		hauteurVisible = monFrame.fenetrePrincipale.maVue.getHeight();
		/*
		 * monFrame.setCursor(new Cursor(Cursor.WAIT_CURSOR));
		 * if (visible) { setCursor(new
		 * Cursor(Cursor.TEXT_CURSOR)); } else { setCursor(new
		 * Cursor(Cursor.DEFAULT_CURSOR)); }
		 */
		super.paint(g);
		if (offScreenImage != null) {
			g.drawImage(offScreenImage, positionX, positionY,
							positionX + largeurVisible, positionY + hauteurVisible,
							positionX, positionY,
							positionX + largeurVisible, positionY + hauteurVisible,
							this);
		}
	}

	@Override
	void montre() {
		visible = true;
		maGestion.afficheLeParagrapheCourant();
		repaint();
	}

	@Override
	void cache() {
		Graphics monGraphique = getGraphics();

		visible = false;
		if (monGraphique == null) {
			return;
		}
		monGraphique.setColor(Color.white);
		monGraphique.fillRect(0, 0, largeurEcran, longueurEcran);
		monGraphique.dispose();
	}

	void affiche(Graphics g) {
	}
//====================== correcteur =========================
	boolean enControle = false;
	byte majusculeCommune = 0;
	ArrayList<String> lesNonReconnus; // un ensemble de mots
	String leDicoNonReconnus;
	String lAdresseDeCharge;
	boolean aRanger;
	int numeroPrecedent;
	String leDernierMot;

	boolean estSeparateur(String leMot) {
		if (leMot.length() != 1) {
			return false;
		}
		return estSeparateur(leMot.charAt(0));
	}

	boolean estSeparateur(char leCar) {
		switch (leCar) {
//            case '\uffff':
			case '\n':
			case '\t':
			case ' ':
			case ',':
			case '.':
			case ';':
			case ':':
			case '\'':
			case '!':
			case '?':
			case '"':
			case '+':
			case '-':
			case '=':
			case '(':
			case ')':
			case '{':
			case '}':
			case '[':
			case ']':
				return true;
		}
		return false;
	}

	/**
	 * Ouvre le fichier nommé, copie les données dans ce fichier. Le
	 * paramètre fileName est le nom du fichier texte du disque
	 */
	boolean writeAFile(String fileName, String donnees) {
		try {     // Ouvre le fichier du nom donné
			File file = new File(fileName);
			FileWriter out = new FileWriter(file);
			// Crée un tableau de caractères de la taille du fichier,
			// pour l'utiliser comme tampon de données, dans lequel
			// nous allons lire les données texte
			out.write(donnees, 0, donnees.length());
			out.close();
			return true;
		} catch (IOException e) {
			return false;
		}
	}

	/**
	 * Ouvre le fichier nommé, obtient le texte de ce fichier et le
	 * renvoi comme une chaine. Le paramètre fileName est le nom du
	 * fichier texte du disque.
	 *
	 * @param fileName.
	 * @return la chaine contenue dans le fichier.
	 */
	String readAFile(String fileName) {
		char[] data;
		int chars_read;
		String donnees;

		try {     // Ouvre le fichier du nom donné
			File file = new File(fileName);
			// Obtient la taille du fichier ouvert
			int size = (int) file.length();
			// définit à zéro le compteur du nombre
			// de caractères lus dans le fichier
			chars_read = 0;
			// Crée un lecteur d'entrée sur le fichier pour lire ses données.
			// FileReader gère les conversions d'encodage
			// des caractères internationaux.
			FileReader in = new FileReader(file);
			// Crée un tableau de caractères de la taille du fichier,
			// pour l'utiliser comme tampon de données, dans lequel
			// nous allons lire les données texte
			data = new char[size];
			// Lit tous les caractères dans le tampon
			while (in.ready()) {
// Incrémente le compteur à chaque caractère lu,
// et les accumule dans le tampon de données.
				chars_read += in.read(data, chars_read, size - chars_read);
			}
			in.close();
			donnees = new String(data, 0, chars_read);
			return donnees;
		} catch (IOException e) {
			return null;
		}
	}

	void appelleleDicoNrc() {
//      ChoixLang laLangue = new ChoixLang(monFrame, "Choose Dictionnary Language", true);
		int tail;
		String leLang;
		String leChemin = monFrame.donneLeCheminEnv();
		File leDirectoire = new File(leChemin);
		String[] maListe = leDirectoire.list();

//      monFrame.listeDictionnaire.removeAllElements();
		monFrame.listeDictionnaire.removeAll(monFrame.listeDictionnaire);
		if (maListe != null) {
			for (int k = 0; k < maListe.length; k++) {
				if (maListe[k].endsWith(".nrc")) {
					tail = maListe[k].length();
					leLang = maListe[k].substring(0, tail - 4);
					monFrame.listeDictionnaire.add(leLang);
				}
			}
		}
		/*        UneCombo laLangue = new UneCombo(monFrame,
		 "Choose a Dictionnary Language", true);
		 laLangue.setLocationRelativeTo(monFrame);
		 laLangue.getRootPane().setDefaultButton(laLangue.OKBouton);
		 laLangue.setVisible(true);*/
	}

	private void chargeLeDicoNrc() {
		String leChemin = monFrame.donneLeCheminEnv();
		String leTout;
		String[] lesLignes;

		if (monFrame.nomDuDocument.equals("NewDoc")) {
			return;
		}
		/*
		 * if (monFrame.languageCourant.equals("")) {
		 * appelleleDico(); }
		 */
		if (leChemin == null) {
			leChemin = "";
		}
		leDicoNonReconnus = monFrame.languageCourant + ".nrc";
		lAdresseDeCharge = leChemin + leDicoNonReconnus;
		lesNonReconnus = new ArrayList<String>();

		leTout = readAFile(lAdresseDeCharge);
		if (leTout == null) {
			return;
		}
		lesLignes = leTout.split("\n");
		lesNonReconnus.addAll(Arrays.asList(lesLignes));
	}

	void sauveLeDicoNrc() {
		if (lesNonReconnus == null) {
			return;
		}
		String leMot;
		String leChemin = monFrame.donneLeCheminEnv();
		String lesLignes = "";

		if (monFrame.languageCourant.equals("")) {
			return;
		}
		if (lesNonReconnus.isEmpty()) {
			return;
		}
		if (leChemin == null) {
			leChemin = "";
		}
		leDicoNonReconnus = monFrame.languageCourant + ".nrc";
		lAdresseDeCharge = leChemin + leDicoNonReconnus;

		for (int k = 0; k < lesNonReconnus.size(); k++) {
			leMot = lesNonReconnus.get(k);
			if (leMot == null) {
				break;
			}
			if (leMot.equals(" ")) {
				continue;
			}
			leMot += "\n";
			lesLignes += leMot;
		}
		writeAFile(lAdresseDeCharge, lesLignes);
	}

	String rangeCeMotNrc() {
		String leTest = null, laValeur;
		String lAutre, leTexte = maConnect.leTexte;
		String[] laListe;
		int k, pos;

		pos = leTexte.indexOf(":");
		leTexte = leTexte.substring(pos + 1);
		laListe = leTexte.split(",");
		DialListe voir = new DialListe(monFrame, true, laListe, leDernierMot);
//        voir.setLocation( 200, 100);
		voir.setLocationRelativeTo(monFrame);
		voir.setVisible(true);
		laValeur = voir.laValeur;
		if (laValeur == null) {
			return "";
		}
		if (laValeur.startsWith(" ")) {
			laValeur = laValeur.substring(1);
		}
		if (!laValeur.equals("XXX")) {
			return laValeur;
		}

		lAutre = leDernierMot.toLowerCase();
		if ((leDernierMot.equals("^"))
						| (leDernierMot.equals(" "))) {
			return "";
		}
		/*
		 * if (monFrame.afficheMessage("Spell checker",
		 * monFrame.resActions.getString("aspellNrc"), 2) ==
		 * Messages2.NO) { return; }
		 */
		for (k = 0; k < lesNonReconnus.size(); k++) {
			leTest = lesNonReconnus.get(k);
			if (leTest == null) {
				break;
			} else if (leTest.compareTo(lAutre) >= 0) {
				break;
			}
		}
		if (leTest == null) {
			lesNonReconnus.add(k, lAutre);
		} else if (leTest.compareTo(lAutre)
						!= 0) {
			lesNonReconnus.add(k, lAutre);
		}
		numeroPrecedent = k;
		return "YYY";
	}

	void supprimeCeMotNrc() {
		if (numeroPrecedent < lesNonReconnus.size()) {
			if (numeroPrecedent != -1) {
				lesNonReconnus.remove(numeroPrecedent);
			}
		}
	}

	boolean dansLaListeNrc(String ceMot) {
		String leTest;
		String lAutre;

		if (lesNonReconnus == null) {
			return false;
		}
		lAutre = ceMot.toLowerCase();
		for (int k = 0; k < lesNonReconnus.size(); k++) {
			leTest = lesNonReconnus.get(k);
			if (leTest == null) {
				return false;
			} else if (leTest.equals(lAutre)) {
				return true;
			}
		}
		return false;
	}

	boolean majComm() {
		majusculeCommune++;

		if (majusculeCommune == 2) {
			majusculeCommune = 0;
			return true;
		}
		return false;
	}

	boolean finiEnSeparateur(String leMot) {
		if (leMot.isEmpty()) {
			return false;
		}
		char laFin = leMot.charAt(leMot.length() - 1);

		return estSeparateur(laFin);
	}

	boolean commenceEnSeparateur(String leMot) {
		char laFin = leMot.charAt(0);

		if (estSeparateur(laFin)) {
			leDernierMot = leDernierMot.substring(1);
			return true;
		}
		if (leMot.length() == 1) {
			return false;
		}
		laFin = leMot.charAt(1);
		if (estSeparateur(laFin)) {
			leDernierMot = leDernierMot.substring(2);
			return true;
		}
		return false;
	}
	boolean enBoutonDroit;

	/**
	 * Renvoie vrai si laStr commence par une majuscule.
	 *
	 * @param laStr
	 * @return
	 */
	boolean commenceEnMaj(String laStr) {
		String laChai = laStr;
		char deb = laChai.charAt(0);

		while ((estSeparateur(deb)) & (laChai.length() > 1)) {
			laChai = laChai.substring(1);
			deb = laChai.charAt(0);
		}
		return (deb >= 65) & (deb <= 91);
	}
	boolean onAffiche = false;

	/**
	 * Cette fonction appelle le correcteur orthographique après un
	 * séparateur.
	 *
	 * @param leCar
	 */
	void appelleAspell(char leCar, int leCode) {

		if (monFrame.fenetrePrincipale.monPane.maConnect == null) {
			return;
		}
		if (enControle) {
			enControle = false;
			return;
		}
		if ((leCode == KeyEvent.VK_CONTROL)) {
			enControle = true;
			return;
		}
		if (maGestion.enGrandeFormule != Globale.HORS_GD_FORMULE) {
			return;
		}
		if (monFrame.mesBoutons.erreur) {
			monFrame.mesBoutons.erreur = false;
			monFrame.mesBoutons.reecritCesMenus();
		}
		AChaine laAchaine;
		String leRetour;
		String prefixe = monFrame.languageCourant.substring(0, 2);

		if ((maConnect != null) && (estSeparateur(leCar))) {
			String[] liste = new String[2];
			if (leCar == '\n') {
				laAchaine = maGestion.leParagrapheCourant.donneLaAChainePrecedente();
			} else {
				/*                if (maGestion.dansUneTable) {
				 laAchaine = monFrame.maGestion.maTableActive.maCelluleActive.monParagraphe.maChaineCourante;
				 } else {*/
				laAchaine = maGestion.leParagrapheCourant.maChaineCourante;
				//               }
			}
			if (laAchaine == null) {
				return;
			}
			if (laAchaine.contexte == Globale.CONTEXTE_LABEL_ETC) {
				return;
			}
			leDernierMot = laAchaine.maChaine;
			if (leDernierMot == null) {
				return;
			}
			if (commenceEnMaj(leDernierMot)) {
				if (laAchaine.attribut == Globale.ATTRIBUT_ZIGZAG) {
					laAchaine.attribut = Globale.ATTRIBUT_NORMAL;
					maGestion.afficheLeParagrapheCourant();
					maGestion.afficheLeParagrapheSuivant();
//                   maGestion.traiteLeCode(KeyEvent.VK_F4);
					maGestion.monDocument.isDirty = true;
				}
				return;
			}
			if (estSeparateur(leDernierMot)) {
				return;
			}
			commenceEnSeparateur(leDernierMot);
			/*
			 * if (leDernierMot.length() <= 1) { return; }
			 */
			if (finiEnSeparateur(leDernierMot)) {
				leDernierMot = leDernierMot.substring(0, leDernierMot.length() - 1);
			}
			if (leDernierMot.length() <= 2) {
				laAchaine.attribut = Globale.ATTRIBUT_NORMAL;
////				maGestion.afficheLeParagrapheCourant();
				return;
			}
			if (dansLaListeNrc(leDernierMot)) {
				if (laAchaine.attribut == Globale.ATTRIBUT_ZIGZAG) {
					laAchaine.attribut = Globale.ATTRIBUT_NORMAL;
					maGestion.monDocument.isDirty = true;
				}
				maGestion.afficheLeParagrapheCourant();
				maGestion.afficheLeParagrapheSuivant();
//                maGestion.traiteLeCode(KeyEvent.VK_F4);
				return;
			}
			if (maGestion.maMagie.commenceEnMajuscule(leDernierMot)) {
				AChaine laPrecedente;

				laPrecedente = maGestion.leParagrapheCourant.donneLaAChainePrecedente();
				if (laPrecedente == null) {
					return;
				}
				if (!maGestion.maMagie.donneMajCommune(laPrecedente.maChaine.charAt(0))) {
					return;
				}
			}
			if (leDernierMot.equals("")) {
				return;
			}
			liste[0] = leDernierMot;
			liste[1] = prefixe;
			maConnect.redemarreLaCommande(liste);
			if (maConnect.leTexte.equals("")) {
				if (laAchaine.attribut == Globale.ATTRIBUT_ZIGZAG) {
					laAchaine.attribut = Globale.ATTRIBUT_NORMAL;
					maGestion.monDocument.isDirty = true;
					maGestion.afficheLeParagrapheCourant();
					maGestion.afficheLeParagrapheSuivant();
				}
////				maGestion.afficheLeParagrapheCourant();
////				maGestion.afficheLeParagrapheSuivant();
//                maGestion.traiteLeCode(KeyEvent.VK_F4);
				return;
			}
			if (lesNonReconnus == null) {
				lesNonReconnus = new ArrayList<String>();
			}
			if (laAchaine.attribut != Globale.ATTRIBUT_ZIGZAG) {
				laAchaine.attribut = Globale.ATTRIBUT_ZIGZAG;
				maGestion.monDocument.isDirty = true;
			} else if (enBoutonDroit) {
				enBoutonDroit = false;
				leRetour = rangeCeMotNrc();
				if (leRetour.equals("")) {
					return;
				}
				if (leRetour.equals("YYY")) {
					laAchaine.attribut = Globale.ATTRIBUT_NORMAL;
					maGestion.afficheLeParagrapheCourant();
					maGestion.afficheLeParagrapheSuivant();
//                    maGestion.traiteLeCode(KeyEvent.VK_F4);
					maGestion.monDocument.isDirty = true;
					return;
				}
				laAchaine.maChaine = leRetour;
				laAchaine.attribut = Globale.ATTRIBUT_NORMAL;
				maGestion.monDocument.isDirty = true;
			}
//			if (laAchaine.attribut == Globale.ATTRIBUT_ZIGZAG) {
			maGestion.afficheLeParagrapheCourant();
			maGestion.afficheLeParagrapheSuivant();
//			}
//            maGestion.traiteLeCode(KeyEvent.VK_F4);
			monFrame.prior = true;
		}
	}
//====================== clavier =========================

	private void traiteControl(int leCar) {
		if (leCar == KeyEvent.VK_CONTROL) {
			return;
		}
		if (maGestion.enGrandeFormule == Globale.HORS_GD_FORMULE) {
			if (maGestion.aideF1declenchee("ControlsAide.html")) {
				return;
			}
			maGestion.traiteControl((char) leCar);
//            return;
		} else {
			if (maGestion.aideF1declenchee("ControlsInFormula.html")) {
				return;
			}
			monFrame.maFormuleGestion.traiteControl(leCar);
//            return;
		}
	}

	private boolean traiteAlt(char leCar) {
//    int leCar = maGestion.clavierChar;

		if (maGestion.envoieUnRC) {
			maGestion.envoieUnRC = false;
			maGestion.renvoieUnRC = true;
		}
		if (leCar == 0) {
			return false;
		}

		if (leCar > 20000) {      // Ah le mac !!!!!
			return true;
		} else {
			leCar %= 128;
			if (System.getProperty("os.name").startsWith("Mac")) {
				leCar = (char) monFrame.monMacroClavier.convertitDuMac(leCar);
			}
		}
		if (monFrame.monMacroClavier.traiteAlte(leCar)) {
			if (maGestion.renvoieUnRC) {
				maGestion.renvoieUnRC = false;
				maGestion.envoieUnRC = true;
			}
			monFrame.laRecVoc = "";
			return true;
		}
		if (maGestion.renvoieUnRC) {
			maGestion.renvoieUnRC = false;
			maGestion.envoieUnRC = true;
		}
		return false;
	}

	String recoitLeMot() {
		String leMot = "";
		int userInput;
		try {
			InputStreamReader ISR = new InputStreamReader(System.in);
			BufferedReader BR = new BufferedReader(ISR);
			userInput = BR.read();
			while (userInput != ' ') {
				leMot += userInput;
				userInput = BR.read();
			}
			BR.close();
			ISR.close();
		} catch (IOException ex) {
			Logger.getLogger(PanneauClavier.class.getName()).log(Level.SEVERE, null, ex);
		}
		return leMot;
	}
//    String leMot;
	boolean formuleTraitee;
	boolean vocPresqueFini;
//    boolean clefTresPresse;

//    VocalFormule maFormuleVocale;
	int leInt, leInt2;
	boolean enDebut = false;

	boolean estUnAccent(char lecar) {
		switch (lecar) {
			case '^':
				return true;
//          case '¨':
			//            return true;
			case '~':
				return true;
		}
		return false;
	}

	boolean enCompose, enCorrige;
	String laBonneChaine, laCorrection;
	int indice = 0, leBonChar;

	boolean forceAffichageVocal(KeyEvent e) {
		if (!monFrame.enVocal) {
			return false;
		}
		if (e.isAltDown() | e.isControlDown()) {
			return true;
		}
		return false;
	}

	void correction() {
		if (indice == 0) {
			if (maGestion.clavierIntKP == 37) {
				indice++;
			} else {
				enCorrige = false;
				return;
			}
		} else {
			if (indice < 4) {
				indice++;
			} else {
				indice = 0;
				if (maGestion.enGrandeFormule == 0) {
					texteBSceMot(laCorrection);
				} else {
					monFrame.maFormuleGestion.traiteLeCode(0, (char) KeyEvent.VK_BACK_SPACE);
				}
				laCorrection = "";
				enCorrige = false;
				onContinue = true;
			}
		}
		return;
	}

	void composition(Integer leNum) {
		if (indice == 0) {
			if (maGestion.clavierCharKP != '0') {
				indice = 0;
				enCompose = false;
				if (monFrame.maFormuleVocale != null) {
					if (monFrame.maFormuleVocale.isVisible()) {
						if (traiteAlt(maGestion.clavierCharKP)) {
							monFrame.toucheDejaTraitee = true;
							return;
						}
					}
				}
				return;
			}
			indice++;
			laBonneChaine = "";
			monFrame.toucheDejaTraitee = true;
			return;
		} else if (indice == 3) {   // on finit
			indice = 0;
//                enCompose = false;
			laBonneChaine += maGestion.clavierCharKP;
			//        System.out.println(laBonneChaine);
			leNum = new Integer(laBonneChaine);
			leBonChar = leNum;
			monFrame.toucheDejaTraitee = false;
			this_keyTyped(null);
			return;
		}
		laBonneChaine += maGestion.clavierCharKP;
		indice++;
		monFrame.toucheDejaTraitee = true;
		return;
	}
	ArrayList<PairHybride> lesPaires;
	boolean estToutSimple;

	void apresDetectionPresse() {
		estToutSimple = true;
		if (lesPaires == null) {
			return;
		}
		PairHybride laPaire;

		for (PairHybride toto : lesPaires) {
			laPaire = toto;
			System.out.print("   " + laPaire.leCode);
			if (!laPaire.estSimple()) {
				estToutSimple = false;
			}
		}
		System.out.println("   ");

		lesPaires.clear();
		return;
	}
	ACaractere leCarBasic;
	int posBasic;
	Coordonnees lesBasic;
	boolean enCorrectionFormule;
	int nbDeSelection;  // donne le nb de caractères sélectionnés
	int nbDePasAgauche = 0;	// donne le nb de 37 pour atteindre la sélection
	int nbPourLeRetour;
	int enSeize = 0;
	boolean enShift = false;

	boolean traiteFlechesEnShift(KeyEvent e) {
		ACaractere leCarCourant;
		char leCar;
		int posCourant;
		Coordonnees lesCourantes;
		int clavierIntKP = e.getKeyCode();

		/*		if (enSeize == 4) {
		 for (int k = 0; k < nbPourLeRetour; k++) {
		 maGestion.avanceLeCurseur();
		 }
		 maGestion.afficheLeCurseur();
		 return true;
		 }*/
		if (e.isShiftDown()) {
			enShift = true;
		}
		if (clavierIntKP == KeyEvent.VK_SHIFT) {
			enSeize++;
			if (enSeize == 1) {
				nbPourLeRetour = nbDePasAgauche;
				nbDePasAgauche = 0;
			}
//			maGestion.monClip.enSelection = false;
			return true;
		}
		if ((clavierIntKP != KeyEvent.VK_LEFT)
						&& (clavierIntKP != KeyEvent.VK_RIGHT)) {
			return false;
		}

		/*		if (enSeize != 2) {
		 return true;
		 }*/
//		System.out.print(" D" + e.getKeyCode());
		if (!maGestion.monClip.enSelection) {
			leCarBasic = null;
			maGestion.reculeLeCurseur();
			maGestion.afficheLeCurseur();
			maGestion.avanceLeCurseur();
			//		maGestion.afficheLeCurseur();
			maGestion.monPane.leTrucDep = null;
			maGestion.monPane.leTrucArr = null;
		}
		if (leCarBasic == null) {
			leCarBasic = maGestion.leParagrapheCourant.maChaineCourante.monACaractereCourant;
			posBasic = maGestion.leParagrapheCourant.maChaineCourante.monNumero;
			maGestion.leParDeb = maGestion.leParagrapheCourant;
			nbDeSelection = 0;
			maGestion.nbFrappes = 0;
		}
		if (clavierIntKP == KeyEvent.VK_LEFT) {
			maGestion.reculeLeCurseur();
		} else {
				maGestion.avanceLeCurseur();
		}
		maGestion.afficheLeCurseur();
		leCarCourant = maGestion.leParagrapheCourant.maChaineCourante.monACaractereCourant;
		posCourant = maGestion.leParagrapheCourant.maChaineCourante.monNumero;
		maGestion.leParArr = maGestion.leParagrapheCourant;
		lesCourantes = new Coordonnees(leCarCourant.xPosition, leCarCourant.yPosition);
		lesBasic = new Coordonnees(leCarBasic.xPosition, leCarBasic.yPosition);
		inverseCeChemin(lesBasic, lesCourantes, Color.CYAN);
		if (leTrucDep == null) {
			leTrucDep = new int[2];
		}
		if (leTrucArr == null) {
			leTrucArr = new int[2];
		}
		maGestion.monPane.leTrucDep[0] = posBasic;
		maGestion.monPane.leTrucArr[0] = posCourant;
		maGestion.monClip.enSelection = true;
		nbDeSelection++;
//		finSeize = true;
		return true;
	}

	@Override
	void this_keyPressed(KeyEvent e) {
//		Integer leNum = new Integer(0);
		if (onContinue) {
			return;
		}
		if (e.isShiftDown()) {
			System.out.print(" M" + e.getKeyCode());
			if (traiteFlechesEnShift(e)) {
				monFrame.toucheDejaTraitee = true;
				return;
			}
		}
		maGestion.clavierIntKP = e.getKeyCode();
		/*		if (maGestion.clavierIntKP == 8) {
		 monFrame.statusBar.setText("" + e.getKeyCode());
		 monFrame.prior = true;
		 //		return;
		 }*/
		if (maGestion.clavierIntKP == KeyEvent.VK_LEFT) {
			nbDePasAgauche++;
		}
		maGestion.clavierCharKP = (char) e.getKeyChar();
		System.out.print(" " + maGestion.clavierIntKP);
		if (maGestion.clavierIntKP == 18) {//A cause de l'absence de unicode !!
			if (maGestion.clavierCharKP == (char) '\uffff') {
				enCompose = true;
				indice = 0;
				return;
			}
		}
//        maGestion.traiteLeCode(maGestion.clavierIntKP);
/*        if (monFrame.enVocal) {
		 PairHybride laPaire = new PairHybride(maGestion.clavierIntKP, maGestion.clavierCharKP);
		 if (lesPaires == null) {
		 lesPaires = new ArrayList();
		 lesPaires.add(laPaire);
		 } else {
		 lesPaires.add(laPaire);
		 }
		 return;
		 }
		 if (estToutSimple) {
		 return;
		 }*/

		/*        if (enCorrige) {
		 correction();
		 return;
		 }*/
		//=====================================================
		if (!enDebut) {
			leInt = maGestion.clavierIntKP;
			enDebut = true;
		} else {
			leInt2 = maGestion.clavierIntKP;
			enDebut = false;
		}

		if (maGestion.maTableActive != null) {
			if (maGestion.enGrandeFormule == 0) {
				monFrame.toucheDejaTraitee = false;
				if ((e.isActionKey())
								|| (e.getKeyCode() == KeyEvent.VK_ESCAPE)) {
					this_keyTyped(e);
				}
				return;
			}
		}
		monFrame.metStatusBarre();
		if (e.isControlDown()) {
			monFrame.laRecVoc = "";
			traiteControl(maGestion.clavierIntKP);
			if (System.getProperty("os.name").startsWith("Win")) {
				int k = e.getModifiers();
				if (k == 10) {
					monFrame.toucheDejaTraitee = false;
				}
			}
			return;
		}
		if (maGestion.clavierIntKP == KeyEvent.VK_META) {
			maGestion.enMeta = true;
			return;
		}
		if (e.isAltDown()) {
			if (traiteAlt(maGestion.clavierCharKP)) {
				monFrame.toucheDejaTraitee = true;
				return;
			}
		}
		if (maGestion.enGrandeFormule == Globale.HORS_GD_FORMULE) {
			if (maGestion.traiteLeCode(maGestion.clavierIntKP)) {
				if (maGestion.clavierIntKP != KeyEvent.VK_DELETE) {
					maGestion.maMagie.aMisLeMot = false;
				}
				monFrame.toucheDejaTraitee = true;
				return;
			}
		} else {
			if (monFrame.maFormuleGestion.traiteLeCode(0, (char) maGestion.clavierIntKP)) {
				formuleTraitee = true;
				if (maGestion.maTableActive != null) {
					maGestion.traiteLeCode(KeyEvent.VK_F4);
				}
				return;
			}
			if (maGestion.maTableActive != null) {
				maGestion.traiteLeCode(KeyEvent.VK_F4);
			}
		}
		monFrame.toucheDejaTraitee = false;
	}

	char passeEnMaj(char leCar) {
		String leMot = "" + leCar;
		leMot = leMot.toUpperCase();
		return leMot.charAt(0);
	}

	boolean onContinue;

	@Override
	void this_keyTyped(KeyEvent e) {

		if (monFrame.toucheDejaTraitee) {
			monFrame.toucheDejaTraitee = false;
			return;
		}
		if (monFrame.enVocal) {
			if (enCompose) {
				onContinue = true;
				enCompose = false;
				maGestion.clavierChar = (char) leBonChar;
				monFrame.laRecVoc += maGestion.clavierChar;
				return;
			}
		}
		maGestion.clavierInt = e.getKeyCode();
		maGestion.clavierChar = (char) e.getKeyChar();

		if (monFrame.enVocal) {
			if (onContinue) {
				onContinue = false;
				return;
			}
			if (!enCorrige) {
				if (maGestion.enGrandeFormule == Globale.HORS_GD_FORMULE) {
					monFrame.laRecVoc += maGestion.clavierChar;
					return;
				} else {
					if (monFrame.maFormuleVocale != null) {
						monFrame.laRecVoc += maGestion.clavierChar;
						return;
					}
				}
			}/* else {
			 if (maGestion.enGrandeFormule == Globale.HORS_GD_FORMULE) {
			 monFrame.laRecVoc += maGestion.clavierChar;
			 return;
			 }
			 }*/

//        leInt2 = maGestion.clavierInt;
			if (maGestion.premierLaSuite) {
				maGestion.premierLaSuite = false;
				maGestion.clavierChar = passeEnMaj(maGestion.clavierChar);
			}
			if ((maGestion.clavierChar == ' ')) {// && (monFrame.enVocal)) {
				monFrame.laRecVoc += maGestion.clavierChar;
			}
		}
		if (monFrame.toucheDejaTraitee) {
			monFrame.toucheDejaTraitee = false;
			return;
		}
		if (maGestion.maTableActive != null) {
			if (maGestion.enGrandeFormule == 0) {
				maGestion.maTableActive.traiteClefPressee(e);
				monFrame.toucheDejaTraitee = true;
				return;
			}
		}
		if (formuleTraitee & (maGestion.clavierInt == KeyEvent.VK_ENTER)) {
			return;
		}
		if (maGestion.clavierInt == KeyEvent.VK_DELETE) {
			return;
		}
		if (maGestion.enGrandeFormule != Globale.HORS_GD_FORMULE) {
			if ((maGestion.clavierChar == KeyEvent.VK_TAB)
							|| (maGestion.clavierChar == KeyEvent.VK_ENTER)) {
// on retourne pour attendre le symbole.
				return;
			}
		}
		if (maGestion.enGrandeFormule == Globale.HORS_GD_FORMULE) {
			if (maGestion.dirigeLaFrappeClavier()) {
				return;
			}
		} else if (maGestion.dirigeLaFrappeClavierEnFormule()) {
			return;
		}
		nombreDeFrappes++;
		if (nombreDeFrappes > Globale.NB_FRAPPES_AVANT_SAUVEGARDE) {
//         monFrame.monEntree.sauveGardeCeDocument();
			nombreDeFrappes = 0;
		}
		if (!visible) {
			return;
		}
		if (maGestion.enGrandeFormule == Globale.HORS_GD_FORMULE) {
			maGestion.traiteSimpleCar();
		} else {
			maGestion.traiteSimpleCarEnFormule();
		}
		monFrame.toucheDejaTraitee = false;
		if (!monFrame.enVocal) {
			maGestion.afficheLeParagrapheCourant();
		}
	}

	char lAncien;

	void apresDetection() {
		//           System.out.println("final = " + monFrame.laRecVoc);
		if (monFrame.laRecVoc.isEmpty()) {
			return;
		}
		traiteCeMotReconnu(monFrame.laRecVoc);
		monFrame.laRecVoc = "";
	}

	@Override
	void this_keyReleased(KeyEvent e) {
		if (monFrame.enVocal) {
			/*            if (maGestion.enGrandeFormule > 0) {
			 monFrame.maFormuleVocale.laChaineDetectee = "";
			 }*/
			monTemps.timer.cancel();
			if (maGestion.enGrandeFormule != 0) {
				monTemps = new LeTimerGlo(4, this);
			} else {
				monTemps = new LeTimerGlo(3, this);
			}
//                       monTempsPresse.timer.cancel();
//                     monTempsPresse = new LeTimer(1);

//            System.out.println("keycode =  " + e.getKeyCode());
		}
	}

	void formuleBSceMot(String leMot) {
		for (int k = 0; k < leMot.length(); k++) {
			monFrame.maFormuleGestion.traiteLeCode(0, (char) KeyEvent.VK_BACK_SPACE);
		}
	}

	boolean sansRefairePar;

	void texteBSceMot(String leMot) {
		if (leMot == null) {
			enCorrige = false;
			return;
		}
		if (leMot.startsWith(" ")) {
			leMot = leMot.substring(1);
		}
		for (int k = 0; k < leMot.length(); k++) {
			maGestion.traiteLeCode((char) KeyEvent.VK_BACK_SPACE);
		}
	}
	//   boolean enDeuxTemps;
	String leMotAvant = "xxxxxxx";
	boolean yAerreur;

	void traiteCeMotReconnu(String leMot) {
		int nbre = 0;
		String leMotBase = leMot;
		leMot = leMot.toLowerCase();
		if (leMot.isEmpty()) {
			/*			for (int k = 0; k < nbPourLeRetour; k++) {
			 maGestion.avanceLeCurseur();
			 }
			 maGestion.afficheLeCurseur();*/
			return;
		}

		if (maGestion.deMettreUnBlanc) {
			maGestion.deMettreUnBlanc = false;
			leMotBase = leMotBase.substring(1);
		}
//		System.out.print(" T" + leMot);
		if (enCorrige) {
//            enDeuxTemps = true;
			enCorrige = false;
			leCarBasic = null;
			System.out.println("hors corrige tcmr");
		}
		if (monFrame.maFormuleVocale != null) {
			if (monFrame.maFormuleVocale.isVisible()) {
				if (leMot.startsWith("\b")) {
					yAerreur = true;
					while (leMot.startsWith("\b")) {
						leMot = leMot.substring(1);
						nbre++;
					}
				}
//            System.out.println("\n départ  " + leMot);
				if (yAerreur) {
					yAerreur = false;
					/*           while (leMotAvant.startsWith(" ")) {
					 leMotAvant = leMotAvant.substring(1);
					 }*/
					while (leMot.startsWith(" ")) {
						leMot = leMot.substring(1);
					}
					for (int k = 1; k < nbre; k++) {
						leMot = leMot.substring(1);
					}
					/*               if (leMot.contains(leMotAvant)) {
					 System.out.println("le mot avant = " + leMotAvant +  " le mot  = " +  leMot);
					 leMot = leMot.replace(leMotAvant, "");
					 }*/
				}
				leMotAvant = leMot;
//            System.out.print(" corrigé  " + leMot);
				monFrame.maFormuleVocale.laChaineDetectee = leMotBase;
				monFrame.maFormuleVocale.apresDetection();
//            System.out.print(" leMotAvant =  " + leMotAvant);
//            monFrame.maFormuleVocale.laChaineDetectee = "";
				return;
			}
		}
		if (monFrame.monChoix == null) {
			monFrame.monChoix = new VoxMenu(monFrame, "jPreTeX Vocal", false);
			monFrame.monChoix.setVisible(true);
		}
		if (monFrame.monChoix.isVisible()) {
			monFrame.monChoix.laChaineDetectee = leMot;
			monFrame.monChoix.apresDetection();
			return;
		}
		if (leMot.contains("jformule") | leMot.contains("jformula")) {
			monFrame.maGestion.ajouteCetteChaineCurseur(" ", false);
			maGestion.afficheLeParagrapheCourant();
			if (monFrame.enVocal) {
				monFrame.mesActionsClavier.displayYesFormulaAction.actionPerformed(null);
				monFrame.maGestion.formuleTemporaire = false;
				monFrame.maFormuleVocale.positionne();
				monFrame.maFormuleVocale.setVisible(true);
//				monFrame.maGestion.monPane.requestFocus();
				//               return;
			} else {
				Messages2 monMes = new Messages2(monFrame, "", true, 1, "Veuillez passer en mode vocal svp.");
				monMes.setVisible(true);
			}
			return;
		}
		if (leMot.contains("jpretex")) {
			monFrame.laRecVoc = "";
			maGestion.afficheLeParagrapheCourant();
			monFrame.monChoix.positionne();
			monFrame.monChoix.setVisible(true);
//			monFrame.maGestion.monPane.requestFocus();
			maGestion.afficheLeParagrapheCourant();
			return;
		}
		if (monFrame.enVocal) {
			if (monFrame.mesCommandesVox == null) {
				monFrame.mesCommandesVox = new CommandesVox(monFrame, "Commandes Vocales", false);
			}
			monFrame.mesCommandesVox.positionne();
			monFrame.mesCommandesVox.setVisible(true);
		}
		if (leMot.contains("jblanc") | leMot.contains("jwhite")) {
			sansRefairePar = true;
//            texteBSceMot("jblanc");
			monFrame.laRecVoc = "";
			maGestion.lePrecedent = 'x';
			maGestion.ajouteCetteChaineCurseur(" ", false);
			sansRefairePar = false;
			maGestion.afficheLeParagrapheCourant();
			return;
		}
		if (leMot.contains("jsupprime") | leMot.contains("jdelete")) {
//      System.out.println("voici :" + leMot + ".");
			monFrame.maGestion.traiteDelete(false);
			sansRefairePar = true;
//            texteBSceMot(leMot);
			monFrame.laRecVoc = "";
			sansRefairePar = false;
			maGestion.afficheLeParagrapheCourant();
			return;
		}
		if (leMot.contains("jcas")) {
			maGestion.traiteControl((char) KeyEvent.VK_K);
			return;
		}
		if (leMot.contains("backspace")) {
			if (maGestion.enGrandeFormule == 0) {
				maGestion.traiteLeCode((char) KeyEvent.VK_BACK_SPACE);
			}
			return;
		}

// en mode recherche de mots ===================
		if (monFrame.enRechercheVocal) {
			if (leMot.contains("encore") | leMot.contains("again")) {
				sansRefairePar = false;
				maGestion.afficheLeParagrapheCourant();
				monFrame.mesActions.searchAgainAction.actionPerformed(null);
			}
			return;
		}
		maGestion.mesCoordCourantes
						= maGestion.leParagrapheCourant.maChaineCourante.donneCoordonneesDuCarCourant();
		if (maGestion.mettreUnBlanc) {
			maGestion.mettreUnBlanc = false;
			maGestion.lePrecedent = 'a';
			leMotBase = " " + leMotBase;
		}
		maGestion.ajouteCetteChaineCurseur(leMotBase, false);
//       maGestion.ajouteCetteChaine(leMotBase, false);
		maGestion.mesCoordCourantes
						= maGestion.leParagrapheCourant.maChaineCourante.donneCoordonneesDuCarCourant();
		maGestion.afficheLeCurseur();
		laCorrection = monFrame.laRecVoc;
		monFrame.laRecVoc = "";
		maGestion.traiteLeCode(KeyEvent.VK_F4);
	}

	//============================= souris ====================
	@Override
	void this_mouseEntered(MouseEvent e) {
//     int k = 0;
//      maGestion.monPane.requestFocus();
	}

	@Override
	void this_mouseWheelMoved(MouseWheelEvent e) {
		int units = Globale.UNIT_INCREMENT / e.getUnitsToScroll();
		int hTot = maGestion.monDocument.donneLaHauteurTotale();
		int amount = e.getScrollAmount();

		if (hTot < maGestion.monPane.hauteurVisible) {
			return;
		}
		maGestion.monCrayon.translation += amount * units * 3;
		if (maGestion.monCrayon.translation < 0) {
			maGestion.monCrayon.translation = 0;
		} else if (maGestion.monCrayon.translation > hTot - maGestion.monPane.hauteurVisible) {
			maGestion.monCrayon.translation = hTot - maGestion.monPane.hauteurVisible;
		}
		maGestion.metBienLaScroll(maGestion.monCrayon.translation);
//      maGestion.monDocument.afficheEnEntierLePane();
		maGestion.petitAffichage();
	}

	@Override
	void this_mouseClicked(MouseEvent e) {
		int nbClicks = e.getClickCount(); // double click ...
		char lecc;

		maGestion.maMagie.monMotif = null;
		AChaine laAChaine;
		laAChaine = monFrame.maGestion.leParagrapheCourant.donneLaAChainePrecedente();
		if (laAChaine != null) {
			lecc = laAChaine.donneLeCharA(laAChaine.maChaine.length() - 1);
			if ((maGestion.mesPolices.contexte == Globale.CONTEXTE_LABEL_ETC)
							& (lecc == ')')) {
				maGestion.mesPolices.metAjour();
			} else if (maGestion.mesPolices.policeTexCourante == Globale.BALISE_TEX) {
				maGestion.mesPolices.metAjour();
			}
		}

		appelleAspell(' ', 0); // avec un blanc pour séparer.

		if (nbClicks > 1) {
			laAChaine = monFrame.maGestion.leParagrapheCourant.donneLaChaineCourante();
			if (laAChaine.genre == Globale.GENRE_FIGURE) {
				((Figure) laAChaine).editUneAncienneFigure();
			} else {
				maGestion.delimiteLeMot(true);
				laAChaine = monFrame.maGestion.leParagrapheCourant.donneLaAChaineSuivante();
				monFrame.maGestion.leParagrapheCourant.metCetteAChaineCourante(laAChaine);
				laAChaine.metLeACaractereCourantEnFin();
			}
		}
	}

	/**
	 * @return true si on a du modifier la position dans la page pour
	 * rendre le curseur visible.
	 */
	boolean ajusteLaPosition(int x, int y) {
		if (y <= 0) {
			return false;
		}
		Dimension dimensionPage = monFrame.fenetrePrincipale.maVue.getExtentSize();
		int decalageHaut = maGestion.monCrayon.translation - y + 16;
		int decalageBas = y - 16 - maGestion.monCrayon.translation - dimensionPage.height;

		if ((decalageHaut <= 0) & (decalageBas <= 0)) {
			return false;
		}
		if (decalageHaut > 0) {
			while (decalageHaut > 0) {
				maGestion.monCrayon.translation -= dimensionPage.height;
				decalageHaut -= dimensionPage.height;
			}
			return true;
		}
		if (decalageBas > 0) {
			while (decalageBas > 0) {
				maGestion.monCrayon.translation += dimensionPage.height;
				decalageBas -= dimensionPage.height;
			}
			return true;
		}
		return false;
	}

	@Override
	void this_mouseDragged(MouseEvent e) {
//      ACaractere leCarCourant;

		if (boutonDroitPresse | boutonCentralPresse) {
			return;
		}
//        Dimension dimensionPage = monFrame.fenetrePrincipale.maVue.getExtentSize();
		Coordonnees coorFin = new Coordonnees(e.getX(), e.getY()
						+ maGestion.monCrayon.translation);
		maGestion.vaIci(coorFin);
		coorFin = maGestion.mesCoordCourantes;

		inverseCeChemin(coordDeb, coorFin,
						monFrame.monMenuCouleurs.couleurCurseurSelection);
	}

	void inverseCeChemin(Coordonnees dep, Coordonnees arr, Color couleur) {
		int largeur = monFrame.fenetrePrincipale.maVue.getWidth();
		int leDecalage = maGestion.monCrayon.translation;
		int hauteur = (3 * monFrame.resTailleMenu) / 2;

		if ((dep == null) | (arr == null)) {
			maGestion.petitAffichage();
			return;
		}

		int xpos[] = {
			dep.abscisse, largeur, largeur, arr.abscisse, arr.abscisse, 0, 0, dep.abscisse};
		int ypos[] = {
			dep.ordonnee - leDecalage - hauteur, dep.ordonnee - leDecalage - hauteur,
			arr.ordonnee - leDecalage - hauteur, arr.ordonnee - leDecalage - hauteur,
			arr.ordonnee - leDecalage + 5, arr.ordonnee - leDecalage + 5,
			dep.ordonnee - leDecalage + 5, dep.ordonnee - leDecalage + 5};
		maGestion.petitAffichage();
// on defint le polygone
		laZoneSelect = new Polygon(xpos, ypos, 8);
// on inverse la zone nouvelle
		maGestion.monCrayon.inverseCePolygone(laZoneSelect, couleur);
		maGestion.maCouleurSelection = couleur;
	}

	/**
	 * Inverse le chemin.
	 */
	@Override
	void inverseCeCheminPol(ACaractere leCarBase, ACaractere leCarCourant,
					Color couleur) {
		int largeur = monFrame.fenetrePrincipale.maVue.getWidth();
		if (leCarBase == null) {
			return;
		}
		if (leCarCourant == null) {
			return;
		}
		int xpos[] = {
			leCarBase.xPosition, largeur, largeur,
			leCarCourant.xPosition, leCarCourant.xPosition,
			0, 0, leCarBase.xPosition};
		int ypos[] = {
			leCarBase.yPosition - maGestion.monCrayon.translation - leCarBase.maxAscent,
			leCarBase.yPosition - maGestion.monCrayon.translation - leCarBase.maxAscent,
			leCarCourant.yPosition - maGestion.monCrayon.translation - leCarCourant.maxAscent,
			leCarCourant.yPosition - maGestion.monCrayon.translation - leCarCourant.maxAscent,
			leCarCourant.yPosition - maGestion.monCrayon.translation + leCarCourant.maxDescent,
			leCarCourant.yPosition - maGestion.monCrayon.translation + leCarCourant.maxDescent,
			leCarBase.yPosition - maGestion.monCrayon.translation + leCarBase.maxDescent,
			leCarBase.yPosition - maGestion.monCrayon.translation + leCarBase.maxDescent};
// on reinverse la zone précédente
/*
		 * if ((laZoneSelect != null) &&
		 * (!maGestion.selectionEffacee)) {
		 * maGestion.monCrayon.inverseCePolygone(laZoneSelect,
		 * couleur); } else { maGestion.selectionEffacee =
		 * false; }
		 */
		maGestion.petitAffichage();
// on defint le polygone
		laZoneSelect = new Polygon(xpos, ypos, 8);
// on inverse la zone nouvelle
		maGestion.monCrayon.inverseCePolygone(laZoneSelect, couleur);
// on repaint le tout
//        maGestion.monPane.repaint();
	}

	void clickDroitFormule(MouseEvent e, MenuBoutonDroit clickDroit, Point p) {
		/*
		 * ACaractere leCar =
		 * maGestion.monParagrapheCourant.donneLeCarCourant();
		 *
		 * switch (leCar.type) { case
		 * Globale.TYPE_BORNE_ENTREE:
		 * clickDroit.jPopupMatrice.show(monFrame, e.getX() -
		 * p.x, e.getY() + 100 - p.y); break; default:
		 * clickDroit.jPopupFormule.show(monFrame, e.getX() -
		 * p.x, e.getY() + 100 - p.y); break; }
		 *
		 */
	}

	/**
	 * Detecte en particulier quel bouton est pressé : gauche, central
	 * droit. Met le bouléain correspondant à vrai.
	 *
	 * @param e
	 */
	@Override
	void this_mousePressed(MouseEvent e) {
		Point p = monFrame.fenetrePrincipale.getViewport().getViewPosition();
		Coordonnees lesCoords = new Coordonnees(e.getX(), e.getY() + maGestion.monCrayon.translation);
		int leBouton = e.getButton();

		if (e.getClickCount() > 1) {
			return;
		}
		maGestion.mousePressee = true;
//      leTrucDep = new int[2];
		maGestion.annuleLaSelection();
		switch (leBouton) {
			case MouseEvent.BUTTON1:
				boutonGauchePresse = true;
//            lesCoords = new Coordonnees(e.getX(), e.getY() + maGestion.monCrayon.translation);
				//          maGestion.vaIci(lesCoords);
				break;
			case MouseEvent.BUTTON2:
				boutonCentralPresse = true;
				break;
			case MouseEvent.BUTTON3:
				if (maGestion != null) {
					if (maGestion.leParagrapheCourant.maChaineCourante != null) {
						if (maGestion.leParagrapheCourant.maChaineCourante.attribut
										== Globale.ATTRIBUT_ZIGZAG) {
							enBoutonDroit = true;
							boutonGauchePresse = true;
							return;
						}
					}
				}
				MenuBoutonDroit clickDroit = new MenuBoutonDroit(monFrame);
				if (maGestion.dansUneTable) {
					clickDroit.jPopupTable.show(monFrame, e.getX() - p.x,
									e.getY() + 100 - p.y);
				} else {
					clickDroit.jPopupStandard.show(monFrame, e.getX() - p.x,
									e.getY() + 100 - p.y);
				}
				return;
		}
		if (coordonneesDifferentes(coordDeb, lesCoords)) {
			if (!maGestion.enMarque) {
				coordDeb = lesCoords;
				maGestion.vaIciPoint(coordDeb, leTrucDep);
				coordDeb = maGestion.mesCoordCourantes;
			}
		}
		if (monFrame.isDirty != maGestion.monDocument.isDirty) {
			monFrame.metLeTitre();
		}
	}

	boolean coordonneesDifferentes(Coordonnees depa, Coordonnees arri) {
		if ((depa == null) || (arri == null)) {
			return true;
		}
		if ((depa.abscisse != arri.abscisse)
						|| (depa.ordonnee != arri.ordonnee)) {
			return true;
		}
		return false;
	}

	/**
	 * Fixe les coordonnées de depart et d'arrivée de la zone inversée.
	 */
	@Override
	void this_mouseReleased(MouseEvent e) {
		int nbClicks = e.getClickCount(); // double click ...
		leTrucArr = new int[2];
		e.consume();
		maGestion.mousePressee = false;
		if (!visible) {
			return;
		}
		if (nbClicks > 1) {
			maGestion.delimiteLeMot(true);
			e.consume();
			boutonDroitPresse = false;
			boutonCentralPresse = false;
			maGestion.afficheLeCurseur();
			return;
		}
		Coordonnees lesCoords = new Coordonnees(e.getX(), e.getY() + maGestion.monCrayon.translation);
		if (boutonGauchePresse) {
			boutonGauchePresse = false;
			if (coordonneesDifferentes(coordArr, lesCoords)) {
				coordArr = lesCoords;
				maGestion.vaIciPoint(coordArr, leTrucArr);
				coordArr = maGestion.mesCoordCourantes;
			}

			if (coordonneesDifferentes(coordArr, coordDeb)) {
				if (!maGestion.dansUneTable) {
					maGestion.monClip.enSelection = true;
					inverseCeChemin(coordDeb, coordArr, monFrame.monMenuCouleurs.couleurCurseurSelection);
				}/* else {
				 coordArr = coordDeb;
				 }*/

			}
		} else if (boutonCentralPresse) {
//            monFrame.mesActions.pasteAction.actionPerformed(null);
		}
		boutonDroitPresse = false;
		boutonCentralPresse = false;
		if (maGestion.dansUneTable) {
			maGestion.maTableActive.afficheLeCurseur();
		} else {
//      maGestion.afficheLeCurseur();
		}
	}
//======================== fin ===========================================
}
