grammar formule2pml;

//options { backtrack = true; k=5;  }
//options {  k=2;  }

@header {
package texToJoc;
}

@members{  FormulePml maFormulePml;}
@lexer::header {package texToJoc;}


expr  : listExpressions
      ;
listExpressions :  (instruc) ;
instruc
   :  chaineSymbolique
   ;
finFichier : EOF { maFormulePml.finFichier(); } ;
finDeFormule   :  FIN_FORMULE { maFormulePml.finDeFormule(); } ;
//=============== caracteres de base =====

caract			: 	CARACTERE 				{ maFormulePml.caractere($start.getText()); }	;
caracReserv	:	CARACTERE_RESERVE	 	{ maFormulePml.caracReserv($start.getText()); } ;
caracExtra		:	CARACTERE_EXTRA	 	{ maFormulePml.caracExtra($start.getText()); } ;
caracSuiva		:	CARACTERE_SUIVANTS	{ maFormulePml.caracSuiva($start.getText()); } ;
caracAccent	:	CARACTERE_ACCENTUE	{ maFormulePml.caracAccent($start.getText()); } ;

caractere	:	caract | caracReserv | caracExtra | caracSuiva | caracAccent
//| detrompeur
			;
detrompeur	:	DETROMPEUR	 { maFormulePml.detrompeur($start.getText()); }	;

lesEspaces 
	:	blancForce | quad | quad2 | blanc
	|	noNumber | notag
	| 	blancNeg | blancSpe | infini
	;
blanc          	:  	BLANC         		{ maFormulePml.blanc(); } ;
blancForce     	:	BLANC_FORCE 	{ maFormulePml.blancForce(); } ;
quad			:	QUAD	 			{ maFormulePml.quad(); } ;
quad2			:	QUAD2 			{ maFormulePml.quad2(); } ;
//====== ceux a faire ====
noNumber		:	NO_NUMBER ;
notag			:	NOTAG 			{ maFormulePml.notag(); } ;
blancNeg	:	BLANC_NEGATIF ;
blancSpe	:	(BLANC_SPECIAL | BLANC_MINI) { maFormulePml.blancForce(); } ;


chaineSymbolique
   : caractereCompletMath*  (finDeFormule | finFichier)
   ;
suiteGenerale	:	caractereCompletMath* ;
/*chaineDeSymboles
   : (caractereCompletMath | separateur)+
   ;
separateur
   : lesSymboles | blancForce | finDeFormule
   ;
*/
//======== accents maths ===========
accentueMath
: accentGraveMath | accentTildeMath | accentAiguMath | accentCirconflexeMath
| accentTremaMath | accentPointMath | accentTchecheMath
| accentBreveMath | accentRondMath | accentOgonekMath | accentCedilleMath
;

accentGraveMath
   :  ACCENT_GRAVE_MATH    { maFormulePml.accentueMath(); }
      caractere            { maFormulePml.accentGraveMath(); } ;
accentAiguMath :  ACCENT_AIGU_MATH     { maFormulePml.accentueMath(); }
                  caractereCompletMath { maFormulePml.accentAiguMath(); } ;
accentTildeMath : ACCENT_TILDE_MATH    { maFormulePml.accentSpeMath("tilde"); }
                  		caractereCompletMath	 ;
accentCirconflexeMath 
	: 	ACCENT_CIRCONFLEXE_MATH 		{ maFormulePml.accentSpeMath("circonflexe"); }
        	caractereCompletMath  ;
accentTremaMath : ACCENT_TREMA_MATH { maFormulePml.accentSpeMath("trema"); }
                  caractereCompletMath ;
accentPointMath 
	: 	ACCENT_POINT_DESSUS_MATH 			{ maFormulePml.accentSpeMath("point"); }
          	caractereCompletMath  ;
accentTchecheMath : ACCENT_TCHECHE_MATH { maFormulePml.accentSpeMath("check"); }
                    caractereCompletMath   ; 
accentBreveMath : ACCENT_BREVE_MATH		{ maFormulePml.accentSpeMath("breve"); }
                  caractereCompletMath  ;
accentRondMath : ACCENT_ROND_MATH   		{ maFormulePml.accentSpeMath("rond"); }
                  caractereCompletMath ;                
accentOgonekMath : ACCENT_OGONEK_MATH	{ maFormulePml.accentSpeMath("ogonek"); }
                  caractereCompletMath ;                
accentCedilleMath : ACCENT_CEDILLE_MATH   { maFormulePml.accentSpeMath("cedille"); }
                  caractereCompletMath ;                
//======== fin accents maths ===========


inferieur   :  INFERIEUR   { maFormulePml.caracteresMathML('<'); } ;
superieur   :  SUPERIEUR   { maFormulePml.caracteresMathML('>'); } ;
egal	:	EGAL  { maFormulePml.caractere("="); } ;

lOblique    :  L_OBLIQUE   { maFormulePml.caracteresMathML('/'); } ;

argumentSimple	:	(caractere | caracteresMathML) | 
						(L_ACCOLADE (caractere | caracteresMathML | ('_' { maFormulePml.indiceLabel(); })
						)+ rAccolade) ;

separateur	: appartient | different | inferieur | superieur | egal | finDeFormule // | parentheseFermante
				| similaire | infOuEgal | caracteresMath2Directs
				| dbleBarreVerticale  | virgule | point | SEPARATEUR
				| math1NonAscii | math2NonAscii
				| appartientPas
				;
				
//============ singletons =================		
singletons	:	blacksquare | displaystyle | lOblique// | parentheseFermante
			| backSlashVide | leUn
			| lesEspaces   	//| debPf | finPf
			;

blacksquare		:	BLACKSQUARE  		{ maFormulePml.singletons("blacksquare"); } ;	
displaystyle		:	DISPLAYSTYLE  		{ maFormulePml.singletons("displaystyle"); } ;	
backSlashVide	:	BACKSLASH_VIDE 	{ maFormulePml.singletons("backSlashVide"); } ;	
leUn				:	LE_UN				 	{ maFormulePml.singletons("leUn"); } ;	

virgule	:	VIRGULE  { maFormulePml.caractere(","); } ;
point	:	POINT	 { maFormulePml.caractere("."); } ;
caractereEnjolive	:	chaineAccoladee
					| 	(caractereSemiComplet	lesSymboles*)+	
					;
caractereSemiComplet
   :  caractereAccentue // | accentueMath //| caracteresMathML
   | lesMotsMaths
   | label
   | caracteresGrecs | caracteresGrecsMaj |caracteresGrecsDirects
   | caracteresMaths | caracteresMath2 | caracteresMathsDirects
   | chaineRoman | chaineItalique | chaineBlackboard | chaineCallig
   | accOuvrReserv | accFermReserv
   | singletons
   | caractereBlackboard 
   | caractereCallig | caractereGot
//   | lesSymboles 
//   | uneMbox
 	 ;

caractereAccentue	: 	caractere | accent  | accentueMath;

caractereCompletMath 
	: caractereIntegrand 	|  caracteresMathML
	| caracteresMath2Directs ;
caractereIntegrand 
	:  caractereAccentue 
   	| caractereCallig | caractereGot 	| caractereBlackboard 
  	| lesMotsMaths
   	| label
   	| lesSymboles 
   	| caracteresGrecs | caracteresGrecsMaj |caracteresGrecsDirects
   	| caracteresMaths | caracteresMath2 | caracteresMathsDirects
  	| chaineAccoladee
  	| chaineRoman | chaineItalique | chaineBlackboard | chaineCallig
  	| chaineGraissee | chainePenchee
 	| lesReserves
  	| singletons
  	| detrompeur    
  	| debSplit | finSplit
  	| genFrac
  	;
chaineAccoladee : { maFormulePml.chaineAccoladeeEntree(); }
                     L_ACCOLADE caractereCompletMath*  rAccolade
                    { maFormulePml.chaineAccoladee(); } ;                 
//============= mbox =================== 

//debPf	:	DEB_PF	{ maFormulePml.debDollar(); } ;
//finPf	:	FIN_PF		{ maFormulePml.finDollar(); } ;

//============= autres polices ==============
caractereEtendu	:	caractereAccentue | lesEspaces  | virgule | point ;

chaineRoman				
	:(	L_ACCOLADE blanc* PL_ROMAN_EMP	{ maFormulePml.unePureOuverturePolice(Globale.ROMAN); }
		(caractereEtendu)+ 
		 rAccolade { maFormulePml.ecritPermanenteAutre(); }
	) | (	PL_ROMAN	{ maFormulePml.unePureOuverturePolice(Globale.ROMAN); }
		(caractereEtendu 	| chaineGraissee | chainePenchee)+  
		rAccolade { maFormulePml.ecritPermanenteAutre(); }
	)	 ;
chaineItalique			
	: (	L_ACCOLADE blanc* PL_ITALIC_EMP { maFormulePml.unePureOuverturePolice(Globale.ITALIC); }
		caractereEtendu+ rAccolade { maFormulePml.ecritPermanenteAutre(); }
	) | (	PL_ITALIC	{ maFormulePml.unePureOuverturePolice(Globale.ITALIC); }
		(caractereEtendu 	| chaineGraissee | chainePenchee)+  
		rAccolade 	{ maFormulePml.ecritPermanenteAutre(); }
	)	;
chaineGraissee		
	: (	L_ACCOLADE blanc* PL_GRASSE_EMP	{ maFormulePml.ecritEnGras(); }
		 caractereEtendu+ rAccolade { maFormulePml.finitLaForme(); }
	  ) | (	PL_GRASSE	{ maFormulePml.ecritEnGras(); }
		 	caractereEtendu+ rAccolade { maFormulePml.finitLaForme(); }
	  ) 	  ;
chainePenchee		
	: (	L_ACCOLADE blanc* PL_PENCHEE_EMP	{ maFormulePml.ecritEnPenchee(); }
		 caractereEtendu+ rAccolade { maFormulePml.finitLaForme(); }
	  ) | (	PL_PENCHEE	{ maFormulePml.ecritEnGras(); }
		 	caractereEtendu+ rAccolade { maFormulePml.finitLaForme(); }
	  ) 	  ;
	  
caractereBlackboard	:	
	MATHBB { maFormulePml.unePureOuverturePolice(Globale.BLACKBOARD); }
	 blanc* caractere  { maFormulePml.ecritPermanenteAutre(); } ;
chaineBlackboard 
	:	 MATHBB	{ maFormulePml.unePureOuverturePolice(Globale.BLACKBOARD); }
		L_ACCOLADE caractere+ rAccolade { maFormulePml.ecritPermanenteAutre(); }
	;
caractereCallig
	:	MATHCAL	{ maFormulePml.unePureOuverturePolice(Globale.CALLIGRAPHIC); }
		blanc* caractere	 { maFormulePml.ecritPermanenteAutre(); } ;
chaineCallig	
	:	MATHCAL	{ maFormulePml.unePureOuverturePolice(Globale.CALLIGRAPHIC); }
		L_ACCOLADE caractere+ rAccolade { maFormulePml.ecritPermanenteAutre(); } ;
caractereGot
	:	MATHGOT	{ maFormulePml.unePureOuverturePolice(Globale.GOTHIC); }
		blanc* caractere	 { maFormulePml.ecritPermanenteAutre(); } ;
chaineGot	
	:	MATHGOT	{ maFormulePml.unePureOuverturePolice(Globale.GOTHIC); }
		L_ACCOLADE caractere+ rAccolade { maFormulePml.ecritPermanenteAutre(); } ;
// Divers ligne

//=== fermeture de groupe: remettre taille normale ===
rAccolade   :  R_ACCOLADE ;//           { maFormulePml.tailleNormale(); }  ;

//lesEnclos	:	parentheseOuvrante | parentheseFermante ;
//parentheseFermante	:	R_PARENTHESE { maFormulePml.caractere($start.getText()); }	;
//parentheseOuvrante	:	L_PARENTHESE { maFormulePml.caractere($start.getText()); }	;
//=============== symboles =============
lesSymboles
   :  lesMonos | lesDuos | lesTrios | matrice | lesCas | finDesCas
   | fantome  | array
   ;
   
debSplit			:	DEB_SPLIT ;
finSplit			:	FIN_SPLIT ;
   
//=================== ARRAY =========================
array		:	DEB_ARRAY   { maFormulePml.array(); }
           		(ligneMatrice)+
            	(R_ACCOLADE   | END_ARRAY)  { maFormulePml.finArray(); }
         ;
//=================== MATRICE =========================
esperluete        :  ESPERLUETE        { maFormulePml.esperluete(); } ;

matrice  :  (	(MATRICE    L_ACCOLADE)
           		|	DEB_MATRICE
           		)	 { maFormulePml.matrice(); }
           		(ligneMatrice)+
            	(R_ACCOLADE   | FIN_MATRICE)  { maFormulePml.finMatrice(); }
         ;
ligneMatrice :		 { maFormulePml.debutLigneMatrice(); }
			suiteGenerale  (itemMatrice)*
               (CE_ERRE | MATRICE_FIN_LIGNE)// { maFormulePml.finItemMatrice(); }
               { maFormulePml.finLigneMatrice(); }
             ;
itemMatrice : esperluete suiteGenerale  { maFormulePml.finItemMatrice(); } ;
//================== CASES =================
lesCas		:	CASES	 		{ maFormulePml.lesCas(); } ;
//			matrice
finDesCas	:	FIN_CASES		{ maFormulePml.finDesCas(); } ;

fantome	:	FANTOME		{ maFormulePml.fantome(); } 
				 L_ACCOLADE
				 suiteGenerale
				  R_ACCOLADE   { maFormulePml.finFantome(); } ;
//=================== monos ================
lesMonos
   :   unIndice | unExposant 
   |  racine | surligne | grandeParenthese 
   |  grandeAccoladeOuv | grandeAccoladeFerm | grandeCrochet// |grandeAccolade
   | produitScalaire | valAbs  | norme | defaut | exces
   | accentBarreMath
   ;
 
accentBarreMath : 	ACCENT_BARRE_DESSUS_MATH  { maFormulePml.monos('B'); }
                  			caractereCompletMath          	{ maFormulePml.finMonos('B'); } ;
   
   
//============= mono ============
unExposant  : exposant ;
unIndice    :   indice ;

exposant 	: 	EXPOSANT_SIMPLE   		{ maFormulePml.entreeExposant(); }
				caractereCompletMath 	{ maFormulePml.exposant(); } ;
indice 		:	INDICE_SIMPLE 			{ maFormulePml.entreeIndice(); }
               		caractereCompletMath 	{   maFormulePml.indice(); } ;

racine	:	RACINE	{ maFormulePml.monos('r'); }
			 caractereCompletMath 	{ maFormulePml.finMonos('r'); }
		;
surligne	:	BARRE	{ maFormulePml.monos('o'); }
			 caractereCompletMath 	{ maFormulePml.finMonos('o'); }
		;
grandeParenthese :	PARENT_GAUCHE	{ maFormulePml.monos('('); }
						suiteGenerale
						PARENT_DROITE     { maFormulePml.finMonos('('); } ;
grandeCrochet :	CROCHET_GAUCHE	{ maFormulePml.monos('['); }
						suiteGenerale
						CROCHET_DROIT     { maFormulePml.finMonos('['); } ;
grandeAccoladeOuv	:	ACCOLADE_OUVRANTE { maFormulePml.monos('{'); }
							suiteGenerale
							(	OUVRANTE_FIN    { maFormulePml.finMonos('.'); }
						 	|	ACCOLADE_FERMANTE { maFormulePml.finMonos('}'); } 
							) ;
grandeAccoladeFerm	:	FERMANTE_DEBUT  { maFormulePml.monos('.'); }
							suiteGenerale
							ACCOLADE_FERMANTE { maFormulePml.finMonos('}'); } ;
produitScalaire   : 	PROD_SCAL_GAUCHE { maFormulePml.monos('G'); } 
                     			suiteGenerale 
                     			PROD_SCAL_DROIT { maFormulePml.finMonos('G'); } ;
norme	:	NORME_GAUCHE	 { maFormulePml.monos('n'); } 
			suiteGenerale// lesTriosL
			NORME_DROITE	 { maFormulePml.finMonos('n'); } ;
valAbs	:	VALEUR_ABS_GAUCHE 	 { maFormulePml.monos('v'); } 
			suiteGenerale
			VALEUR_ABS_DROITE	 { maFormulePml.finMonos('v'); } ;
defaut	:	DEFAUT_GAUCHE  	 { maFormulePml.monos('e'); } 
			suiteGenerale
			DEFAUT_DROIT	 { maFormulePml.finMonos('e'); } ;
exces	:	EXCES_GAUCHE   	 { maFormulePml.monos('a'); } 
			suiteGenerale
			EXCES_DROIT	 { maFormulePml.finMonos('a'); } ;


//========== duo ====
lesDuos
   :  vraieFraction | pardessus | pardessous | binomiale
   ;
vraieFraction   : 	VRAIE_FRACTION          	{ maFormulePml.duos('f'); }
      				caractereCompletMath
      				{ maFormulePml.numerateur(); }
      				caractereCompletMath         { maFormulePml.finDuos('f'); } ;
pardessus		:	PAR_DESSUS    { maFormulePml.duos('c'); }
      				caractereCompletMath         { maFormulePml.numerateur(); }
      				caractereCompletMath         { maFormulePml.finDuos('c'); } ;
pardessous	:	PAR_DESSOUS   { maFormulePml.duos('g'); }
      				caractereCompletMath         { maFormulePml.numerateur(); }
     					caractereCompletMath         { maFormulePml.finDuos('g'); } ;
binomiale	:		BINOM	{ maFormulePml.binoDuos(); }
      				caractereCompletMath         { maFormulePml.numeBino(); }
      				caractereCompletMath         { maFormulePml.finBino(); } ;

//=================== trios ===============
lesTrios
   : integrale  | produitInfini | somme | produitVectoriel | union | intersection
    | grosV
   ;
integrale			:	integraleL ;//  separateur ;
somme			:	sommeL ;//    separateur ;
produitInfini		:	produitInfiniL ;//     separateur ;
produitVectoriel	:	produitVectorielL;//   separateur ;
union				:	unionL;//   separateur ;
intersection		:	intersectionL ;//  separateur ;
grosV				:	grosVL ;//  separateur ;

/*lesTriosL
   : integraleL  | produitInfiniL | sommeL | produitVectorielL | unionL | intersectionL
    | grosVL
   ;
*/  
integraleL	: INTEGRALE 	{ maFormulePml.trios('i'); }
   		  borneInferieure?
   		  borneSuperieure?
   		  integrand	{ maFormulePml.finTrios('i'); } ;	
sommeL	: 	SOMME 	{ maFormulePml.trios('s'); }
   		  		borneInferieure?
   		  		borneSuperieure?
				integrand	{ maFormulePml.finTrios('s'); } ;
 produitInfiniL	: 	PROD_INFINI	{ maFormulePml.trios('p'); }
   		  	   	  		borneInferieure?
   		  	   	  		borneSuperieure?
   		  	   	  		integrand	{ maFormulePml.finTrios('p'); } ;
produitVectorielL  : PROD_VECTORIEL	{ maFormulePml.trios('P'); }
   		  			 borneInferieure?
   		  			 borneSuperieure?
   		  			 integrand	{ maFormulePml.finTrios('P'); }	 ;
unionL	:	UNION      { maFormulePml.trios('h'); }
			borneInferieure?
   		  	borneSuperieure?
   		  	integrand	{ maFormulePml.finTrios('h'); } ;
intersectionL	:	INTERSECTION  { maFormulePml.trios('H'); }
   		  			borneInferieure?
   		  			borneSuperieure?
   		  			integrand	{ maFormulePml.finTrios('H'); } ;
grosVL	:	BIG_VEE  { maFormulePml.trios('w'); }
   		  			borneInferieure?
   		  			borneSuperieure?
   		  			integrand	{ maFormulePml.finTrios('w'); } ;
   		  			
borneInferieure : BORNE_INFERIEURE	{ maFormulePml.entreeBorneInferieure(); }
//INDICE_SIMPLE { maFormulePml.entreeBorneInferieure(); }
               		  	caractereCompletMath	{ maFormulePml.borneInferieure(); }	;   
         
borneSuperieure  : BORNE_SUPERIEURE	{ maFormulePml.entreeBorneSuperieure(); }
//EXPOSANT_SIMPLE { maFormulePml.entreeBorneSuperieure(); }
      			     	  caractereCompletMath { maFormulePml.borneSuperieure(); } ;
integrand	:	 { maFormulePml.entreeIntegrant(); }
//				caractereCompletMath 
				caractereIntegrand+
//				(lesTrios | lesDuos | lesMonos | caractereEnjolive)
				separateur { maFormulePml.integrant(); };
				
//============== special ==============

genFrac	:	GEN_FRAC 		{ maFormulePml.genFrac($start.getText()); }
				caractereCompletMath	{ maFormulePml.genFrac1(); }
				caractereCompletMath	{ maFormulePml.genFrac2(); }
				caractereCompletMath	{ maFormulePml.genFrac3(); }
				caractereCompletMath	{ maFormulePml.genFrac4(); }
		         	{ maFormulePml.duos('F'); }
      			caractereCompletMath	{ maFormulePml.genFrac5(); }
      				{ maFormulePml.numerateur(); }
      			caractereCompletMath	{ maFormulePml.genFrac6(); }
      				{ maFormulePml.finDuos('F'); } 
			;

				
//================ grec ==============
caracteresGrecsDirects
   : alpha | beta | chi | delta | epsilon | varepsilon | phi
   | varphi | gamma | eta | iota | kappa | lambda | mu | nu
   | omega | pi | psi | rho | varrho | sigma | tau | theta
   | vartheta | upsilon | xi | zeta
   ;
alpha       :  A_GREC   { maFormulePml.lettreGrecque('a'); } ;
beta        :  B_GREC   { maFormulePml.lettreGrecque('b'); } ;
chi         :  C_GREC   { maFormulePml.lettreGrecque('c'); } ;
delta       :  D_GREC   { maFormulePml.lettreGrecque('d'); } ;
epsilon     :  E_GREC   { maFormulePml.lettreGrecque('e'); } ;
varepsilon  :  EE_GREC  { maFormulePml.lettreGrecque('e'); } ;
phi         :  F_GREC   { maFormulePml.lettreGrecque('f'); } ;
varphi      :  FF_GREC  { maFormulePml.lettreGrecque('f'); } ;
gamma       :  G_GREC   { maFormulePml.lettreGrecque('g'); } ;
eta         :  H_GREC   { maFormulePml.lettreGrecque('h'); } ;
iota        :  I_GREC   { maFormulePml.lettreGrecque('i'); } ;
kappa       :  K_GREC   { maFormulePml.lettreGrecque('k'); } ;
lambda      :  L_GREC   { maFormulePml.lettreGrecque('l'); } ;
mu          :  M_GREC   { maFormulePml.lettreGrecque('m'); } ;
nu          :  N_GREC   { maFormulePml.lettreGrecque('n'); } ;
pi          :  P_GREC   { maFormulePml.lettreGrecque('p'); } ;
psi         :  Q_GREC   { maFormulePml.lettreGrecque('q'); } ;
rho         :  R_GREC   { maFormulePml.lettreGrecque('r'); } ;
varrho      :  RR_GREC  { maFormulePml.lettreGrecque('r'); } ;
sigma       :  S_GREC   { maFormulePml.lettreGrecque('s'); } ;
varsigma    :  SS_GREC  { maFormulePml.lettreGrecque('s'); } ;
tau         :  T_GREC   { maFormulePml.lettreGrecque('t'); } ;
theta       :  TT_GREC  { maFormulePml.lettreGrecque('t'); } ;
vartheta    :  TTT_GREC { maFormulePml.lettreGrecque('t'); } ;
upsilon     :  U_GREC   { maFormulePml.lettreGrecque('u'); } ;
omega       :  W_GREC   { maFormulePml.lettreGrecque('w'); } ;
xi          :  X_GREC   { maFormulePml.lettreGrecque('x'); } ;
zeta        :  Z_GREC   { maFormulePml.lettreGrecque('z'); } ;
// majuscules
caracteresGrecsMaj
   : deltaMaj | gammaMaj | thetaMaj | lambdaMaj | piMaj
   | xiMaj | sigmaMaj | upsilonMaj | phiMaj | psiMaj | omegaMaj
   ;
deltaMaj    :  DM_GREC   { maFormulePml.lettreGrecque('D'); } ;
gammaMaj    :  GM_GREC   { maFormulePml.lettreGrecque('G'); } ;
thetaMaj    :  TM_GREC   { maFormulePml.lettreGrecque('T'); } ;
lambdaMaj   :  LM_GREC   { maFormulePml.lettreGrecque('L'); } ;
piMaj       :  PM_GREC   { maFormulePml.lettreGrecque('P'); } ;
xiMaj       :  XM_GREC   { maFormulePml.lettreGrecque('X'); } ;
sigmaMaj    :  SM_GREC   { maFormulePml.lettreGrecque('S'); } ;
upsilonMaj  :  UM_GREC   { maFormulePml.lettreGrecque('U'); } ;
phiMaj      :  FM_GREC   { maFormulePml.lettreGrecque('F'); } ;
psiMaj      :  QM_GREC   { maFormulePml.lettreGrecque('Q'); } ;
omegaMaj    :  WM_GREC   { maFormulePml.lettreGrecque('W'); } ;

grecque : CARACTERE { maFormulePml.lettreGrecque($start.getText()); }	;
caracteresGrecs   :  GRECS		grecque      rAccolade   ;
//======================= maths ====================================
caracteresMathsDirects
: croix | dPartielle | ilExiste | contient
| intersectionCar | contientEns | nonIdentique
| orthogonal | leT | unionCar | pourTout | pointCentre// | similaire
| rondCentre | barreVerticale | boulette// | dbleBarreVerticale
| supOuEgal | croixRond | leGros | inclusion | equivalent
| leVide | exterieur | plusOuMoins | bigTriangleUp
| pointsCentres | pointsVerticaux | pointsBas
| pointVertical
| nabla | infTilda | semblable
| setminus | oplus 
;

caracteresMathML : appartient | different | inferieur | superieur | egal | similaire//  | lOblique
					  | infOuEgal
					  | dbleBarreVerticale  | virgule | point
					  | math1NonAscii | math2NonAscii
					  | appartientPas  | cercleRond | etoile
					  | SEPARATEUR
					  | bra | ket | approx  | propTo
					  ;
bra				:	BRA	{ maFormulePml.unicode('<'); } ;
ket				:	KET	{ maFormulePml.unicode('>'); } ;
appartient  	:  	APPARTIENT  		{ maFormulePml.unicode('\u2208'); } ;
cercleRond	:	CERCLE_ROND	{ maFormulePml.unicode('\u229A'); } ;
croix			:  	CROIX       			{ maFormulePml.unicode('\u00D7'); } ;
exterieur      	:  	EXTERIEUR     		{ maFormulePml.unicode('\u2227'); } ;

etoile			:	ETOILE				{ maFormulePml.lettreMath('\''); } ;

appartientPas	:	APPARTIENT_PAS	 { maFormulePml.lettreMath('r'); } ;
oplus	:	OPLUS	{ maFormulePml.lettreMath('+'); } ;
setminus	:	SET_MINUS { maFormulePml.caractere("\\"); } ;
different   :  DIFFERENT   { maFormulePml.lettreMath('b'); } ;
dPartielle  :  D_PARTIELLE { maFormulePml.lettreMath('d'); } ;
ilExiste    :  IL_EXISTE   { maFormulePml.lettreMath('e'); } ;
contient    :  CONTIENT    { maFormulePml.lettreMath('f'); } ;

intersectionCar :  INTERSECTION_CAR { maFormulePml.lettreMath('i'); } ;
contientEns     :  CONTIENT_ENS     { maFormulePml.lettreMath('j'); } ;
inclusion       :  INCLUSION       { maFormulePml.lettreMath('k'); } ;
nabla           :  NABLA         { maFormulePml.lettreMath('m'); } ;
nonIdentique   :  NON_IDENTIQUE { maFormulePml.lettreMath('n'); } ;
infini         :  INFINI        { maFormulePml.lettreMath('o'); } ;

orthogonal     :  ORTHOGONAL    { maFormulePml.lettreMath('s'); } ;
leT            :  LE_T          { maFormulePml.lettreMath('t'); } ;
unionCar       :  UNION_CAR     { maFormulePml.lettreMath('u'); } ;
pourTout       :  POUR_TOUT     { maFormulePml.lettreMath('v'); } ;

pointVertical  :  POINT_VERTICAL { maFormulePml.lettreMath(','); } ;
pointCentre    :  POINT_CENTRE  { maFormulePml.lettreMath(','); } ;
similaire      :  SIMILAIRE     { maFormulePml.lettreMath(';'); } ;
semblable      :  SEMBLABLE     { maFormulePml.lettreMath(';'); } ;
rondCentre     :  ROND_CENTRE   { maFormulePml.lettreMath('.'); } ;
barreVerticale :  BARRE_VERTICALE  { maFormulePml.lettreMath('!'); } ;
leVide         :  VIDE          { maFormulePml.lettreMath('0'); } ;


dbleBarreVerticale : DBARRE_VERTICALE { maFormulePml.lettreMath('5'); } ;
boulette       :  BOULETTE      { maFormulePml.lettreMath(')'); } ;

infOuEgal      :  INF_EGAL      { maFormulePml.lettreMath('<'); } ;
supOuEgal      :  SUP_EGAL      { maFormulePml.lettreMath('>'); } ;
croixRond      :  CROIX_ROND    { maFormulePml.lettreMath('*'); } ;

equivalent     :  EQUIVALENT    	{ maFormulePml.lettreMath('~'); } ;
approx			:	APPROX			{ maFormulePml.lettreMath('X'); } ;
propTo			:	PROP_TO			{ maFormulePml.lettreMath('-'); } ;
plusOuMoins    :  PLUS_MOINS    	{ maFormulePml.lettreMath('#'); } ;
bigTriangleUp  :  BIG_TRIANGLE_UP { maFormulePml.lettreMath('#'); } ;
leGros         :  LE_GROS        ;
infTilda       :  INF_TILDA      { maFormulePml.lettreMath('<'); } ;
//================== caracteresMaths1 non ASCII =====================
math1NonAscii
	:	lessim | donc | gtrsim 
	;

//lessim		:	LESSIM	 { maFormulePml.intMath(130); } ;
lessim		:	LESSIM		{ maFormulePml.unicode('\u2272'); };
donc		:	DONC		{ maFormulePml.unicode('\u2234'); };
gtrsim		:	GTRSIM	{ maFormulePml.unicode('\u2273'); };


pointsCentres    :  POINTS_CENTRES  { maFormulePml.intMath(255); } ;
pointsBas    :  POINTS_BAS  { maFormulePml.intMath(255); } ;
pointsVerticaux    :  POINTS_VERTICAUX  { maFormulePml.intMath(254); } ;

//================== caracteresMaths2 non ASCII =====================
math2NonAscii	:	nonEntraine 
				      | flecheNE| flecheNW | flecheSE | flecheSW ;

nonEntraine	:	NON_ENTRAINE  { maFormulePml.intMath2(223); } ;
flecheSE       :  FLECHE_SE      { maFormulePml.intMath2(201); } ;
flecheSW       :  FLECHE_SW      { maFormulePml.intMath2(202); } ;
flecheNE       :  FLECHE_NE      { maFormulePml.intMath2(200); } ;
flecheNW       :  FLECHE_NW      { maFormulePml.intMath2(199); } ;

//========= lettre math2 =========
caracteresMath2Directs
: flecheDroite | flecheVers | implication | equivalence
| flecheE| flecheW | imag | ell | hBarre
;
hBarre	:	H_BARRE	 { maFormulePml.intMath2(31); } ;
flecheE	:	FLECHE_E	 { maFormulePml.lettreMath2('X'); } ;
flecheW	:	FLECHE_W	 { maFormulePml.lettreMath2('Y'); } ;
flecheDroite   :  FLECHE_DROITE  { maFormulePml.lettreMath2(':'); } ;
flecheVers     :  FLECHE_VERS    { maFormulePml.lettreMath2(':'); } ;
implication    :  IMPLICATION    { maFormulePml.lettreMath2(';'); } ;
equivalence    :  EQUIVALENCE    { maFormulePml.lettreMath2('='); } ;
imag	:	IMAGINAIRE	 { maFormulePml.lettreMath2(' '); } ;
ell             :  ELL            { maFormulePml.lettreMath2('l'); } ;

carMath : CARACTERE { maFormulePml.lettreMath($start.getText()); };
caracteresMaths   :  MATHS     carMath      rAccolade   ;
carMath2 : CARACTERE { maFormulePml.lettreMath2($start.getText()); };
caracteresMath2   :  BATHS	carMath2      rAccolade   ;
//============== les mots math ==============
//lesMotsMaths	:	(inf | sup | exponentielle | limite | operator | signe | max | min)
	//		 { maFormulePml.motMath($start.getText()); } ;

lesMotsMaths	:	LES_MOTS_MATH  { maFormulePml.motMath($start.getText()); }
			 		| operator	;
/*sup	:	SUP  ;
inf		:	INF	 ;
exponentielle	:	EXPONENTIELLE ;
limite	:	LIMITE ;
signe	:	SIGNE	 ;
max	:	MAX	;
min	:	MIN	;
*/
operator	:	OPERATOR_NAME { maFormulePml.operatorName(); } 
				L_ACCOLADE caractereCompletMath+  rAccolade
				 { maFormulePml.finOperatorName(); } 
			;
label	:	LABEL	{ maFormulePml.entreeLabel(); } 
			 argumentSimple	
			{ maFormulePml.label(); } ;

lesReserves		:	accOuvrReserv | accFermReserv | pourCent | dollar | esperRes
					|	indiceRes | moinsRes | diezeRes
					;
accOuvrReserv	:	ACC_OUVRANTE_RESERVE 	{ maFormulePml.caractere("{"); } ;
accFermReserv	:	ACC_FERMANTE_RESERVE	{ maFormulePml.caractere("}"); } ;
pourCent			:	POUR_CENT					{ maFormulePml.lettreAccentue('\u0025'); } ;
dollar				:	DOLLAR_RESERVE				{ maFormulePml.caractere("$"); } ;
esperRes			:	ESPER_RESERVE				{ maFormulePml.caractere("&"); } ;
indiceRes			:	INDICE_RESERVE				{ maFormulePml.caractere("_"); } ;
moinsRes			:	MOINS_RESERVE				{ maFormulePml.caractere("-"); } ;
diezeRes			:	DIEZE_RESERVE				{ maFormulePml.caractere("#"); } ;
/*=====================================			
lettreAccentue : 
		A_GRAVE         { maFormulePml.lettreAccentue('\u00E0'); }
               | A_AIGU          { maFormulePml.lettreAccentue('\u00E1'); }
               | A_CIRCONFLEXE   { maFormulePml.lettreAccentue('\u00E2'); }
               | A_TILDE         { maFormulePml.lettreAccentue('\u00E3'); }
               | A_TREMA         { maFormulePml.lettreAccentue('\u00E4'); }
               | A_ROND          { maFormulePml.lettreAccentue('\u00E5'); }

               | E_GRAVE         { maFormulePml.lettreAccentue('\u00E8'); }
               | E_AIGU          { maFormulePml.lettreAccentue('\u00E9'); }
//               | E_CIRCONFLEXE   { maFormulePml.lettreAccentue('\u00EA'); }
               | E_TREMA         { maFormulePml.lettreAccentue('\u00EB'); }

               | I_GRAVE         { maFormulePml.lettreAccentue('\u00EC'); }
               | I_AIGU          { maFormulePml.lettreAccentue('\u00ED'); }
               | I_CIRCONFLEXE  { maFormulePml.lettreAccentue('\u00EE'); }
               | I_TREMA         { maFormulePml.lettreAccentue('\u00EF'); }

               | O_GRAVE         { maFormulePml.lettreAccentue('\u00F2'); }
               | O_AIGU          { maFormulePml.lettreAccentue('\u00F3'); }
               | O_CIRCONFLEXE   { maFormulePml.lettreAccentue('\u00F4'); }
               | O_TILDE         { maFormulePml.lettreAccentue('\u00F5'); }
               | O_TREMA         { maFormulePml.lettreAccentue('\u00F6'); }

               | U_GRAVE         { maFormulePml.lettreAccentue('\u00F9'); }
               | U_AIGU          { maFormulePml.lettreAccentue('\u00FA'); }
               | U_CIRCONFLEXE   { maFormulePml.lettreAccentue('\u00FB'); }
               | U_TREMA         { maFormulePml.lettreAccentue('\u00FC'); }

               | C_CEDILLE       { maFormulePml.lettreAccentue('\u00E7'); }
               | N_TILDE         { maFormulePml.lettreAccentue('\u00F1'); }

               | AM_GRAVE         { maFormulePml.lettreAccentue('\u00C0'); }
               | AM_AIGU          { maFormulePml.lettreAccentue('\u00C1'); }
               | AM_CIRCONFLEXE   { maFormulePml.lettreAccentue('\u00C2'); }
               | AM_TILDE         { maFormulePml.lettreAccentue('\u00C3'); }
               | AM_TREMA         { maFormulePml.lettreAccentue('\u00C4'); }
               | AM_ROND          { maFormulePml.lettreAccentue('\u00C5'); }

               | EM_GRAVE         { maFormulePml.lettreAccentue('\u00C8'); }
               | EM_AIGU          { maFormulePml.lettreAccentue('\u00C9'); }
               | EM_CIRCONFLEXE   { maFormulePml.lettreAccentue('\u00CA'); }
               | EM_TREMA         { maFormulePml.lettreAccentue('\u00CB'); }

               | IM_GRAVE         { maFormulePml.lettreAccentue('\u00CC'); }
               | IM_AIGU          { maFormulePml.lettreAccentue('\u00CD'); }
               | IM_CIRCONFLEXE   { maFormulePml.lettreAccentue('\u00CE'); }
               | IM_TREMA         { maFormulePml.lettreAccentue('\u00CF'); }

               | OM_GRAVE         { maFormulePml.lettreAccentue('\u00D2'); }
               | OM_AIGU          { maFormulePml.lettreAccentue('\u00D3'); }
               | OM_CIRCONFLEXE   { maFormulePml.lettreAccentue('\u00D4'); }
               | OM_TILDE         { maFormulePml.lettreAccentue('\u00D5'); }
               | OM_TREMA         { maFormulePml.lettreAccentue('\u00D6'); }

               | UM_GRAVE         { maFormulePml.lettreAccentue('\u00D9'); }
               | UM_AIGU          { maFormulePml.lettreAccentue('\u00DA'); }
               | UM_CIRCONFLEXE   { maFormulePml.lettreAccentue('\u00DB'); }
               | UM_TREMA         { maFormulePml.lettreAccentue('\u00DC'); }
               | CM_CEDILLE       { maFormulePml.lettreAccentue('\u00C7'); }
               | NM_TILDE         { maFormulePml.lettreAccentue('\u00D1'); }
                           ;
*/
// ================ accents ================

caractereAccentues	:	caractere | detrompeur ;

iSansPoint	:	( I_SANS_POINT
				|	(L_ACCOLADE I_SANS_POINT R_ACCOLADE)
				)	 { maFormulePml.iSansPoint(); } ;

accent	:	accentGrave | accentAigu | trema | accentCirc | accentTilde 
		| accentRond | cmCedille | cCedille
		;
accentGrave	:		ACCENT_GRAVE	 { maFormulePml.ecritCourante(); }	
			 			(	caractereAccentues
			 			|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
						)	 { maFormulePml.accentGrave(); } ;
accentAigu :		ACCENT_AIGU	 { maFormulePml.ecritCourante(); }	
			 		(	caractereAccentues
			 		|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
					)	 { maFormulePml.accentAigu(); } ;
trema	:		TREMA	 { maFormulePml.ecritCourante(); }	
			 	(	caractereAccentues
			 	|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
				)	{ maFormulePml.accentTrema(); } ;
accentCirc	:		ACCENT_CIRC	 { maFormulePml.ecritCourante(); }	
			 		(	caractereAccentues
			 		|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
					)	{ maFormulePml.accentCirc(); } ;
accentTilde:		ACCENT_TILDE	 { maFormulePml.ecritCourante(); }	
			 		(	caractereAccentues
			 		|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
					)	{ maFormulePml.accentTilde(); } ;
accentRond:		ACCENT_ROND	 { maFormulePml.ecritCourante(); }	
			 		(	caractereAccentues
			 		|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
					)	 { maFormulePml.accentRond(); } ;
cmCedille		:	CM_CEDILLE		{ maFormulePml.lettreAccentue('\u00C7'); } ;
cCedille		:	C_CEDILLE  		{ maFormulePml.lettreAccentue('\u00E7'); } ;


//======================= fin du parser =======================================
//======================= fin du parser =======================================

//======================= Debut du Lexer =======================================
//======================= Debut du Lexer =======================================

//================ polices math ============

PL_ROMAN      		:	'#mathrm{'  |  '#text{'  | '#finPf{' |  '#mbox{'  
						| 	'#mbox{ #blancForce#rm'  ;
PL_ROMAN_EMP      	: 	'#rm'  |  '#mbox'  ;
PL_ITALIC     			:   	'#mathit{' ;
PL_ITALIC_EMP     	:  	'#it' ;
//=== accents maths ==========

ACCENT_GRAVE_MATH         		:  '#grave'   ;
ACCENT_AIGU_MATH          		:  '#acute' ;
ACCENT_CIRCONFLEXE_MATH	:  ('#hat' | '#widehat') ;
ACCENT_TREMA_MATH         	:  '#ddot'    ;
ACCENT_TILDE_MATH         		:  '#tilde'   ;

ACCENT_POINT_DESSUS_MATH  :  '#dot'     ;
ACCENT_TCHECHE_MATH       	:  '#check'   ;
ACCENT_BARRE_DESSUS_MATH  :  '#bar'     ;
ACCENT_BREVE_MATH         		:  '#breve'   ;
ACCENT_ROND_MATH         		:  '#r'   ;
ACCENT_OGONEK_MATH     		:  '#k'   ;
ACCENT_CEDILLE_MATH     		:  '#c'   ;

//===================  accents ========================
CM_CEDILLE      	:  '#c C' ;
C_CEDILLE      	:  '#c c' | '#c\r\n'  ;

I_SANS_POINT		:	'#i '  | '#i\n' ;

ACCENT_GRAVE	:	'#`' ;
ACCENT_AIGU		:	'#\'' ;
ACCENT_CIRC		:	'#^'  ;
ACCENT_TILDE	:	'#~' ;
TREMA				:	'#H' | '#\"' ;
ACCENT_ROND	:	'#.' ;

//===================  fin accents ========================

BLANC       		:  (' ')+ ;
BLANC_FORCE 	: 	'#blancForce' ;
QUAD				:	'#quad' ;
QUAD2			:	'#qquad' ;
BLANC_NEGATIF  	:  	'#!' ;
BLANC_MINI		:	'#,' ;
BLANC_SPECIAL	:	'#;' ;

FIN_FORMULE            : '#finFormule' ;
// Whitespace -- ignored
WS :  (  '\t'
      |  '\f'
// handle newlines
      |  (  '\r\n'   // Evil DOS
      |  '\r'     // Macintosh
      |  '\n'   // Unix (the right way)
         )
      )  {skip();}
   ;

// Single-line comments
SL_COMMENT
	:	'%'
		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{skip(); }
	;
ESPACE            :  ('#espace' | '#;');
R_ACCOLADE     :  '}'         ;
L_ACCOLADE     :  '{'         ;
//==================== MathML ================
INFERIEUR      	:  '<' ;
SUPERIEUR     	:  '>' ;
L_OBLIQUE     	:  '/' ;
EGAL			:	'=' ;
BRA			:	 '#langle' ;
KET			:	 '#rangle';
//========================= mono ==========================
EXPOSANT_SIMPLE		:	'^'	;
INDICE_SIMPLE			:	'_'	;
RACINE					:	 '#sqrt'  ;
BARRE						:	'#overline' ;
PARENT_GAUCHE        	:  '#left(' | '#bigl('  | '#big('       ;  //'('
PARENT_DROITE        		:  '#right)'  | '#bigr)'   | '#big)'         ;
CROCHET_GAUCHE       	:  '#left['  | '#bigl['   | '#big['          ;  //'['
CROCHET_DROIT        	:  '#right]'   | '#bigr]'     | '#big]'        ;
ACCOLADE_OUVRANTE   	:  '#accOuvrante' ;  //'{'
OUVRANTE_FIN         		:  '#right.'        ;
FERMANTE_DEBUT       	:  '#left.'         ;
ACCOLADE_FERMANTE   	:  '#accFermante' ;
EXCES_GAUCHE         		:  '#excesGauche'   ;  //'a'
EXCES_DROIT          		:  '#excesDroit'  ;
DEFAUT_GAUCHE        	:  '#defautGauche'  ;  //'e'
DEFAUT_DROIT         		:  '#defautDroit' ;
PROD_SCAL_GAUCHE     	:  ('#prodScalGauche'  ) ;  //'G'
PROD_SCAL_DROIT      	:  ('#prodScalDroit' ) ;
NORME_GAUCHE         	:  	'#normeGauche'	; //'#left#Vert'  | '#left #Vert'   ;  //'n'
NORME_DROITE			:       '#normeDroite' 	;	// '#right#Vert' | '#right #Vert'   ;
VALEUR_ABS_GAUCHE    	:  '#valAbsGauche'    ;  //'v'
VALEUR_ABS_DROITE		:  '#valAbsDroite'   ;
//========================= duo ===========================
FRACTION         		:  '#over'          ;

VRAIE_FRACTION    	:  '#frac'  |   '#dfrac'  |   '#tfrac'  ;
GEN_FRAC				:	'#genfrac' ;
PAR_DESSUS        		:  '#buildrel' | '#stackrel' ;
PAR_DESSOUS      		:  '#buildreb' ;
BINOM					:	'#binom' ;
//========================= trio ============================
INTEGRALE		:  '#int'     ;
PROD_INFINI		:  '#prod'    ;
SOMME			: '#sum' ;
PROD_VECTORIEL	:  '#bigwedge' ;
UNION             	:  '#bigcup'  ;
INTERSECTION     :  '#bigcap'  ;
BIG_VEE			:	'#bigvee' ;

BORNE_INFERIEURE	:	'#borneInferieure' ;
BORNE_SUPERIEURE	:	'#borneSuperieure' ;
//============ grec ===========================
A_GREC   : '#alpha' ;
B_GREC   : '#beta' ;
C_GREC   : ('#chi' | '#chi\r\n' ) ;
D_GREC   : '#delta' ;
E_GREC   : '#epsilon' ;
EE_GREC  : '#varepsilon' ;
F_GREC   : '#phi' ;
FF_GREC  : '#varphi' ;
G_GREC   : '#gamma' ;
H_GREC   : '#eta' ;
I_GREC   : '#iota' ;
K_GREC   : '#kappa' ;
L_GREC   : '#lambda' ;
M_GREC   : '#mu' ;
N_GREC   : '#nu' ;
P_GREC   : '#pi' ;
Q_GREC   : '#psi' ;
R_GREC   : '#rho' ;
RR_GREC  : '#varrho' ;
S_GREC   : '#sigma' ;
SS_GREC  : '#varsigma' ;
T_GREC   : '#tau'     ;
TT_GREC  : '#theta'   ;
TTT_GREC : '#vartheta'   ;
U_GREC   : '#upsilon' ;
W_GREC   : '#omega' ;
X_GREC   : '#xi' ;
Z_GREC   : '#zeta' ;
// majuscules
GM_GREC   : '#Gamma' ;
DM_GREC   : '#Delta' ;
TM_GREC   : '#Theta' ;
LM_GREC   : '#Lambda' ;
PM_GREC   : '#Pi' ;
XM_GREC   : '#Xi' ;
SM_GREC   : '#Sigma' ;
UM_GREC   : '#Upsilon' ;
FM_GREC   : '#Phi' ;
QM_GREC   : '#Psi' ;
WM_GREC   : '#Omega' ;

GRECS         :  '#gr{'  ;
//==================== mots maths ==================
LES_MOTS_MATH	:	'#exp' | '#lim' | '#inf' | '#sup' | '#max' | '#min' | '#log'  | '#ln' 
					| 	'#sign' | '#sin' | '#cos' | '#tan'  | '#limsup'  | '#liminf' 
					;
OPERATOR_NAME	:	'#operatorname' ;

//================== caracteresMaths1 non ASCII =====================
LESSIM		:	'#lesssim' ;
DONC		:	'#therefore' ;
GTRSIM	:	'#gtrsim' ;
//================== caracteresMaths2 non ASCII =====================
NON_ENTRAINE	:	'#nRightarrow' ;

//================== caracteresMathsDirects =====================
ETOILE						:	'#ast' ;

CERCLE_ROND       		:  '#circledcirc'       ; //.
INTERSECTION_CAR  		:  '#cap'        ;  //i
UNION_CAR         		:  '#cup'        ;  //u
POINT_CENTRE      		:  '#cdot'       ; //,
ROND_CENTRE       		:  '#circ'       ; //.
APPROX						:	'#approx'	;
PROP_TO						:	'#propto'	;

OPLUS	:	'#oplus' ;
SET_MINUS	:	'#setminus' |  '#backslash' ;
APPARTIENT     :  '#in'            ;
APPARTIENT_PAS    :  '#notin'   |  '#not#in'  ;
DIFFERENT      :  '#not='  | '#neq'        ;
CROIX          :  '#times'         ;
D_PARTIELLE    :  '#partial'       ;
IL_EXISTE      :  '#exists'        ;
CONTIENT       :  '#ni'            ;
CROIX_ROND     :  '#otimes'        ;
CONTIENT_ENS      :  '#supset'     ;  //j
NON_IDENTIQUE     :  '#not#equiv' ;  //n
INFINI            :  '#infty'  |   '{#infty}'   ;  //o
ORTHOGONAL        :  '#perp'       ;  //s
LE_T              :  '#top'        ;  //t
POUR_TOUT         :  '#forall'     ; //v
POINT_VERTICAL    :  '#vdot'       ; //,
SIMILAIRE         :  '#simeq'      ; //;
SEMBLABLE         :  '#sim'      ; //;
DBARRE_VERTICALE  :  '#Vert'       ; //5
BARRE_VERTICALE   :  ('#mid' | '#vert') ; //!
BOULETTE          :  ('#bullet' | '#bull')     ; //)
INF_EGAL          :  '#le' | '#leq'             ; //<
PLUS_MOINS        :  '#pm' ;
LE_GROS           :  '#Big' ;
INCLUSION         :  '#subset'  ;
SUP_EGAL          :  '#geq'  | '#ge'  ;
EQUIVALENT        :  '#equiv' ;
VIDE              :  '#emptyset' ;
EXTERIEUR         :  '#wedge' ;
BIG_TRIANGLE_UP   :  '#bigtriangleup' ;
POINTS_CENTRES    :  '#dots' |  '#cdots' ;
POINTS_BAS      	:  '#ldots' ;
POINTS_VERTICAUX  :  '#vdots' ;
ELL               :  '#ell' ;
NABLA             :  '#nabla' ;
INF_TILDA         :  '#mathcode\'2E=\'712E#usA .' ;


VIRGULE	:	',' ;
POINT	:	'.' ;
//======== math2 =========
FLECHE_SE         	:  '#searrow' ;
FLECHE_SW         	:  '#swarrow' ;
FLECHE_NE         	:  '#nearrow' ;
FLECHE_NW         	:  '#nwarrow' ;
FLECHE_VERS       :  '#longmapsto' ;
FLECHE_DROITE	:  '#longrightarrow' | '#to' | '#mapsto' ;
IMPLICATION       	:  '#Rightarrow' | '#Longrightarrow' ;
EQUIVALENCE      	:  '#Leftrightarrow' ;
IMAGINAIRE		:	'#Im'  ;// | '#mbox{Im}'  ;
FLECHE_E         	:  '#rightarrow' ;
FLECHE_W         	:  '#leftarrow' ;
H_BARRE				:	'#hbar' ;

//=========== divers =======

//============= label ===============
LABEL	:	'#label'	;
//==================== reserves ================
ACC_OUVRANTE_RESERVE 	: '#{'  | '#vraieAccOuv' ;
ACC_FERMANTE_RESERVE 	: '#}'  | '#vraieAccFerm' ;
POUR_CENT            			: '#%' | '#pourcent' ;
DOLLAR_RESERVE				:	'#dollar' ;
ESPER_RESERVE				:	'#esperRes' ;
INDICE_RESERVE				:	'#indiceRes' ;
MOINS_RESERVE				:	'#moinsRes' ;
DIEZE_RESERVE				:	'#diezeRes' ;
//========== a virer ========
NO_NUMBER			:	'#nonumber' ;
NOTAG				:	'#notag' ;
//============= polices maths permanentes ===========

MATHS         :  '#mt{'  ;

BATHS         :  '#mt2{' ;
//============= autres polices ==============
MATHCAL	:	'#mathcal' ;
MATHBB	:	 '#mathbb' | '#Bbb' ;
MATHGOT	:	'#goth' ;

PL_GRASSE_EMP  :  '#bf' | '#emph'  | '#mathbf' ;
PL_GRASSE  :  '#bf{' | '#emph{'  | '#mathbf{' ;
PL_PENCHEE_EMP :  '#\sl' ;
PL_PENCHEE :  '#\sl{' ;

//============== matrice ==============
DEB_ARRAY				:	'#begin{array}' ;
END_ARRAY				:	'#end{array}' ;
MATRICE           	: 	'#matrix' ;
DEB_MATRICE          :  '#begin{matrix}';
FIN_MATRICE          :  '#end{matrix}' ;
DEB_SPLIT				:	'#begin{split}' ;
FIN_SPLIT				: 	'#end{split}' ;
ESPERLUETE        		:  	'&'       ;
CE_ERRE           		:  	'#cr' ; // | '##'  | '# #' ;
MATRICE_FIN_LIGNE	:	'#matriceFinLigne'  |	'#RCforce' ;
CASES					:	'#begin{cases}' ;
FIN_CASES				:	'#end{cases}' ;

FANTOME	:	'#phantom' ;
//============= divers =======================
BLACKSQUARE	:	'#blacksquare' ;
DISPLAYSTYLE   :  '#displaystyle'  ;
LE_UN				:	'#11' ;
//======== separateurs =========
SEPARATEUR	:	'#separateur' ;
BACKSLASH_VIDE	:	'#\n' ;

CARACTERE_RESERVE	:	'#'	| '$' |  '%' | '&' |'(' | ')'  | '/' | '[' | '\\' | ']'  | '^' | '_'  
						| 	'{' | '\|' | '}' ;
CARACTERE_ACCENTUE : '\u00A1'..'\u00FF' ;
CARACTERE_EXTRA	:     '\u0100' .. '\u02C7';
CARACTERE_SUIVANTS	:  '\u02C8' .. '\uFFFF';


CARACTERE 		// ordinaires !
	:	'!' | '\"' | '\'' |'*' ..  '.' | '0' ..  'Z' | '`' .. 'z' | '~' | ' '
	;

DETROMPEUR	:	 '#'	CARACTERE ;


