header {
package texToJoc;
}

class PetiteFormuleParser extends Parser;
options {
   k = 2;
}

{  FormulePml maFormulePml;
//   boolean enTriCorps = false;
}

file  : listExpressions
      ;

//=================== expression =========
listExpressions :  (instruc) ;
instruc
   :  chaineSymbolique
   ;
finFichier : EOF { maFormulePml.finFichier(); } ;
finDeFormule   :  FIN_FORMULE { maFormulePml.finDeFormule(); } ;
//=============== caracteres de base =====
blanc          :  BLANC         { maFormulePml.blanc(); } ;
blancForce     : (BLANC_FORCE | ESPACE) { maFormulePml.blancForce(); } ;
caracteresMathML : inferieur | superieur | lOblique
                 ;
inferieur   :  INFERIEUR   { maFormulePml.caracteresMathML('<'); } ;
superieur   :  SUPERIEUR   { maFormulePml.caracteresMathML('>'); } ;
lOblique    :  L_OBLIQUE   { maFormulePml.caracteresMathML('/'); } ;

caractere
   : (st : CARACTERE { maFormulePml.caractere(st.getText()); } )
   ;

chaineSymbolique
   : (caractereCompletMath | separateur)+
   ;
separateur
   : lesSymboles | blancForce | finDeFormule
   ;
caractereCompletMath
   :  caractere
   |  blanc
   | caracteresGrecs | caracteresGrecsMaj |caracteresGrecsDirects
   | caracteresMaths | caracteresMath2 | caracteresMathsDirects
   | caracteresMath2Directs
   | caracteresItaliques
   | overline
   | lesRaccourcis
   | caracteresMathML
   | changementPermanentDePolice
   | chainePureSoulignee | item
   | lesReserves
   | tailleScript
   | ressort
   | accentueMath
   | lesFaussesBbb | lesFaussesBbbDirects
//   | finFichier
   | chaineParenthesee
   | listeDeChaines
   | policeEmballees
   ;

//======================== Singletons ==============================
//=== fermeture de groupe: remettre taille normale ===
rAccolade   :  R_ACCOLADE           { maFormulePml.tailleNormale(); }
         ;
//============== chaine basique =======================
chainePureSoulignee
            :  UNDERLINE chaineParenthesee
               { maFormulePml.chainePureSoulignee(); } ;

chainePure { maFormulePml.nouvelleChaine(); }
   :  (caractereCompletMath)+
   ;
// chaineParagraphee : { maFormulePml.chaineParagraphee(); }
   //   chainePure chainePurePoliceeEmpilee ;

chainePenchee  : (PL_PENCHEE_EMP | L_PENCHEE_EMP)
                                       { maFormulePml.debChaineFormee(); }
                  chainePure rAccolade { maFormulePml.chainePenchee(); } ;
chaineGraissee :
         (PL_GRASSE_EMP | L_GRASSE_EMP)
                              { maFormulePml.debChaineFormee(); }
         chainePure rAccolade { maFormulePml.chaineGraissee(); } ;
chaineGraisseeFormee
 : (L_GRASSE_PENCHEE_EMP | PL_GRASSE_PENCHEE_EMP)
                              { maFormulePml.debChaineFormee(); }
         chainePure rAccolade rAccolade
                  { maFormulePml.chaineFormeeGraissee(); } ;
chaineFormeeGraissee
 : (L_PENCHEE_GRASSE_EMP | PL_PENCHEE_GRASSE_EMP)
                           { maFormulePml.debChaineFormee(); }
         chainePure rAccolade rAccolade
                           { maFormulePml.chaineFormeeGraissee(); } ;
listeDeChaines
 : chainePenchee | chaineGraissee
 | chaineGraisseeFormee | chaineFormeeGraissee
 ;
/*==
chainePurePoliceeEmpilee
   :  unePureOuverturePolice
      chainePure
      rAccolade        { maFormulePml.chainePurePoliceeEmpilee(); } ;
==*/
chaineParenthesee :  { maFormulePml.chaineParentheseeEntree(); }
                     L_ACCOLADE chaineSymbolique rAccolade
                     { maFormulePml.chaineParenthesee(); } ;
//============== polices =================
policeEmballees
   : unePureOuverturePolice
      chaineSymbolique  // chainePure
      rAccolade { maFormulePml.chainePurePoliceeEmpilee(); }
   ;



unePureOuverturePolice
   : (PL_ROMAN_EMP    | L_ROMAN_EMP)
         { maFormulePml.unePureOuverturePolice(Globale.ROMAN); }
   | (PL_SMALLCAP_EMP | L_SMALLCAP_EMP)
         { maFormulePml.unePureOuverturePolice(Globale.SMALLCAP); }
   | (PL_BLACKBOARD_EMP | L_BLACKBOARD_EMP)
         { maFormulePml.unePureOuverturePolice(Globale.BLACKBOARD); }
   | (PL_ITALIC_EMP  | L_ITALIC_EMP)
         { maFormulePml.unePureOuverturePolice(Globale.ITALIC); }
   | (PL_GOTHIC_EMP  | L_GOTHIC_EMP)
         { maFormulePml.unePureOuverturePolice(Globale.GOTHIC); }
   |  (PL_CALLIGRAPHIC_EMP | L_CALLIGRAPHIC_EMP)
         { maFormulePml.unePureOuverturePolice(Globale.CALLIGRAPHIC); }
//   | (PL_TYPEWRITER_EMP | L_TYPEWRITER_EMP)
  //       { maFormulePml.unePureOuverturePolice(Globale.TYPEWRITER); }
   | CYRILLIC_EMP
         { maFormulePml.unePureOuverturePolice(Globale.CYRILLIC); }
   ;
//======================= permanente ===========================
changementPermanentDePolice
   :  changementRoman | changementAutres
   ;

changementRoman
   :  roman | romanSlanted | romanBold
   | romanSlantedBold ;
roman            : ROMAN                { maFormulePml.roman(0); } ;
romanSlanted     : SLANTED_TEX          { maFormulePml.roman(1); } ;
romanBold        : BOLDFACE_TEX         { maFormulePml.roman(2); } ;
romanSlantedBold : SLANTED_BOLDFACE_TEX { maFormulePml.roman(3); } ;

changementAutres
   : blackBoard | italic | gothic | callig //| typeWriter
   | smallCap   | cyrillic
   ;
blackBoard  : BLACKBOARD         { maFormulePml.blackBoard(); } ;
italic      : ITALIC             { maFormulePml.italic(); } ;
gothic      : GOTHIC             { maFormulePml.gothic(); } ;
callig      : CALLIGRAPHIC       { maFormulePml.callig(); } ;
//typeWriter  : TYPEWRITER         { maFormulePml.typeWriter(); } ;
smallCap    : SMALLCAP           { maFormulePml.smallCap(); } ;
cyrillic    : CYRILLIC           { maFormulePml.cyrillic(); } ;
tailleScript   :  TAILLE_SCRIPT  { maFormulePml.tailleScript(); } ;
//================ divers ============
//================ grec ==============
//================ grec ==============
caracteresGrecsDirects
   : alpha | beta | chi | delta | epsilon | varepsilon | phi
   | varphi | gamma | eta | iota | kappa | lambda | mu | nu
   | omega | pi | psi | rho | varrho | sigma | tau | theta
   | vartheta | upsilon | xi | zeta
   ;
alpha       :  A_GREC   { maFormulePml.lettreGrecque('a'); } ;
beta        :  B_GREC   { maFormulePml.lettreGrecque('b'); } ;
chi         :  C_GREC   { maFormulePml.lettreGrecque('c'); } ;
delta       :  D_GREC   { maFormulePml.lettreGrecque('d'); } ;
epsilon     :  E_GREC   { maFormulePml.lettreGrecque('e'); } ;
varepsilon  :  EE_GREC  { maFormulePml.lettreGrecque('e'); } ;
phi         :  F_GREC   { maFormulePml.lettreGrecque('f'); } ;
varphi      :  FF_GREC  { maFormulePml.lettreGrecque('f'); } ;
gamma       :  G_GREC   { maFormulePml.lettreGrecque('g'); } ;
eta         :  H_GREC   { maFormulePml.lettreGrecque('h'); } ;
iota        :  I_GREC   { maFormulePml.lettreGrecque('i'); } ;
kappa       :  K_GREC   { maFormulePml.lettreGrecque('k'); } ;
lambda      :  L_GREC   { maFormulePml.lettreGrecque('l'); } ;
mu          :  M_GREC   { maFormulePml.lettreGrecque('m'); } ;
nu          :  N_GREC   { maFormulePml.lettreGrecque('n'); } ;
pi          :  P_GREC   { maFormulePml.lettreGrecque('p'); } ;
psi         :  Q_GREC   { maFormulePml.lettreGrecque('q'); } ;
rho         :  R_GREC   { maFormulePml.lettreGrecque('r'); } ;
varrho      :  RR_GREC  { maFormulePml.lettreGrecque('r'); } ;
sigma       :  S_GREC   { maFormulePml.lettreGrecque('s'); } ;
varsigma    :  SS_GREC  { maFormulePml.lettreGrecque('s'); } ;
tau         :  T_GREC   { maFormulePml.lettreGrecque('t'); } ;
theta       :  TT_GREC  { maFormulePml.lettreGrecque('t'); } ;
vartheta    :  TTT_GREC { maFormulePml.lettreGrecque('t'); } ;
upsilon     :  U_GREC   { maFormulePml.lettreGrecque('u'); } ;
omega       :  W_GREC   { maFormulePml.lettreGrecque('w'); } ;
xi          :  X_GREC   { maFormulePml.lettreGrecque('x'); } ;
zeta        :  Z_GREC   { maFormulePml.lettreGrecque('z'); } ;
// majuscules
caracteresGrecsMaj
   : deltaMaj | gammaMaj | thetaMaj | lambdaMaj | piMaj
   | xiMaj | sigmaMaj | upsilonMaj | phiMaj | psiMaj | omegaMaj
   ;
deltaMaj    :  DM_GREC   { maFormulePml.lettreGrecque('D'); } ;
gammaMaj    :  GM_GREC   { maFormulePml.lettreGrecque('G'); } ;
thetaMaj    :  TM_GREC   { maFormulePml.lettreGrecque('T'); } ;
lambdaMaj   :  LM_GREC   { maFormulePml.lettreGrecque('L'); } ;
piMaj       :  PM_GREC   { maFormulePml.lettreGrecque('P'); } ;
xiMaj       :  XM_GREC   { maFormulePml.lettreGrecque('X'); } ;
sigmaMaj    :  SM_GREC   { maFormulePml.lettreGrecque('S'); } ;
upsilonMaj  :  UM_GREC   { maFormulePml.lettreGrecque('U'); } ;
phiMaj      :  FM_GREC   { maFormulePml.lettreGrecque('F'); } ;
psiMaj      :  QM_GREC   { maFormulePml.lettreGrecque('Q'); } ;
omegaMaj    :  WM_GREC   { maFormulePml.lettreGrecque('W'); } ;

caracteresGrecs
   :  GRECS
      (st : CARACTERE { maFormulePml.lettreGrecque(st.getText()); } )
      rAccolade
   ;
//============== fausses Bbb ==================
lesFaussesBbbDirects
: aFausseBbb | bFausseBbb | cFausseBbb | dFausseBbb | eFausseBbb
| fFausseBbb | gFausseBbb | hFausseBbb | iFausseBbb | jFausseBbb
| kFausseBbb | lFausseBbb | mFausseBbb | nFausseBbb | oFausseBbb
| pFausseBbb | qFausseBbb | rFausseBbb | sFausseBbb | tFausseBbb
| uFausseBbb | vFausseBbb | wFausseBbb | xFausseBbb | yFausseBbb
| zFausseBbb | unFausseBbb
;
unFausseBbb  :  UN_BBB    { maFormulePml.lettreFausseBbb('1'); } ;
aFausseBbb  :  A_BBB    { maFormulePml.lettreFausseBbb('A'); } ;
bFausseBbb  :  B_BBB    { maFormulePml.lettreFausseBbb('B'); } ;
cFausseBbb  :  C_BBB    { maFormulePml.lettreFausseBbb('C'); } ;
dFausseBbb  :  D_BBB    { maFormulePml.lettreFausseBbb('D'); } ;
eFausseBbb  :  E_BBB    { maFormulePml.lettreFausseBbb('E'); } ;
fFausseBbb  :  F_BBB    { maFormulePml.lettreFausseBbb('F'); } ;
gFausseBbb  :  G_BBB    { maFormulePml.lettreFausseBbb('G'); } ;
hFausseBbb  :  H_BBB    { maFormulePml.lettreFausseBbb('H'); } ;
iFausseBbb  :  I_BBB    { maFormulePml.lettreFausseBbb('I'); } ;
jFausseBbb  :  J_BBB    { maFormulePml.lettreFausseBbb('J'); } ;
kFausseBbb  :  K_BBB    { maFormulePml.lettreFausseBbb('K'); } ;
lFausseBbb  :  L_BBB    { maFormulePml.lettreFausseBbb('L'); } ;
mFausseBbb  :  M_BBB    { maFormulePml.lettreFausseBbb('M'); } ;
nFausseBbb  :  N_BBB    { maFormulePml.lettreFausseBbb('N'); } ;
oFausseBbb  :  O_BBB    { maFormulePml.lettreFausseBbb('O'); } ;
pFausseBbb  :  P_BBB    { maFormulePml.lettreFausseBbb('P'); } ;
qFausseBbb  :  Q_BBB    { maFormulePml.lettreFausseBbb('Q'); } ;
rFausseBbb  :  R_BBB    { maFormulePml.lettreFausseBbb('R'); } ;
sFausseBbb  :  S_BBB    { maFormulePml.lettreFausseBbb('S'); } ;
tFausseBbb  :  T_BBB    { maFormulePml.lettreFausseBbb('T'); } ;
uFausseBbb  :  U_BBB    { maFormulePml.lettreFausseBbb('U'); } ;
vFausseBbb  :  V_BBB    { maFormulePml.lettreFausseBbb('V'); } ;
wFausseBbb  :  W_BBB    { maFormulePml.lettreFausseBbb('W'); } ;
xFausseBbb  :  X_BBB    { maFormulePml.lettreFausseBbb('X'); } ;
yFausseBbb  :  Y_BBB    { maFormulePml.lettreFausseBbb('Y'); } ;
zFausseBbb  :  Z_BBB    { maFormulePml.lettreFausseBbb('Z'); } ;

lesFaussesBbb
   :  BBB
      (st : CARACTERE { maFormulePml.lettreFausseBbb(st.getText()); } )
      rAccolade
   ;

//==================== reserves ===
lesReserves : accOuvrReserve | accFermReserve | pourcentage | leDieze
            ;
accOuvrReserve
   :  ACC_OUVRANTE_RESERVE { maFormulePml.lettreReserve('{'); } ;
accFermReserve
   :  ACC_FERMANTE_RESERVE { maFormulePml.lettreReserve('}'); } ;
pourcentage
   :  POUR_CENT { maFormulePml.lettreReserve('%'); } ;
leDieze
   :  LE_DIEZE  { maFormulePml.lettreReserve('#'); } ;
//======================= maths ====================================
caracteresMathsDirects
: appartient | different | croix | dPartielle | ilExiste | contient
| intersectionCar | contientEns | nonIdentique | infini | pasEn
| orthogonal | leT | unionCar | pourTout | pointCentre | similaire
| rondCentre | barreVerticale | dbleBarreVerticale | boulette
| infOuEgal | supOuEgal | croixRond | leGros | inclusion | equivalent
| leVide | exterieur | plusOuMoins | bigTriangleUp | troisPoints
| pointVertical
| ell | nabla | infTilda | semblable
;
appartient  :  APPARTIENT  { maFormulePml.lettreMath('a'); } ;
different   :  DIFFERENT   { maFormulePml.lettreMath('b'); } ;
croix       :  CROIX       { maFormulePml.lettreMath('c'); } ;
dPartielle  :  D_PARTIELLE { maFormulePml.lettreMath('d'); } ;
ilExiste    :  IL_EXISTE   { maFormulePml.lettreMath('e'); } ;
contient    :  CONTIENT    { maFormulePml.lettreMath('f'); } ;

intersectionCar :  INTERSECTION_CAR { maFormulePml.lettreMath('i'); } ;
contientEns     :  CONTIENT_ENS     { maFormulePml.lettreMath('j'); } ;
inclusion       :  INCLUSION       { maFormulePml.lettreMath('k'); } ;
ell             :  ELL            { maFormulePml.lettreMath('l'); } ;
nabla           :  NABLA         { maFormulePml.lettreMath('m'); } ;
nonIdentique   :  NON_IDENTIQUE { maFormulePml.lettreMath('n'); } ;
infini         :  INFINI        { maFormulePml.lettreMath('o'); } ;

pasEn          :  PAS_DEDANS    { maFormulePml.lettreMath('r'); } ;
orthogonal     :  ORTHOGONAL    { maFormulePml.lettreMath('s'); } ;
leT            :  LE_T          { maFormulePml.lettreMath('t'); } ;
unionCar       :  UNION_CAR     { maFormulePml.lettreMath('u'); } ;
pourTout       :  POUR_TOUT     { maFormulePml.lettreMath('v'); } ;
troisPoints    :  TROIS_POINTS  { maFormulePml.lettreMath('y'); } ;

pointVertical  :  POINT_VERTICAL { maFormulePml.lettreMath(','); } ;
pointCentre    :  POINT_CENTRE  { maFormulePml.lettreMath(','); } ;
similaire      :  SIMILAIRE     { maFormulePml.lettreMath(';'); } ;
semblable      :  SEMBLABLE     { maFormulePml.lettreMath(';'); } ;
rondCentre     :  ROND_CENTRE   { maFormulePml.lettreMath('.'); } ;
barreVerticale :  BARRE_VERTICALE  { maFormulePml.lettreMath('!'); } ;
leVide         :  VIDE          { maFormulePml.lettreMath('0'); } ;
exterieur      :  EXTERIEUR     { maFormulePml.lettreMath('1'); } ;
dbleBarreVerticale : DBARRE_VERTICALE { maFormulePml.lettreMath('5'); } ;
boulette       :  BOULETTE      { maFormulePml.lettreMath(')'); } ;
infOuEgal      :  INF_EGAL      { maFormulePml.lettreMath('<'); } ;
supOuEgal      :  SUP_EGAL      { maFormulePml.lettreMath('>'); } ;
croixRond      :  CROIX_ROND    { maFormulePml.lettreMath('*'); } ;
equivalent     :  EQUIVALENT    { maFormulePml.lettreMath('~'); } ;
plusOuMoins    :  PLUS_MOINS    { maFormulePml.lettreMath('#'); } ;
bigTriangleUp  :  BIG_TRIANGLE_UP { maFormulePml.lettreMath('#'); } ;
leGros         :  LE_GROS        ;
infTilda       :  INF_TILDA      { maFormulePml.lettreMath('<'); } ;
//========= lettre math2 =========
caracteresMath2Directs
: flecheDroite | flecheVers | implication | equivalence
| flecheSE| flecheSW| flecheNE| flecheNW
;
flecheSE       :  FLECHE_SE      { maFormulePml.lettreMath2('X'); } ;
flecheSW       :  FLECHE_SW      { maFormulePml.lettreMath2('X'); } ;
flecheNE       :  FLECHE_NE      { maFormulePml.lettreMath2('X'); } ;
flecheNW       :  FLECHE_NW      { maFormulePml.lettreMath2('X'); } ;
flecheDroite   :  FLECHE_DROITE  { maFormulePml.lettreMath2(':'); } ;
flecheVers     :  FLECHE_VERS    { maFormulePml.lettreMath2(':'); } ;
implication    :  IMPLICATION    { maFormulePml.lettreMath2(';'); } ;
equivalence    :  EQUIVALENCE    { maFormulePml.lettreMath2('='); } ;


caracteresMaths
   :  MATHS
      (st : CARACTERE { maFormulePml.lettreMath(st.getText()); } )
      rAccolade
   ;

caracteresMath2
   :  BATHS
      (st : CARACTERE { maFormulePml.lettreMath2(st.getText()); } )
      rAccolade
   ;

//========= lettre math italique =====
caracteresItaliques
: contreOblique
;
contreOblique  :  BACKSLASH      { maFormulePml.lettreItalique('\\'); } ;
//======================= le header ================================
//======================= references =======================================
//======================= listes ============================
item : ITEM ;
//========= separateurs ===========
ressort  :  RESSORT           { maFormulePml.ressort(); } ;
//======================== formules ==============================
//=============== base maths=======================

// basiqueMath : lesSymboles       ;
// expressionMath :  (basiqueMath)+ ;
//======== accents maths ===========
accentueMath
: accentGraveMath | accentTildeMath | accentAiguMath | accentCirconflexeMath
| accentTremaMath | accentPointMath | accentTchecheMath | accentBarreMath
| accentBreveMath
;

accentGraveMath
   :  ACCENT_GRAVE_MATH    { maFormulePml.accentueMath(); }
      caractere            { maFormulePml.accentGraveMath(); } ;
accentTildeMath : ACCENT_TILDE_MATH    { maFormulePml.accentueMath(); }
                  caractereCompletMath            { maFormulePml.accentTildeMath(); } ;
accentAiguMath :  ACCENT_AIGU_MATH     { maFormulePml.accentueMath(); }
                  caractereCompletMath { maFormulePml.accentAiguMath(); } ;
accentCirconflexeMath : ACCENT_CIRCONFLEXE_MATH { maFormulePml.accentueMath(); }
                        caractereCompletMath   { maFormulePml.accentCirconflexeMath(); } ;
accentTremaMath : ACCENT_TREMA_MATH    { maFormulePml.accentueMath(); }
                  caractereCompletMath            { maFormulePml.accentTremaMath(); } ;
accentPointMath : ACCENT_POINT_DESSUS_MATH   { maFormulePml.accentueMath(); }
                  caractereCompletMath                  { maFormulePml.accentPointMath(); } ;
accentTchecheMath : ACCENT_TCHECHE_MATH      { maFormulePml.accentueMath(); }
                    caractere            { maFormulePml.accentTchecheMath(); } ;
accentBarreMath : ACCENT_BARRE_DESSUS_MATH   { maFormulePml.accentueMath(); }
                  caractereCompletMath            { maFormulePml.accentBarreMath(); } ;
accentBreveMath : ACCENT_BREVE_MATH    { maFormulePml.accentueMath(); }
                  caractereCompletMath            { maFormulePml.accentBreveMath(); } ;
//======== fin accents maths ===========
overline :  OVERLINE                   { maFormulePml.overline(); }
            chaineParenthesee
                                       { maFormulePml.finOverline(); };
//======================== symboles ==============================
lesSymboles
   :  lesMonos | lesTrios | matrice | lesDuos
   ;
lesSymbolesSansIndice
   :  lesMonosSansIndice | lesTrios | lesDuos | matrice
   ;
lesMonosSansIndice
   :  racine | parentheses | crochets | accoladeOuvrante | accoladeFermante
   |  parExces | parDefaut | produitScalaire | norme | valeurAbsolue
//   |  normeAcc | valeurAbsolueAcc
   ;
//expressionParenthesee : L_ACCOLADE chainePure rAccolade ;
//expressionParenthesee : L_ACCOLADE chainePure rAccolade ;
//=================== duos ================
lesDuos
   :  vraieFraction | underSet | overSet //| fraction
   ;
vraieFraction
   :  VRAIE_FRACTION          { maFormulePml.fraction(); }
      caractereCompletMath           { maFormulePml.numerateur(); }
      caractereCompletMath           { maFormulePml.denominateur(); }
   ;
underSet
   :  PAR_DESSOUS             { maFormulePml.underSet(); }
      caractereCompletMath           { maFormulePml.numerateur(); }
      L_OBLIQUE
      caractereCompletMath           { maFormulePml.denominateur(); }
   ;
overSet
   :  PAR_DESSUS             { maFormulePml.overSet(); }
      caractereCompletMath           { maFormulePml.numerateur(); }
      L_OBLIQUE
      caractereCompletMath           { maFormulePml.denominateur(); }
   ;
/*
underSetAcc
   :  PAR_DESSOUS_ACC         { maFormulePml.underSet(); }
      caractereCompletMath           { maFormulePml.numerateur(); }
      L_OBLIQUE
      caractereCompletMath           { maFormulePml.denominateur(); }
      rAccolade
   ;
overSetAcc
   :  PAR_DESSUS_ACC          { maFormulePml.overSet(); }
      caractereCompletMath           { maFormulePml.numerateur(); }
      L_OBLIQUE
      caractereCompletMath           { maFormulePml.denominateur(); }
      rAccolade
   ;
*/
/*==
fraction :                          { maFormulePml.fraction(); }
            L_ACCOLADE
            caractereCompletMath { maFormulePml.numerateur(); }
            FRACTION
            caractereCompletMath { maFormulePml.denominateur(); }
            rAccolade ;
==*/
//=================== trios ===============
lesTrios
   : integrale          | somme                 | union | intersection
   | produitInfini      | produitVectoriel
//   | integraleAcc
//   | sommeAcc | unionAcc   | intersectionAcc
//   | produitInfiniAcc   | produitVectorielAcc
   ;

triCorps
:  //{ enTriCorps = true; }
   (uneborneInferieure)*
   (uneborneSuperieure)*
   (                            { maFormulePml.entreeIntegrant(); }
         caractereCompletMath    { maFormulePml.integrant(); }
   )
   {  maFormulePml.finTrio();
    //  enTriCorps = false;
   }
;

//============
integrale
:  INTEGRALE { maFormulePml.integrale(); }
   triCorps
;
/*===
integraleAcc      :  INTEGRALE_ACC { maFormulePml.integrale(); }
                     triCorps  R_ACCOLADE
                     ;
sommeAcc          :  SOMME_ACC { maFormulePml.somme(); }
                     triCorps  R_ACCOLADE ;
produitInfiniAcc  :  PROD_INFINI_ACC { maFormulePml.produitInfini(); }
                     triCorps  R_ACCOLADE ;
produitVectorielAcc :  PROD_VECTORIEL_ACC { maFormulePml.produitVectoriel(); }
                     triCorps  R_ACCOLADE ;
unionAcc          :  UNION_ACC { maFormulePml.union(); }
                     triCorps  R_ACCOLADE ;
intersectionAcc   :  INTERSECTION_ACC { maFormulePml.intersection(); }
                     triCorps  R_ACCOLADE ;
==*/
somme             :  SOMME { maFormulePml.somme(); }
                     triCorps  ;
produitInfini     :  PROD_INFINI { maFormulePml.produitInfini(); }
                     triCorps  ;
produitVectoriel  :  PROD_VECTORIEL { maFormulePml.produitVectoriel(); }
                     triCorps  ;
union             :  UNION { maFormulePml.union(); }
                     triCorps  ;
intersection      :  INTERSECTION { maFormulePml.intersection(); }
                     triCorps  ;
/*=================== matrice ================
matrice  :  MATRICE           { maFormulePml.matrice(); }
            caractereCompletMath
           (entreeMatrice)+
//            R_ACCOLADE   { maFormulePml.finMatrice(); }
//           finMatrice
         ;
         exception // for rule
         catch [RecognitionException ex] {
         reportError("voila A : " + ex.toString()); }

ligneMatrice : (entreeMatrice)*
               caractereCompletMath
               CE_ERRE { maFormulePml.finLigneMatrice(); }
             ;
entreeMatrice : (esperluete | finLigneMatrice
               exception // for alternate
               catch [RecognitionException ex] {
               reportError("voila B : " + ex.toString()); }
               )
                (caractereCompletMath
                |
                 R_ACCOLADE   { maFormulePml.finMatrice(); })
              ;
            exception
            catch [RecognitionException ex] {
            reportError("voila C : " + ex.toString());  }

//  finMatrice :  CE_ERRE R_ACCOLADE   { maFormulePml.finMatrice(); } ;
//finMatrice :  FIN_LIGNE_CR
  //             R_PAREN  { maFormulePml.finMatrice(); } ;

esperluete        :  ESPERLUETE        { maFormulePml.esperluete(); } ;
         exception // for rule
         catch [RecognitionException ex] {
         reportError("voila D : " + ex.toString()); }

finLigneMatrice   :  CE_ERRE  { maFormulePml.finLigneMatrice(); } ;
=================== MATRICE =========================*/
matrice  :  MATRICE           { maFormulePml.matrice(); }
            L_ACCOLADE
            chaineSymbolique
           (ligneMatrice)+
            R_ACCOLADE   { maFormulePml.finMatrice(); }
         ;
ligneMatrice : (entreeMatrice)*
               CE_ERRE { maFormulePml.finItemMatrice(); }
               ( { maFormulePml.finLigneMatrice(); } chaineSymbolique)?
             ;

entreeMatrice : esperluete chaineSymbolique ;
/*==
entreeMatrice :
      ((esperluete caractereCompletMath )
      |  ( CE_ERRE { maFormulePml.finItemMatrice(); }
            (( R_ACCOLADE   { maFormulePml.finMatrice(); })
         |
            ( { maFormulePml.finLigneMatrice(); } caractereCompletMath))
         )
      )
      ;
==*/
esperluete        :  ESPERLUETE        { maFormulePml.esperluete(); } ;

// finLigneMatrice   :  CE_ERRE  { maFormulePml.finLigneMatrice(); } ;
//================ tableaux ===========
tableau  :  TABLEAU L_ACCOLADE chainePure rAccolade
            finTableau
         ;
finTableau :  FIN_TABLEAU  { maFormulePml.finTableau(); } ;
esperlueteTableau :  ESPERLUETE  { maFormulePml.esperlueteTableau(); } ;
finLigneTableau   :  FIN_LIGNE_CR { maFormulePml.finLigneTableau(); } ;
//=================== raccourcis ===========
lesRaccourcis
   :  limite | vielleFraction
   ;
limite         : LIMITE {maFormulePml.ecritLimite(); } ;
vielleFraction : FRACTION {maFormulePml.ecritFraction(); } ;
//=================== monos ================
lesMonos
   :  racine | parentheses | crochets | accoladeOuvrante | accoladeFermante
   |  parExces | parDefaut | produitScalaire | norme
//   | normeAcc | valeurAbsolueAcc
   | valeurAbsolue | unExposant | unIndice
//   | exposantSimple | indiceSimple
//   | exposant
   ;
//=============
// finMono : chainePure rAccolade { maFormulePml.finMono(); } ;
corps : caractereCompletMath { maFormulePml.monoCar(); }
//         | ( chaineParenthesee { maFormulePml.finMono(); } )
      ;
corpsSimple : chaineSymbolique { maFormulePml.finMono(); } ;
//========== indice exposant ====
unExposant  : exposantSimple  | exposant ;
unIndice    : indiceSimple    | indice ;
uneborneSuperieure : borneSuperieureSimple | borneSuperieure ;
uneborneInferieure : borneInferieureSimple | borneInferieure ;
exposantSimple :
      EXPOSANT_SIMPLE   { maFormulePml.entreeExposant(); }
      caractereCompletMath { maFormulePml.exposantSimple(); }
               ;
borneSuperieureSimple :
      EXPOSANT_SIMPLE   { maFormulePml.entreeBorneSuperieure(); }
      caractereCompletMath { maFormulePml.borneSuperieure(); }
               ;
exposant : EXPOSANT  ( rAccolade
            |     ( { maFormulePml.exposant(); }
                  chaineSymbolique { maFormulePml.finMono(); }
                  rAccolade )
            )
         ;
borneSuperieure : EXPOSANT  ( rAccolade
            |     ( { maFormulePml.entreeBorneSuperieure(); }
                  chaineSymbolique { maFormulePml.borneSuperieure(); }
                  rAccolade )
          )
         ;
indiceSimple : INDICE_SIMPLE { maFormulePml.entreeIndice(); }
               caractereCompletMath {   maFormulePml.indiceSimple(); }
            ;
borneInferieureSimple : INDICE_SIMPLE { maFormulePml.entreeBorneInferieure(); }
               caractereCompletMath { maFormulePml.borneInferieure(); }
            ;
indice : INDICE   ( rAccolade
         |
                  ( {  maFormulePml.indice(); }
            chaineSymbolique { maFormulePml.finMono();  }
            rAccolade )
         )
      ;
borneInferieure : INDICE   ( rAccolade
         |
                  ( {  maFormulePml.entreeBorneInferieure(); }
            chaineSymbolique { maFormulePml.borneInferieure(); }
            rAccolade )
         )
      ;
//exposantSimple : EXPOSANT_SIMPLE { maFormulePml.entreeExposant(); }
  //               caractereCompletMath { maFormulePml.exposantSimple(); } ;
//exposant : EXPOSANT { maFormulePml.exposant(); }
  //         (caractereCompletMath)* rAccolade { maFormulePml.finMono(); } ;
//indiceSimple : INDICE_SIMPLE { maFormulePml.entreeIndice(); }
  //             caractereCompletMath { maFormulePml.indiceSimple(); } ;
//indice : INDICE { maFormulePml.indice(); }
  //         caractereCompletMath rAccolade { maFormulePml.finMono(); } ;
//========== autres monos ====
racine      :  RACINE { maFormulePml.racine(); } corps ;
parentheses :  PARENT_GAUCHE { maFormulePml.parentheses(); }
               corpsSimple PARENT_DROITE ;
crochets    :  CROCHET_GAUCHE { maFormulePml.crochets(); }
               corpsSimple CROCHET_DROIT ;
accoladeOuvrante  :  ACCOLADE_OUVRANTE { maFormulePml.accoladeOuvrante(); }
                     corpsSimple OUVRANTE_FIN ;
accoladeFermante  :  FERMANTE_DEBUT { maFormulePml.accoladeFermante(); }
                     corpsSimple ACCOLADE_FERMANTE ;
parExces          :  EXCES_GAUCHE { maFormulePml.parExces(); }
                     corpsSimple EXCES_DROIT ;
parDefaut         :  DEFAUT_GAUCHE { maFormulePml.parDefaut(); }
                     corpsSimple DEFAUT_DROIT ;
produitScalaire   :  PROD_SCAL_GAUCHE { maFormulePml.produitScalaire(); }
                     corpsSimple PROD_SCAL_DROIT ;
norme             :  NORME_GAUCHE { maFormulePml.norme(); }
                     corpsSimple NORME_DROITE ;
valeurAbsolue     :  VALEUR_ABS_GAUCHE { maFormulePml.valeurAbsolue(); }
                     corpsSimple VALEUR_ABS_DROITE ;
/*==
normeAcc          :  NORME_GAUCHE_ACC { maFormulePml.norme(); }
                     corpsSimple NORME_DROITE R_ACCOLADE ;
valeurAbsolueAcc  :  VALEUR_ABS_GAUCHE_ACC { maFormulePml.valeurAbsolue(); }
                     corpsSimple VALEUR_ABS_DROITE R_ACCOLADE ;
==*/
//========================
//========================= genres Formules =============
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================
//======================= fin du parser =======================================

class PetiteFormuleLexer extends Lexer;
options {
//   defaultErrorHandler = true;
   k = 25;
//	charVocabulary = '\3'..'\255';
}
{  boolean enPf = true;
}

/*======== mots reserves par TeX ==========
TABLEAU     :  "\\begin{tabular}" ;
FIN_TABLEAU :  "\\end{tabular}" ;

LE_BEGIN_PAR    :	"\\begin{"  ;
LE_END_PAR      :	"\\end{"    ;
================*/
R_ACCOLADE     :  "}"         ;
L_ACCOLADE     :  "{"         ;

RESSORT     :  "#hfill"   ;

/*=== caracteres particuliers =============
ITEM           :	"\\item"        ;
UNDERLINE      :  "\\underbar"
               |  "\\underline"   ;
========*/
//=== Latex ===============================


LABEL             :	("#label{" | "~#label{")  ;
REF               :	("#ref{"   | "~#ref{" )    ;
CITE              :	("#cite{"  | "~#cite{")    ;
SOURCE            :	"#bibitem{"          ;
//==================== formule ============================

PETITE_FORMULE          :  "$"   { if(enPf)
                                       enPf = false;
                                    else
                                       enPf = true;
                                 }
                        ;
FORMULE_STANDARD        :   "$$" { if(enPf)
                                       enPf = false;
                                    else
                                       enPf = true;
                                 }
                        ;
FORMULE_BEGIN      :  "#begin{equation}" {enPf = true;}
                       ;
FIN_FORMULE_BEGIN  :  "#end{equation}"   {enPf = false;}
                       ;
/*
LISTE_NUMEROTEE         :  "#begin{enumerate}"  ;
FIN_LISTE_NUMEROTEE     :  "#end{enumerate}"    ;
LISTE_ITEMISE           :  "#begin{itemize}"    ;
FIN_LISTE_ITEMISE       :  "#end{itemize}"      ;
*/
OVERLINE          :  "#overline"      ;

EXPOSANT_SIMPLE   :  "^"  ;
INDICE_SIMPLE     :  "_"  ;
EXPOSANT          :  ("^{" | "^{ ") ;
INDICE            :  "_{" ;
//========================= mono ===========================
PARENT_GAUCHE        :  "#left("         ;  //'('
PARENT_DROITE        :  "#right)"        ;
CROCHET_GAUCHE       :  "#left["         ;  //'['
CROCHET_DROIT        :  "#right]"        ;
ACCOLADE_OUVRANTE    :  "#left#lbrace"  ;  //'{'
OUVRANTE_FIN         :  "#right."        ;
FERMANTE_DEBUT       :  "#left."         ;
ACCOLADE_FERMANTE    :  "#right#rbrace" ;
EXCES_GAUCHE         :  "#left#lceil"   ;  //'a'
EXCES_DROIT          :  "#right#rceil"  ;
DEFAUT_GAUCHE        :  "#left#lfloor"  ;  //'e'
DEFAUT_DROIT         :  "#right#rfloor" ;
PROD_SCAL_GAUCHE     :  ("#left#langle"  | "#langle") ;  //'G'
PROD_SCAL_DROIT      :  ("#right#rangle" | "#rangle") ;
NORME_GAUCHE         :  "#left#Vert"    ;  //'n'
//NORME_GAUCHE_ACC     :  "{#left#Vert"    ;  //'n'
NORME_DROITE         :  "#right#Vert"   ;
RACINE               :  "#sqrt"          ;  //'r'
VALEUR_ABS_GAUCHE    :  "#left#vert"    ;  //'v'
//VALEUR_ABS_GAUCHE_ACC    :  "{#left#vert"    ;  //'v'
VALEUR_ABS_DROITE    :  "#right#vert"   ;

//========================= duo ============================
FRACTION         :  "#over"          ;

VRAIE_FRACTION    :  "#frac"    ;
PAR_DESSUS        :  "#buildrel" ;
PAR_DESSOUS       :  "#buildreb" ;
//PAR_DESSUS_ACC    :  "{#buildrel" ;
//PAR_DESSOUS_ACC   :  "{#buildreb" ;
//========================= trio ===========================

INTEGRALE         :  "#int"     ;
SOMME             :  "#sum"     ;
PROD_INFINI       :  "#prod"    ;
PROD_VECTORIEL	   :  "#bigwedge" ;
UNION             :  "#bigcup"  ;
INTERSECTION      :  "#bigcap"  ;

/*==
INTEGRALE_ACC     :  "{#int"     ;
SOMME_ACC         :  "{#sum"     ;
PROD_INFINI_ACC   :  "{#prod"    ;
PROD_VECTORIEL_ACC :  "{#bigwedge" ;
UNION_ACC         :  "{#bigcup"  ;
INTERSECTION_ACC  :  "{#bigcap"  ;
==*/
/*
LEFT              :  "#left"    ;
RIGHT             :  "#right"   ;
*/
//======= matrice ===========
//NOUV_LIGNE        : "\r\n" {newline();} ;
MATRICE           :  "#matrix" ;
/*==
MATRICE           :  ("#matrix{" | "#matrix {"| "#matrix\r\n{" {newline();}
                     | "#matrix {\r\n " {newline();}
                     | "#matrix \r\n{" {newline();}) ;
==*/
ESPERLUETE        :  "&"         ;
            exception[ESPERLUETE] // for a:A
            catch [RecognitionException ex] {
            reportError("voici" + ex.toString());
            }

//FIN_LIGNE_CR :  "#cr\r\n" {newline();} ;
//FIN_LIGNE_CR : ("#cr" | "#cr\r\n" {newline();} )     ;
//FIN_MATRICE_BIS   :  "#cr\r\n }"  {newline();} ;
//FIN_MATRICE       :  FIN_LIGNE_CR "}"  ;
//FIN_MATRICE         :   ("#cr\r\n}" {newline();} | "#cr}");
//FIN_MATRICE         :   "#cr}";
CE_ERRE           :  "#cr" ;
//================ polices permanentes ============

ROMAN          :  "#rm"   ;
BLACKBOARD     :  "#Bbb"  ;
ITALIC         :  "#it"   ;
GOTHIC         :  "#goth" ;
CALLIGRAPHIC   :  "#cal"  ;
//TYPEWRITER     :  "#tt"   ;
SMALLCAP       :  ("#sc" | "#Ptm")  ;
CYRILLIC       :  "#cyr"  ;

//============= polices maths permanentes ===========

MATHS         :  "#mt{"  ;

BATHS         :  "#mt2{" ;

GRECS         :  "#gr{"  ;

BBB           :  "#fbb{" ;

//============= attributs polices  =================
BOLDFACE_TEX   :  "#bf"      ;
SLANTED_TEX    :  "#sl"      ;
//============== tailles ===================
TAILLE_SCRIPT  :  "#scriptstyle" ;

//================ polices math ============
PL_BLACKBOARD_EMP :  "{#Bbb"    ;
L_BLACKBOARD_EMP  :  "#textbb{"
                  |  "#mathbb{"   ;
//================ polices empilees ============
PL_ROMAN_EMP      : "{#rm"      ;
L_ROMAN_EMP       :  "#textrm{"
                  |  "#mathrm{" ;
//PL_ITALIC_EMP     :  "{#it"     ;
L_ITALIC_EMP      :  "#textit{"
                  |  "#mathit{" ;
PL_GOTHIC_EMP     :	"{#goth"   ;
L_GOTHIC_EMP      :  "#mathfrak{" ;

PL_CALLIGRAPHIC_EMP  :	"{#cal"      ;
L_CALLIGRAPHIC_EMP   :	"#mathcal{"      ;

//PL_TYPEWRITER_EMP    :	"{#tt"       ;
//L_TYPEWRITER_EMP     :  "#texttt{"
  //                   |  "#mathtt{"       ;
//PL_SMALLCAP_EMP   :	"{#sc"
//	               |  "{#Ptm" ;
L_SMALLCAP_EMP    :  "#textsc{"
                  |  "#mathsc{"  ;
//CYRILLIC_EMP	   :  "{#cyr"       ;
//============= formes polices =================
PL_GRASSE_EMP  :  "{#bf"        ;
L_GRASSE_EMP   :  "#textbf{"
               |  "#mathbf{"    ;

PL_PENCHEE_EMP :  "{#sl"     ;
L_PENCHEE_EMP  :  "#textsl{"
               |  "#mathsl{" ;
L_GRASSE_PENCHEE_EMP   :  "#textbf{#textsl{"    ;
L_PENCHEE_GRASSE_EMP   :  "#textsl{#textbf{"    ;
PL_GRASSE_PENCHEE_EMP   :  "{#bf{#sl "    ;
PL_PENCHEE_GRASSE_EMP   :  "{#sl{#bf "    ;
//=================== lettres accentues ========================
LE_MOINS       :  ("#tt -" | "#tt\r\n -" {newline();}
                   | "#tt \r\n-" {newline();});
A_GRAVE        : "#`a" ;
A_AIGU         : "#\'a" ;
A_CIRCONFLEXE  : "#^a" ;
A_TILDE        : "#~a" ;
A_TREMA        : "#\"a" ;
A_ROND         : "#.a" ;

E_GRAVE        : "#`e" ;
E_AIGU         : "#\'e" ;
E_CIRCONFLEXE  : "#^e" ;
E_TREMA        : "#\"e" ;

I_GRAVE        : ("#`i" | "#`#i")   ;
I_AIGU         : ("#\'i" | "#\'#i") ;
I_CIRCONFLEXE  : ("#^i"  | "#^#i")  ;
//I_CIRCONFLEXE_PAR :  "#^#i" ;
I_TREMA        : ("#\"i" | "#\"#i") ;

O_GRAVE        : "#`o" ;
O_AIGU         : "#\'o" ;
O_CIRCONFLEXE  : "#^o" ;
O_TILDE        : "#~o" ;
O_TREMA        : "#\"o" ;

U_GRAVE        : "#`u" ;
U_AIGU         : "#\'u" ;
U_CIRCONFLEXE  : "#^u" ;
U_TREMA        : "#\"u" ;

C_CEDILLE      :  ("#c c" | "#c\r\nc" {newline();}) ;
N_TILDE        :  "#~n" ;

AM_GRAVE        : "#`A" ;
AM_AIGU         : "#\'A" ;
AM_CIRCONFLEXE  : "#^A" ;
AM_TILDE        : "#~A" ;
AM_TREMA        : "#\"A" ;
AM_ROND         : "#.A" ;

EM_GRAVE        : "#`E" ;
EM_AIGU         : "#\'E" ;
EM_CIRCONFLEXE  : "#^E" ;
EM_TREMA        : "#\"E" ;

IM_GRAVE        : "#`I" ;
IM_AIGU         : "#\'I" ;
IM_CIRCONFLEXE  : "#^I" ;
IM_TREMA        : "#\"I" ;

OM_GRAVE        : "#`O" ;
OM_AIGU         : "#\'O" ;
OM_CIRCONFLEXE  : "#^O" ;
OM_TILDE        : "#~O" ;
OM_TREMA        : "#\"O" ;

UM_GRAVE        : "#`U" ;
UM_AIGU         : "#\'U" ;
UM_CIRCONFLEXE  : "#^U" ;
UM_TREMA        : "#\"U" ;

CM_CEDILLE      :  "#c C" ;
NM_TILDE        :  "#~N" ;
//===================  fin lettres accentues ========================

ACCENT_GRAVE         :  "#`"    ;
ACCENT_AIGU          :  "#\'"   ;
ACCENT_CIRCONFLEXE   :  "#^"    ;
ACCENT_TREMA         :  "#\""   ;
ACCENT_TILDE         :  "#~"    ;
ACCENT_CEDILLE       :  "#c"   ;
ACCENT_POINT_DESSUS  :  "#."    ;
ACCENT_POINT_DESSOUS :  "#d"   ;
ACCENT_UMLAUT        :  "#H"   ;
ACCENT_TCHECHE       :  "#v"   ;
ACCENT_BARRE_DESSUS  :  "#="    ;
ACCENT_BARRE_DESSOUS :  "#b"   ;

//=== accents maths ==========

ACCENT_GRAVE_MATH         :  "#grave"   ;
ACCENT_AIGU_MATH          :  "#acute"  ;
ACCENT_CIRCONFLEXE_MATH   :  ("#hat" | "#widehat") ;
ACCENT_TREMA_MATH         :  "#ddot"    ;
ACCENT_TILDE_MATH         :  "#tilde"   ;
ACCENT_POINT_DESSUS_MATH  :  "#dot"     ;
ACCENT_TCHECHE_MATH       :  "#check"   ;
ACCENT_BARRE_DESSUS_MATH  :  "#bar"     ;
ACCENT_BREVE_MATH         :  "#breve"   ;

//============ grec ===========================
A_GREC   : "#alpha" ;
B_GREC   : "#beta" ;
C_GREC   : ("#chi" | "#chi\r\n" {newline();} ) ;
D_GREC   : "#delta" ;
E_GREC   : "#epsilon" ;
EE_GREC  : "#varepsilon" ;
F_GREC   : "#phi" ;
FF_GREC  : "#varphi" ;
G_GREC   : "#gamma" ;
H_GREC   : "#eta" ;
I_GREC   : "#iota" ;
K_GREC   : "#kappa" ;
L_GREC   : "#lambda" ;
M_GREC   : "#mu" ;
N_GREC   : "#nu" ;
P_GREC   : "#pi" ;
Q_GREC   : "#psi" ;
R_GREC   : "#rho" ;
RR_GREC  : "#varrho" ;
S_GREC   : "#sigma" ;
SS_GREC  : "#varsigma" ;
T_GREC   : "#tau"     ;
TT_GREC  : "#theta"   ;
TTT_GREC : "#vartheta"   ;
U_GREC   : "#upsilon" ;
W_GREC   : "#omega" ;
X_GREC   : "#xi" ;
Z_GREC   : "#zeta" ;
// majuscules
GM_GREC   : "#Gamma" ;
DM_GREC   : "#Delta" ;
TM_GREC   : "#Theta" ;
LM_GREC   : "#Lambda" ;
PM_GREC   : "#Pi" ;
XM_GREC   : "#Xi" ;
SM_GREC   : "#Sigma" ;
UM_GREC   : "#Upsilon" ;
FM_GREC   : "#Phi" ;
QM_GREC   : "#Psi" ;
WM_GREC   : "#Omega" ;
//============== fausses Bbb ==================
UN_BBB   : "#11" ;
A_BBB    : "#AA" ;
B_BBB    : "#BB" ;
C_BBB    : "#CC" ;
D_BBB    : "#DD" ;
E_BBB    : "#EE" ;
F_BBB    : "#FF" ;
G_BBB    : "#GG" ;
H_BBB    : "#HH" ;
I_BBB    : "#II" ;
J_BBB    : "#JJ" ;
K_BBB    : "#KK" ;
L_BBB    : "#LL" ;
M_BBB    : "#MM" ;
N_BBB    : "#NN" ;
O_BBB    : "#OO" ;
P_BBB    : "#PP" ;
Q_BBB    : "#QQ" ;
R_BBB    : "#RR" ;
S_BBB    : "#SS" ;
T_BBB    : "#TT" ;
U_BBB    : "#UU" ;
V_BBB    : "#VV" ;
W_BBB    : "#WW" ;
X_BBB    : "#XX" ;
Y_BBB    : "#YY" ;
Z_BBB    : "#ZZ" ;
//==================== maths ==================
//EXPONENTIELLE   :  "#exp"           ;
LIMITE            :  "#lim"           ;


APPARTIENT     :  "#in"            ;
DIFFERENT      :  "#not="          ;
CROIX          :  "#times"         ;
D_PARTIELLE    :  "#partial"       ;
IL_EXISTE      :  "#exists"        ;
CONTIENT       :  "#ni"            ;
CROIX_ROND     :  "#otimes"        ;
INTERSECTION_CAR  :  "#cap"        ;  //i
CONTIENT_ENS      :  "#supset"     ;  //j
NON_IDENTIQUE     :  "#not#equiv" ;  //n
INFINI            :  "#infty"      ;  //o
PAS_DEDANS        :  "#not#in"    ;  //r
ORTHOGONAL        :  "#perp"       ;  //s
LE_T              :  "#top"        ;  //t
UNION_CAR         :  "#cup"        ;  //u
POUR_TOUT         :  "#forall"     ; //v
POINT_CENTRE      :  "#cdot"       ; //,
POINT_VERTICAL    :  "#vdot"       ; //,
SIMILAIRE         :  "#simeq"      ; //;
SEMBLABLE         :  "#sim"      ; //;
ROND_CENTRE       :  "#circ"       ; //.
BARRE_VERTICALE   :  ("#mid" | "#vert") ; //!
DBARRE_VERTICALE  :  "#Vert"       ; //5
BOULETTE          :  ("#bullet" | "#bull")     ; //)
INF_EGAL          :  "#leq"              ; //<
PLUS_MOINS        :  "#pm" ;
LE_GROS           :  "#Big" ;
INCLUSION         :  "#subset"  ;
SUP_EGAL          :  "#geq"  ;
EQUIVALENT        :  "#equiv" ;
VIDE              :  "#emptyset" ;
EXTERIEUR         :  "#wedge" ;
BIG_TRIANGLE_UP   :  "#bigtriangleup" ;
TROIS_POINTS      :  "#dots" ;
ELL               :  "#ell" ;
NABLA             :  "#nabla" ;
INF_TILDA         :  "#mathcode\"2E=\"712E#usA ." ;
//======== math2 =========
FLECHE_SE         :  "#searrow" ;
FLECHE_SW         :  "#swarrow" ;
FLECHE_NE         :  "#nearrow" ;
FLECHE_NW         :  "#nwarrow" ;
FLECHE_VERS       :  "#longmapsto" ;
FLECHE_DROITE     :  "#longrightarrow"   ;
IMPLICATION       :  "#Rightarrow" ;
EQUIVALENCE       :  "#Leftrightarrow" ;
//=========== divers =======
ESPACE            :  ("#espace" | "#;");
BACKSLASH         :  "#backslash"      ;
//EXPOS_VIDE        : ("^{}" | "^{ }" )   { _ttype = Token.SKIP; } ;
//INDI_VIDE        : "_{}"   { _ttype = Token.SKIP; } ;
//CARAC_VIDE        : ("{}" | "{ }" | "{  }")   { _ttype = CARACTERE; } ;
//==================== reserves ================
ACC_OUVRANTE_RESERVE : "#{" ;
ACC_FERMANTE_RESERVE : "#}" ;
POUR_CENT            : "#%" ;
LE_DIEZE             : "##" ;
//==================== MathML ================
INFERIEUR      :  "<" ;
SUPERIEUR      :  ">" ;
L_OBLIQUE      :  "/" ;
//========== a virer ========
BLANC_NEGATIF  :  "#!" ;
//==================== special ================
//LE_RETOUR            :  "\r\n" {newline();} ;
FIN_FORMULE            : "\\finFormule" ;
// Whitespace -- ignored
WS :  (  '\t'
      |  '\f'
// handle newlines
      |  (  "\r\n" {newline();}   // Evil DOS
      |  '\r' {newline();}     // Macintosh
      |  '\n'  {newline();}  // Unix (the right way)
         )
      )  { _ttype = Token.SKIP; }
   ;

// Single-line comments
SL_COMMENT
	:	"%"
		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{$setType(Token.SKIP); }
	;

BLANC       :  ' ' ;// { if(enPf) $setType(Token.SKIP); } ;

BLANC_FORCE : ("# " | "#," | "#\r\n" {newline();} );
DISPLAYSTYLE   :  "#displaystyle" { if(enPf) $setType(Token.SKIP); } ;

CARACTERE
: '!'
| '#'
| '\"'
| '\''..'.'
| '0'..';'
| '='
| '?'..'['
| ']'
| '`'..'z'
| '~'
;

//CARACTERE_RESERVE  :  '&' | '~'  ;
//CARACTERE_DIEZE    : '#' ;
CARACTERE_ACCENTUE : '\u00A1'..'\u00FF' ;
