grammar reduit;

options { k=2; }

@header {
package texToJoc;
}

@members{  Reducteur1 monReducteur;
  }

@lexer::header {package texToJoc;}

expr 	: grosCars*	 finFichier	;

//=============== caracteres de base =====

caract			: 	CARACTERE 				{ monReducteur.caractere($start.getText()); }	;
caracReserv	:	CARACTERE_RESERVE	 	{ monReducteur.caracReserv($start.getText()); } ;
caracExtra		:	CARACTERE_EXTRA	 	{ monReducteur.caracExtra($start.getText()); } ;
caracSuiva		:	CARACTERE_SUIVANTS	{ monReducteur.caracSuiva($start.getText()); } ;
caracAccent	:	CARACTERE_ACCENTUE	{ monReducteur.caracAccent($start.getText()); } ;
caractSimple 
	:	caract | caracSuiva   | caracReserv | caracAccent | caracExtra
	;
caractere	:	caractSimple 		 	
		 	| retourCar 
		 	| espaces
		 	 ;

retourCar	:	RETOUR_CAR	 { monReducteur.retourCar($start.getText()); }	;
detrompeur	:	DETROMPEUR { monReducteur.detrompeur($start.getText()); }	;
grosCars	:	caractere	| nouvEnvir | nouvCommandes | nouvDefs
			| 	chaineParenthesee | detrompeur
			;
espaces	:	WS { monReducteur.espaces($start.getText()); }			;
chainePure 
	:	{ monReducteur.nouvelleChaine(); }	
		(caractere | chaineParenthesee | detrompeur)+
			{ monReducteur.laChainePure($text); }	
  	;
chainePurePure 
	:	{ monReducteur.nouvelleChainePure(); }	
		(caractere | detrompeur)+
			{ monReducteur.laChainePurePure($text); }	
  	;
chaineParenthesee	:	lAccolades	{ monReducteur.nouvelleChaineParenthesee(); }	
							chainePure?
							rAccolades	{ monReducteur.recupereChaineParenthesee(); }	
						;
nouvEnvir		:	NOUV_ENVIR
					lAccolades
					chainePure
					rAccolades	{ monReducteur.recupereEnvir(); }	
				;
nouvDefs		:	NOUV_DEFINITIONS
					chainePurePure	{ monReducteur.recupereCommande1(); }	
					lAccolades
					chainePure 
					rAccolades	{ monReducteur.recupereCommande2(); }		
				;
nouvCommandes	:	NOUV_COMMANDES
						lAccolades
						(	chainePure 
						|	NOUV_COMMANDES	)
						rAccolades	{ monReducteur.recupereCommande1(); }	
						caractere*
						lAccolades
						(	 chainePure 
						|	NOUV_COMMANDES	)
						rAccolades	{ monReducteur.recupereCommande2(); }							
						;
finFichier : EOF { monReducteur.finDuDocument(); } ;
/*
mbox	:	MBOX	L_ACCOLADE	{ monReducteur.mbox(); }	
			chainePure
			R_ACCOLADE	{ monReducteur.finMbox(); }	
		;
*/
rAccolades	:	R_ACCOLADE	{ monReducteur.rAccolades(); };
lAccolades		:	L_ACCOLADE	{ monReducteur.lAccolades(); };
//======================= fin du parser =======================================
//======================= fin du parser =======================================

//======================= Debut du Lexer =======================================
//======================= Debut du Lexer =======================================
//MBOX		:	'\\mbox' ;

R_ACCOLADE	:  '}' ;
L_ACCOLADE	:  '{' ;

NOUV_ENVIR	:	'\\newenvironment';

NOUV_COMMANDES	:	'\\newcommand' | '\\renewcommand';
NOUV_DEFINITIONS	:	'\\def' ;
// Single-line comments
SL_COMMENT
	:	'%'
		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{skip();}	;
// | espaces
// Whitespace -- ignored
WS :  	(  '\t'  |  '\f'
// handle newlines
     	 	|  	(  '\r\n'  // Evil DOS
      		|  '\r'     // Macintosh
      		|  '\n'  // Unix (the right way)
         		)
      	)	//{skip();} // { _ttype = Token.SKIP; }
   		;
CARACTERE_RESERVE	:	'#'	| '$' |  '%' | '&' |'(' | ')'  | '/' | '['| ']'  | '^' | '_'  
						| 	'{' | '\|' | '}' | '\\' ;

CARACTERE_ACCENTUE : '\u00A1'..'\u00FF' ;
CARACTERE_EXTRA	:     '\u0100' .. '\u02C7';
CARACTERE_SUIVANTS	:  '\u02C8' .. '\uFFFF';

CARACTERE 		// ordinaires !
	:	'!' | '\"' | '\'' |'*' ..  '.' | '0' ..  'Z' | '`' .. 'z' | '~' | ' '
	;
RETOUR_CAR	:	 ('\\r' CARACTERE) | ('\\n'  CARACTERE) ;
						
DETROMPEUR	:	 '\\'	CARACTERE+ ;
