grammar reduit0;

options {k=2;}

@header {
package texToJoc;
}

@members{  Reducteur monReducteur;
  }

@lexer::header {package texToJoc;}

expr 	: grosCars*	 finFichier	;
/*
caractereSimple
   : CARACTERE// { monReducteur.caractere($start.getText()); }
   ;
caractereSuivants  : 	CARACTERE_SUIVANTS { monReducteur.caractereSuivants($start.getText()); } ;

detrompeurs	:	DETROMPEURS  { monReducteur.caractere($start.getText()); }
			;
caractere	:	
	caractereSimple | espaces | detrompeurs | caractereSuivants
	;
	
*///=============== caracteres de base =====

caract			: 	CARACTERE 				{ monReducteur.caractere($start.getText()); }	;
caracReserv	:	CARACTERE_RESERVE	 	{ monReducteur.caracReserv($start.getText()); } ;
caracExtra		:	CARACTERE_EXTRA	 	{ monReducteur.caracExtra($start.getText()); } ;
caracSuiva		:	CARACTERE_SUIVANTS	{ monReducteur.caracSuiva($start.getText()); } ;
caracAccent	:	CARACTERE_ACCENTUE	{ monReducteur.caracAccent($start.getText()); } ;

caractere	:	caract | caracReserv | caracExtra | caracSuiva | caracAccent
			| detrompeur	;
detrompeur	:	DETROMPEUR	 { monReducteur.detrompeur0($start.getText()); }	;
	
grosCars	:	caractere	| nouvEnvir | nouvCommandes 
			| chaineParenthesee	| chaineCrochettee
			;
//espaces	:	WS { monReducteur.espaces($start.getText()); } ;
chainePure 
	:	{ monReducteur.nouvelleChaine(); }	
	(caractere)+	{ monReducteur.laChainePure($text); }	
   ;
 chaineParenthesee	:	L_ACCOLADE	{ monReducteur.nouvelleChaineParenthesee(); }	
					(caractere 		|	chaineParenthesee | chaineCrochettee)*
					R_ACCOLADE	{ monReducteur.recupereChaineParenthesee(); }	
				;

chaineCrochettee	:	'['	{ monReducteur.nouvelleChaineCrochettee(); }	
					 	(caractere | chaineParenthesee)*
						']'	{ monReducteur.chaineCrochettee(); }	
					;

//chaineComposee	:	chainePure	chaineParenthesee*				;
nouvEnvir	:	NOUV_ENVIR
			L_ACCOLADE
			chainePure
			R_ACCOLADE	{ monReducteur.recupereEnvir(); }	
		;
nouvCommandes	:	NOUV_COMMANDES
						L_ACCOLADE
						chainePure
						R_ACCOLADE	{ monReducteur.recupereCommande1(); }	
						chaineCrochettee?
						L_ACCOLADE
						(	NOUV_COMMANDES { monReducteur.recupereNouvCom(); }	
						| (caractere | chaineParenthesee)* { monReducteur.recupereLaSuite(); }	
						) 
						R_ACCOLADE						 
					;
					
finFichier : EOF { monReducteur.finDuDocument(); } ;
//======================= fin du parser =======================================
//======================= fin du parser =======================================

//======================= Debut du Lexer =======================================
//======================= Debut du Lexer =======================================
R_ACCOLADE     :  '}' ;
L_ACCOLADE     :  '{' ;

NOUV_ENVIR			:	'\\newenvironment';

NOUV_COMMANDES		:	'\\newcommand'	 |	'\\renewcommand';
//DETROMPEURS	:	 '\\ne'  | '\\re'	  | '\\na' | '\\no' | '\\nu'		;	
// Single-line comments
SL_COMMENT
	:	 '%'
	
		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{skip();}	;

// Whitespace
WS :  (  '\t'
      |  '\f'
// handle newlines
      |  (  '\r\n'  // Evil DOS
      |  '\r'     // Macintosh
      |  '\n'  // Unix (the right way)
         )
      ) 	{skip();}	// { _ttype = Token.SKIP; }
   ;
//CARACTERE_SUIVANTS	:  '\u00C4' .. '\uFFFF';
//CARACTERE	:	' '..'~'	| 'é' ;

CARACTERE_RESERVE	:	'#'	| '$' |  '%' | '&' |'(' | ')'  | '/' | '[' | '\\' | ']'  | '^' | '_'  
						| 	'{' | '\|' | '}' ;
CARACTERE_ACCENTUE : '\u00A1'..'\u00FF' ;
CARACTERE_EXTRA	:     '\u0100' .. '\u02C7';
CARACTERE_SUIVANTS	:  '\u02C8' .. '\uFFFF';

CARACTERE 		// ordinaires !
	:	'!' | '\"' | '\'' |'*' ..  '.' | '0' ..  'Z' | '`' .. 'z' | '~' | ' '
	;
DETROMPEUR	:	 ('\\r' CARACTERE)
				| ('\\n'  CARACTERE) ;
