grammar reduit2 ;
//options {filter=true;}

options { k=2;}

@header {
package texToJoc;
}

@members{  Reducteur2 monReducteur;
  }

@lexer::header {package texToJoc;}

expr 	: grosCars*	 finFichier	;

//=============== caracteres de base =====

caract		: 	CARACTERE 			{ monReducteur.caractere($start.getText()); }	;
caracReserv	:	CARACTERE_RESERVE	{ monReducteur.caracReserv($start.getText()); } ;
caracExtra		:	CARACTERE_EXTRA	 	{ monReducteur.caracExtra($start.getText()); } ;
caracSuiva		:	CARACTERE_SUIVANTS	{ monReducteur.caracSuiva($start.getText()); } ;
caracAccentues	:	CARACTERE_ACCENTUE	{ monReducteur.caracAccentues($start.getText()); } ;
caractereSimple	:	caract | caracReserv | caracExtra | caracSuiva  | caracAccentues ;
caractere	:	caractereSimple
			| espaces | rAccolade | lAccolade
			| lesRemplaces  | detrompeur
			;
detrompeur	:	DETROMPEUR	{ monReducteur.detrompeur($start.getText()); }	;

//=============== fin caracteres de base =====

grosCars	:	caractere | mbox | exposant | indice // | lesFormules
			| finLigne  //| cas | finCas
		;
espaces	:	retourChariot | blanc ;
retourChariot		:	WS 		{ monReducteur.espaces($start.getText()); } ;
blanc				:	BLANC 	{ monReducteur.blanc(); } ;

chaineAccoladee
	: 	lAccolade 	{ monReducteur.entreeAccoladee(); }
		(	caractereSimple
			| espaces
			| indice | exposant
			| chaineAccoladee
			| detrompeur
		)+
	 	rAccolade	{ monReducteur.chaineAccoladee($text); }
   ;

finFichier : (EOF | FIN_DOC) { monReducteur.finDuDocument(); } ;
//=================== les Formules ===========
lesSymboles	: indice | exposant | lesRemplaces
				;
formule0 	:	DOLLAR { monReducteur.form0(); } ;

finLigne	:	FIN_LIGNE  { monReducteur.finLigne(); } ;

lAccolade		:	'{'  { monReducteur.lAccolade(); } ;
rAccolade		:	'}'  { monReducteur.rAccolade(); } ;

mbox	:	MBOX  { monReducteur.mbox(); }
			(caractereSimple
			| formule0
			| lesSymboles
			| detrompeur
		 	| espaces
			| chaineAccoladee )+
			'}'  { monReducteur.finMbox(); } ;
indice				:	INDICE					{ monReducteur.indice(); }
						(caractereSimple  | detrompeur | espaces
						| chaineAccoladee)	{ monReducteur.finIndice(); }
					;
exposant			:	EXPOSANT				{ monReducteur.exposant(); }
						(caractereSimple  | detrompeur | espaces
						| chaineAccoladee)	{ monReducteur.finExposant(); }
					;
lesRemplaces
	: display | esperluette | valAbsGau | valAbsDroi | normeGauche | normeDroite
	| accOuvr | accFerm | prodScalGauche | prodScalDroit
	| right | left | barreVerticale | dBarreVerticale
	| excesGauche | excesDroit | defautGauche | defautDroit
	| vraieFerm | vraieOuv //| accDieze//	| indice | exposant
	| integrale | produitInfini | somme | produitVectoriel | union | intersection
	| grosV
	;
display		:	DISPLAY	{ monReducteur.remplace(0); } ;
esperluette	:	'&'	 { monReducteur.remplace(2); } ;
valAbsGau		:	VALEUR_ABS_GAUCHE	{ monReducteur.remplace(3); } ;
valAbsDroi	:	VALEUR_ABS_DROITE	{ monReducteur.remplace(4); } ;
normeGauche	:	NORME_GAUCHE	{ monReducteur.remplace(5); } ;
normeDroite	:	NORME_DROITE	{ monReducteur.remplace(6); } ;
accOuvr		:	ACC_OUVR 	{ monReducteur.remplace(7); } ;
accFerm		:	ACC_FERM		{ monReducteur.remplace(8); } ;
prodScalGauche	:	PROD_SCAL_GAUCHE	{ monReducteur.remplace(9); } ;
prodScalDroit		:	PROD_SCAL_DROIT	{ monReducteur.remplace(10); } ;
right				:	RIGHT	{ monReducteur.remplace(11); } ;
left					:	LEFT	{ monReducteur.remplace(12); } ;
barreVerticale		:	BARRE_VERTICALE	{ monReducteur.remplace(13); } ;
dBarreVerticale	:	DBARRE_VERTICALE	{ monReducteur.remplace(14); } ;
excesGauche		:	EXCES_GAUCHE    	{ monReducteur.remplace(15); } ;
excesDroit			:	EXCES_DROIT    		{ monReducteur.remplace(16); } ;
defautGauche		:	DEFAUT_GAUCHE    	{ monReducteur.remplace(17); } ;
defautDroit		:	DEFAUT_DROIT    		{ monReducteur.remplace(18); } ;
vraieOuv			:	ACC_OUVR_PT	{ monReducteur.remplace(19); } ;
vraieFerm			:	ACC_FERM_PT	{ monReducteur.remplace(20); } ;

integrale			:	INTEGRALE			{ monReducteur.remplace(21); } ;
produitInfini		:	PROD_INFINI	  		{ monReducteur.remplace(22); } ;
somme			:	SOMME				{ monReducteur.remplace(23); } ;
produitVectoriel	:	PROD_VECTORIEL	  	{ monReducteur.remplace(24); } ;
union				:	UNION             		{ monReducteur.remplace(25); } ;
intersection		:	INTERSECTION     		{ monReducteur.remplace(26); } ;
grosV				:	BIG_VEE				{ monReducteur.remplace(27); } ;

/*================== CASES =================
cas			:	CASES	 		{ monReducteur.lesCas(); } ;
finCas		:	FIN_CASES		{ monReducteur.finDesCas(); } ;
*/
//======================= fin du parser =======================================
//======================= fin du parser =======================================

//======================= Debut du Lexer =======================================
//======================= Debut du Lexer =======================================

VALEUR_ABS_GAUCHE    	: 	'#left|' | '#left#vert'  ;
VALEUR_ABS_DROITE    	:	'#right|'  | '#right#vert'  ;
NORME_GAUCHE    		: 	'#left#|' | '#left#Vert'  ;
NORME_DROITE    		:	'#right#|'  | '#right#Vert'  ;
ACC_OUVR    				: 	'#left#{' | '#left#lbrace' | '#left#vraieAccOuv' ;
ACC_FERM    				:	'#right#}'  | '#right#rbrace' | '#right#vraieAccFerm' ;
PROD_SCAL_GAUCHE    	: 	'#left#langle' ;
PROD_SCAL_DROIT    	:	'#right#rangle' ;
RIGHT						:	'#right' ;
LEFT						:	'#left' ;
BARRE_VERTICALE   		: 	'|' ; //!
DBARRE_VERTICALE  		:	'#|' ;
EXCES_GAUCHE    		: 	'#left#lceil' ;
EXCES_DROIT    			:	'#right#rceil' ;
DEFAUT_GAUCHE    		: 	'#left#lfloor' ;
DEFAUT_DROIT    			:	'#right#rfloor' ;
INDICE						:	'_' ;
EXPOSANT					:	'^'	;
ACC_OUVR_PT    				: 	'#lbrace';
ACC_FERM_PT    				:	'#rbrace';

//VRAIE_ACCOLADE_OUV	:	'#{' ;
//VRAIE_ACCOLADE_FERM	:	'#}' ;
//========================= trio ============================
INTEGRALE				:	'#int' ;
PROD_INFINI				:  	'#prod'    ;
SOMME					: 	'#sum' ;
PROD_VECTORIEL	   		:  	'#bigwedge' ;
UNION             			:  	'#bigcup'  ;
INTERSECTION     			:  	'#bigcap'  ;
BIG_VEE					:	'#bigvee' ;

/*================= cases ===============
CASES			:	'#begin{cases}' ;
FIN_CASES		:	'#end{cases}' ;
*/
DISPLAY					:	'#displaystyle' ;

DOLLAR	:	'#maFormule' ;
FIN_LIGNE	:	'#RCforce';
FIN_DOC	:	'#finFormule'  ;

MBOX	:	'#mbox{' | '#text{' | '#mbox{#rm' | '#text{#rm' ;

BLANC	:	' ' ;
// Single-line comments
SL_COMMENT
	:	 '%'
		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{skip();}	;
// Whitespace
WS :  (  '\t'  |  '\f'
// handle newlines
      |  (  '\r\n'  // Evil DOS
      |  '\r'     // Macintosh
      |  '\n'  // Unix (the right way)
         )
      ) //	{skip();}	// { _ttype = Token.SKIP; }
   ;

CARACTERE_RESERVE	:	'#'	| '$' |  '%' | '&' |'(' | ')'  | '/' | '[' | '\\' | ']'  | '^' | '_'
						| 	'{' | '\|' | '}' ;
CARACTERE_ACCENTUE : '\u00A1'..'\u00FF' ;
CARACTERE_EXTRA	:     '\u0100' .. '\u02C7';
CARACTERE_SUIVANTS	:  '\u02C8' .. '\uFFFF';

CARACTERE 		// ordinaires !
	:	'!' | '\"' | '\'' |'*' ..  '.' | '0' ..  'Z' | '`' .. 'z' | '~'// | ' '
	;

DETROMPEUR	:	 '#'	CARACTERE+ ;// CARACTERE CARACTERE  CARACTERE  ;

