grammar reduit2 ;

options {k=2;}

@header {
package texToJoc;
}

@members{  Reducteur2 monReducteur;
  }

@lexer::header {package texToJoc;}

expr 	: grosCars*	 finFichier	;

caractereSimple
   : CARACTERE { monReducteur.caractere($start.getText()); }
   ;
caractereSuivants  : 	CARACTERE_SUIVANTS { monReducteur.caractereSuivants($start.getText()); } ;
caractereExtras  : 	CARACTERE_EXTRA { monReducteur.caractereExtras($start.getText()); } ;
caractereAccentues  : 	CARACTERE_ACCENTUE { monReducteur.caractereAccentues($start.getText()); } ;

detrompeurs	:	DETROMPEURS
  				{ monReducteur.detrompeurs($start.getText()); }
			;
caractere	:	
	caractereSimple | espaces | detrompeurs 
	| caractereSuivants | caractereExtras | caractereAccentues
	 | finLigne  
	  | blanc
	;
grosCars	:	caractere | lesFormules | rAccolade | italic
		;
espaces	:	WS { monReducteur.caractere($start.getText()); }			;
chainePure 
	:	{ monReducteur.nouvelleChaine(); }	
	(caractere)+	{ monReducteur.laChainePure($text); }	
   ;
					
finFichier : (EOF | FIN_DOC) { monReducteur.finDuDocument(); } ;
//=================== les Formules ===========
lesFormules 
	:	   formule2 | formule0 | formule1 ;
	
dedansDeFormule :	(caractere  mbox*)+	;

formule0 	:	DOLLAR { monReducteur.debForm0(); }
				chainePure DOLLAR { monReducteur.finForm0(); } ;
formule1 	:	DDOLLAR { monReducteur.debForm1(); }
				dedansDeFormule
				 DDOLLAR	 { monReducteur.finForm1(); } ;
formule2 	:	BEG_EQUA { monReducteur.debForm2(); }
				dedansDeFormule
				END_EQUA { monReducteur.finForm2(); } ;
				
finLigne	:	FIN_LIGNE  { monReducteur.finLigne(); } ;

rAccolade	:	R_ACCOLADE	 { monReducteur.rAccolade(); } ;
mbox	:	MBOX  { monReducteur.mbox(); } 
			(caractere  formule0*)+
			rAccolade  { monReducteur.finMbox(); } ;

italic	:	ITALIC	 { monReducteur.italic(); } ;
blanc	:	BLANC { monReducteur.blanc(); } ;
//======================= fin du parser =======================================
//======================= fin du parser =======================================

//======================= Debut du Lexer =======================================
//======================= Debut du Lexer =======================================

DOLLAR	:	'$' ;
DDOLLAR	:	'$$' ;
BEG_EQUA	:	'\\begin{equation}' ;
END_EQUA	:	'\\end{equation}' ;


FIN_LIGNE	:	'#RCforce';
FIN_DOC	:	'\\finDocument'	;

MBOX	:	'\\mbox{' | '\\text{' ;

R_ACCOLADE     :  '}'         ;
//L_ACCOLADE     :  '{'         ;

BLANC	:	' ' ;
ITALIC	: '\\it' ;
// Single-line comments
SL_COMMENT
	:	 '%'
		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{skip();}	;
// Whitespace
WS :  (  '\t'
      |  '\f'
// handle newlines
      |  (  '\r\n'  // Evil DOS
      |  '\r'     // Macintosh
      |  '\n'  // Unix (the right way)
         )
      ) //	{skip();}	// { _ttype = Token.SKIP; }
   ;
CARACTERE_ACCENTUE : '\u00A1'..'\u00FF' ;
CARACTERE_EXTRA	:     '\u0100' .. '\u02C7';// '\u00C4' .. '\u02C7';
CARACTERE_SUIVANTS	:  '\u02C8' .. '\uFFFF';
CARACTERE	:  '!'..'\'' | '*'..'#' | '\''..';' | '?'..'[' | '`'..'z' | '|' | '~' 
	| '<' | '=' | '>'  | '§' | '_' | '{' | '}' | ']';
DETROMPEURS	:	 '\\' CARACTERE CARACTERE ;	
