grammar reduit;

options { k=2; }

@header {
package texToJoc;
}

@members{  Reducteur1 monReducteur;
  }

@lexer::header {package texToJoc;}

expr 	: grosCars*	 finFichier	;

//=============== caracteres de base =====

caract			: 	CARACTERE ;//				{ monReducteur.caractere($start.getText()); }	;
caracReserv	:	CARACTERE_RESERVE	 	{ monReducteur.caracReserv($start.getText()); } ;
caracExtra		:	CARACTERE_EXTRA	 	{ monReducteur.caracExtra($start.getText()); } ;
caracSuiva		:	CARACTERE_SUIVANTS	{ monReducteur.caracSuiva($start.getText()); } ;
caracAccent	:	CARACTERE_ACCENTUE	{ monReducteur.caracAccent($start.getText()); } ;
caractSimple 
	:	caract | caracSuiva   | caracReserv | caracAccent
	;
caractere	:	caractSimple 
		 	| chaineParenthesee	
		 	| detrompeur 
		 	 ;// | caracExtra ;

detrompeur	:	DETROMPEUR	 { monReducteur.detrompeur($start.getText()); }	;

grosCars	:	caractere	| nouvEnvir | nouvCommandes //| entreTruc
		 ;
//espaces	:	WS { monReducteur.caractere($start.getText()); }			;
chainePure 
	:	{ monReducteur.nouvelleChaine(); }	
	(caractere)+	{ monReducteur.laChainePure($text); }	
   ;
chaineParenthesee	:	L_ACCOLADE	{ monReducteur.nouvelleChaineParenthesee(); }	
					chainePure?
					R_ACCOLADE	{ monReducteur.recupereChaineParenthesee(); }	
				;
nouvEnvir		:	NOUV_ENVIR
				L_ACCOLADE
				chainePure
				R_ACCOLADE	{ monReducteur.recupereEnvir(); }	
			;
nouvCommandes	:	NOUV_COMMANDES
					L_ACCOLADE
					(	chainePure 
					|	NOUV_COMMANDES	)
					R_ACCOLADE	{ monReducteur.recupereCommande1(); }	
					L_ACCOLADE
					(	 chainePure 
					|	NOUV_COMMANDES	)
					R_ACCOLADE	{ monReducteur.recupereCommande2(); }							
				;
finFichier : EOF { monReducteur.finDuDocument(); } ;
//======================= fin du parser =======================================
//======================= fin du parser =======================================

//======================= Debut du Lexer =======================================
//======================= Debut du Lexer =======================================

R_ACCOLADE     :  '}' ;
L_ACCOLADE     :  '{' ;

NOUV_ENVIR			:	'\\newenvironment';

NOUV_COMMANDES		:	'\\newcommand' |	'\\renewcommand';
// Single-line comments
SL_COMMENT
	:	'%'
	
		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{skip();}	;
// | espaces
// Whitespace -- ignored
WS :  (  '\t'
      |  '\f'
// handle newlines
      |  (  '\r\n'  // Evil DOS
      |  '\r'     // Macintosh
      |  '\n'  // Unix (the right way)
         )
      )	{skip();} // { _ttype = Token.SKIP; }
   ;

CARACTERE_ACCENTUE : '\u00A1'..'\u00FF' ;
CARACTERE_EXTRA	:     '\u0100' .. '\u02C7';
CARACTERE_SUIVANTS	:  '\u02C8' .. '\uFFFF';


CARACTERE 		// ordinaires !
	:	'!' | '\"' | '\'' |'*' ..  '.' | '0' ..  'Z' | '`' .. 'z' | '~' | ' '
	;
CARACTERE_RESERVE	:	'#'	| '$' |  '%' | '&' |'(' | ')'  | '/' | '['| ']'  | '^' | '_'  
						| 	'{' | '\|' | '}' | '\\' ;
DETROMPEUR	:	 ('\\r' CARACTERE)
				| ('\\n'  CARACTERE) ;

