
grammar tex2pml;

options { k=2;}

@header {
package texToJoc;
}

@members{  GestionPml maGestionPml;
  }

@lexer::header {package texToJoc;}



//expr 	:	enTete listExpressions ;
expr 	:	debutDoc?  listExpressions;

//enTete : (debutDoc)? ;	//{ maGestionPml.premiereChaine(); } ;

debutDoc :	 DEBUT_DOCUMENT { maGestionPml.debutDoc(); } ;

listExpressions :  (instruc) ;
instruc   :  chaineParagraphee
			;
//=============== caracteres de base =====
//caracSimp		:	CARACTERE_SIMPLE	{ maGestionPml.caractere($start.getText()); }	;

caract			: 	CARACTERE 				{ maGestionPml.caractere($start.getText()); }	;
caracReserv	:	CARACTERE_RESERVE	 	{ maGestionPml.caracReserv($start.getText()); } ;
caracExtra		:	CARACTERE_EXTRA	 	{ maGestionPml.caracExtra($start.getText()); } ;
caracSuiva		:	CARACTERE_SUIVANTS	{ maGestionPml.caracSuiva($start.getText()); } ;
caracAccent	:	CARACTERE_ACCENTUE	{ maGestionPml.caracAccent($start.getText()); } ;
detrompeur 	: 	DETROMPEUR  			{ maGestionPml.detrompeur($start.getText()); } ;

//dQuote	:	DQUOTE	{ maGestionPml.dQuote(); }	;
caractereSimple	:	caract | caracReserv | caracExtra | caracSuiva | caracAccent
					| detrompeur//  | dQuote
					;
caractere	: caractereSimple  
			| accent//lettreAccentue	
			| retourChariot 
			| retourChariot2 
			| retourChariot3 
			| lesEspaces
			| esperluete
			| lesReserves
			;// | ceJour;

grosCaractere	:  caractere 
//			| chaineParenthesee 
//			| chaineCrochettee
			| chaineAccoladee
//			| chaineGraisseePar
			| chaineGraissee | chainePenchee 
			| chaineCalligraphique | chaineRoman | chaineItalique 
//			| romanGraissee
			| chaineGothique | chaineTypewriter | chainePetitemaj
			| chaineCyrillique | chaineBlackboard
			| ligneCentree
			| contexteTheoreme
			| lesSections
			| lesEnTetes
			| formule
			| citations
			| finParagraphe
			| singletons  | taillePol
			;
formule	:	 laUneFormule | laUneGrandeFormule | laUneGrandeFormuleEtoile
			;
caracteresEnjolives	:	(caractereSimple | formule)+ 
					;
suiteGenerale	:	grosCaractere* ;

//finParagraphe : LE_RETOUR_CHARIOT | FINPARAG   { maGestionPml.finParagraphe(); } ;
finParagraphe : FINPARAG   { maGestionPml.finParagraphe(); } ;
finDuDocument :	FIN_DOCUMENT { maGestionPml.finDuDocument(); } ;

chaineParagraphee : { maGestionPml.chaineParagraphee(); }
      suiteGenerale ( finFichier| finDuDocument);

//retourChariot	:	LE_RETOUR_CHARIOT		{ maGestionPml.blancRetour(); };
retourChariot	:	LE_RETOUR_CHARIOT_MAC		{ maGestionPml.blancRetourMac(); };
retourChariot2	:	LE_RETOUR_CHARIOT_WIN		{ maGestionPml.blancRetourWin(); };
retourChariot3	:	LE_RETOUR_CHARIOT_LIN		{ maGestionPml.blancRetourLin(); };
leSaut	:	LE_SAUT	{ maGestionPml.saut(); };
//========= les Espaces =============
lesEspaces
	:	blanc | blancForce | quad | quad2 | espace | blancSpecial
	;
blanc          	:  	BLANC        		{ maGestionPml.blanc(); };
blancForce     : 	BLANC_FORCE 	{ maGestionPml.blancForce(); } ;	
blancSpecial	:	BLANC_SPECIAL	{ maGestionPml.blancSpecial(); } ;	
quad			:	QUAD	 			{ maGestionPml.quad(); } ;
quad2			:	QUAD2 			{ maGestionPml.quad2(); } ;
espace 		: 	ESPACE			{ maGestionPml.blancForce(); } ;	

//============== singletons ========
singletons	:	blacksquare | item | chaineCrochettee | leSaut | dbBlackslash 
			| backSlashVide | metPageBreak  | hskip
			;
item	: ITEM { maGestionPml.singletons("item"); } 	;

//============== taille =================
taillePol 	:	tiny | scriptsize | footnotesize | small | normalsize 
			| large | large2 | large3 | huge | huge2
			;
corpsTaille	:	suiteGenerale	rAccolade  { maGestionPml.finTaille(); };

tiny			:	L_ACCOLADE TINY { maGestionPml.metTaille(Globale.TAILLE_TINY); } 
         				corpsTaille ;
scriptsize		:	L_ACCOLADE SCRIPT { maGestionPml.metTaille(Globale.TAILLE_SCRIPT); } 
         				corpsTaille;
footnotesize	:	L_ACCOLADE 
					FOOTNOTE 			{ maGestionPml.metTaille(Globale.TAILLE_FOOTNOTE); } 
         				corpsTaille;
small			:	L_ACCOLADE SMALL 	{ maGestionPml.metTailleIsol(Globale.TAILLE_SMALL); } 
					corpsTaille ;
normalsize	:	L_ACCOLADE 
					NORMALE 				{ maGestionPml.metTaille(Globale.TAILLE_NORMALE); } 
         				corpsTaille;
large			:	L_ACCOLADE LARGE  { maGestionPml.metTaille(Globale.TAILLE_LARGE); } 
					corpsTaille ;
large2			:	L_ACCOLADE LARGE2 { maGestionPml.metTaille(Globale.TAILLE_LARGE2); } 
					corpsTaille ;
large3			:	L_ACCOLADE LARGE3 { maGestionPml.metTaille(Globale.TAILLE_LARGE3); } 
					corpsTaille ;
huge			:	L_ACCOLADE HUGE 	{ maGestionPml.metTaille(Globale.TAILLE_HUGE); } 
         				corpsTaille ;
huge2			:	L_ACCOLADE HUGE2 { maGestionPml.metTaille(Globale.TAILLE_HUGE2); } 
         				corpsTaille ;
//============= fin taille ========================
metPageBreak	:	SAUT_DE_PAGE	 { maGestionPml.metPageBreak(); } ;

blacksquare	:	BLACKSQUARE  { maGestionPml.singletons("blacksquare"); } ;		

dbBlackslash	:	DB_BACKSLASH  { maGestionPml.singletons("dbBlackslash"); } ;
backSlashVide	:	BACKSLASH_VIDE { maGestionPml.singletons("backSlashVide"); } ;	

//=== accents ==
caractereAccentues	:	caractereSimple | iSansPoint ;

iSansPoint	:	( I_SANS_POINT
				|	(L_ACCOLADE I_SANS_POINT R_ACCOLADE)
				)	 { maGestionPml.iSansPoint(); } ;

accent	:	accentGrave | accentAigu | trema | accentCirc | accentTilde 
		| accentRond | cmCedille | cCedille
		;
accentGrave	:		ACCENT_GRAVE	 { maGestionPml.ecritCourante(); }	
			 			(	caractereAccentues
			 			|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
						)	 
						{ maGestionPml.accentGrave(); } ;
accentAigu :		ACCENT_AIGU	 { maGestionPml.ecritCourante(); }	
			 		(	caractereAccentues
			 		|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
					)	 
					{ maGestionPml.accentAigu(); } ;
trema	:		TREMA	 { maGestionPml.ecritCourante(); }	
			 	(	caractereAccentues
			 	|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
				)	
				 { maGestionPml.accentTrema(); } ;
accentCirc	:		ACCENT_CIRC	 { maGestionPml.ecritCourante(); }	
			 		(	caractereAccentues
			 		|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
					)	
					{ maGestionPml.accentCirc(); } ;
accentTilde:		ACCENT_TILDE	 { maGestionPml.ecritCourante(); }	
			 		(	caractereAccentues
			 		|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
					)	
					{ maGestionPml.accentTilde(); } ;
accentRond:		ACCENT_ROND	 { maGestionPml.ecritCourante(); }	
			 		(	caractereAccentues
			 		|	(L_ACCOLADE caractereAccentues R_ACCOLADE)
					)	 
					{ maGestionPml.accentRond(); } ;
cmCedille		:	CM_CEDILLE		{ maGestionPml.lettreAccentue('\u00C7'); } ;
cCedille		:	C_CEDILLE  		{ maGestionPml.lettreAccentue('\u00E7'); } ;

chainePure :	{ maGestionPml.nouvelleChaine(); }	caractere+   ;
chaineIntitule :	{ maGestionPml.chaineIntitule(); }	(caractere)+   ;
   
rAccolade   	: 	R_ACCOLADE     {  maGestionPml.tailleNormale(); }  ;   
lAccolade		:	L_ACCOLADE BLANC? ;
/*romanGraissee 	:	ROMAN_GRAS		{ maGestionPml.debRomanGraisseee(); }
         					suiteGenerale
         					R_ACCOLADE
         			 		rAccolade { maGestionPml.romanGraissee(); } 
         				;
*/         				
/*chaineGraisseePar :	PL_GRASSE_PAR	{ maGestionPml.debChaineFormee(); }
         					suiteGenerale
         					R_ACCOLADE
         			 		rAccolade { maGestionPml.chaineGraissee(); } 
         				;*/
chaineGraissee :	(	(L_ACCOLADE PL_GRASSE)
					| 	 PL_GRASSE_PAR
					)	{ maGestionPml.debChaineFormee(); }
         				suiteGenerale
         			 	rAccolade { maGestionPml.chaineGraissee(); } 
         		;
chainePenchee 	:	(PL_PENCHEE_PAR
						| 	(L_ACCOLADE PL_PENCHEE ) 
						)	{ maGestionPml.debChaineFormee(); }
						suiteGenerale
						rAccolade { maGestionPml.chainePenchee(); } 
         		;
chaineAccoladee : { maGestionPml.chaineAccoladeeEntree(); }
                     L_ACCOLADE suiteGenerale
                     rAccolade
                    { maGestionPml.chaineAccoladee(); } ;
chaineAccoladeeGenerale 	
	:	chaineAccoladee | chaineGraissee | chainePenchee
	| 	chaineRoman | chaineItalique | chaineTypewriter | chaineBlackboard
	|	chaineCalligraphique | chaineGothique | chaineCyrillique
      ;
/*chaineParenthesee : { maGestionPml.chaineParentheseeEntree(); }
                     L_PARENTHESE chainePure  R_PARENTHESE
                    { maGestionPml.chaineParenthesee(); } ;
*/
chaineAccSimple : L_ACCOLADE  suiteGenerale  R_ACCOLADE ;
chaineCroSimple :  L_CROCHET  suiteGenerale  R_CROCHET ;
                   
chaineCrochettee :	 { maGestionPml.chaineCrochetteeEntree(); }
                     L_CROCHET  suiteGenerale
  //                    chainePure 
                       R_CROCHET
                      { maGestionPml.chaineCrochettee(); } ;
                    
chaineFormee	:	chaineGraissee | chainePenchee | chainePure	;

corpsPolice	:	suiteGenerale rAccolade { maGestionPml.ecritPermanenteAutre(); } ;

chaineRoman		:	(	PL_ROMAN_PAR
						|	(L_ACCOLADE PL_ROMAN)
						)	{ maGestionPml.unePureOuverturePolice(Globale.ROMAN); }
						corpsPolice ;
chaineItalique		:	(	PL_ITALIC_PAR
						|	(L_ACCOLADE PL_ITALIC)
						)	{ maGestionPml.unePureOuverturePolice(Globale.ITALIC); }
						corpsPolice ;
chaineTypewriter		:	(	( L_ACCOLADE PL_TYPEWRITER)
							|	( PL_TYPEWRITER_PAR)
							)	{ maGestionPml.unePureOuverturePolice(Globale.TYPEWRITER); }
							corpsPolice ;
chainePetitemaj		:	(	PL_SMALLCAP_PAR
							|	(L_ACCOLADE PL_SMALLCAP)
							)	{ maGestionPml.unePureOuverturePolice(Globale.SMALLCAP); }
							corpsPolice ;
chaineBlackboard		:	(	 PL_BLACKBOARD_PAR
							|	( L_ACCOLADE PL_BLACKBOARD)
							)	{ maGestionPml.unePureOuverturePolice(Globale.BLACKBOARD); }
							corpsPolice ;
chaineCalligraphique	
 :	L_ACCOLADE	
 	PL_CALLIGRAPHIC { maGestionPml.unePureOuverturePolice(Globale.CALLIGRAPHIC); }
	corpsPolice ;
chaineGothique	
 :	L_ACCOLADE	PL_GOTHIC	{ maGestionPml.unePureOuverturePolice(Globale.GOTHIC); }
	corpsPolice ;
chaineCyrillique	
 :	L_ACCOLADE	PL_CYRILLIC	{ maGestionPml.unePureOuverturePolice(Globale.CYRILLIC); }
	corpsPolice ;
//=========================== Divers ligne ===================
/*
ligneCentree : (	(LIGNE_CENTREE  L_ACCOLADE) { maGestionPml.ligneCentree(); }
				|	(LIGNE_CENTREE  PL_GRASSE_EMP)  { maGestionPml.ligneCentreeGraissee(); }
				|	(LIGNE_CENTREE  ROMAN_GRAS)  { maGestionPml.ligneCentreeGraissee(); }
				|	(LIGNE_CENTREE  PL_GRASSE L_ACCOLADE)  { maGestionPml.ligneCentreeGraissee(); }
				)
              		 suiteGenerale
              		 rAccolade        { maGestionPml.finLigneCentree(); } 
            		 ;*/
ligneCentree	:	LIGNE_CENTREE				{ maGestionPml.ligneCentree(); }
					chaineAccoladeeGenerale    	{ maGestionPml.finLigneCentree(); } 
            		 ;       		 
//=================== divers en-tete ===================
lesEnTetes	:	titre | auteur | adresse | date | email | keywords | subjclass | maketitle
		;
titre			:	TITRE	 				{ maGestionPml.entreeTitre(); } 
			 		chaineCrochettee? 
			  		chaineAccSimple		{ maGestionPml.titre(); } ;
auteur			:	AUTEUR				{ maGestionPml.entreeHeader("auteur"); } 
					chaineAccSimple		{ maGestionPml.header("auteur"); } ;
adresse		:	ADRESSE				{ maGestionPml.entreeHeader("adresse"); } 
					chaineAccSimple		{ maGestionPml.header("adresse"); } ;
date			:	DATE					{ maGestionPml.entreeHeader("date"); } 
					chaineAccPure 		{ maGestionPml.header("date"); } ;
email			:	EMAIL					{ maGestionPml.entreeHeader("email"); } 
			 		chaineAccSimple		{ maGestionPml.header("email"); } ;
keywords		:	 KEYWORDS			{ maGestionPml.entreeHeader("keywords"); } 
					chaineAccSimple		{ maGestionPml.header("keywords"); } ;
subjclass		:	 SUBJCLASS			{ maGestionPml.entreeHeader("subjclass"); } 
					chaineAccSimple		{ maGestionPml.header("subjclass"); } ;
titreCourant	:	TITRE_COURANT	chaineAccSimple ;
maketitle		:	 MAKETITLE	;
//ceJour	:	JOURDHUI ;
//======================= sections ============================
lesSections	:	chapter | section | subsection | subsubsection
			;
chapter	:	CHAPITRE	{ maGestionPml.section("chapter"); } 
			chaineAccSimple { maGestionPml.finSections("chapter"); } ;		
section	:	PARAGRAPHE	{ maGestionPml.section("section"); } 
			chaineAccSimple { maGestionPml.finSections("section"); } ;		
subsection	:	SS_PARAGRAPHE	{ maGestionPml.section("subsection"); } 
				chaineAccSimple { maGestionPml.finSections("subsection"); } ;	
subsubsection	:	SS_SS_PARAGRAPHE	{ maGestionPml.section("subsubsection"); } 
				chaineAccSimple { maGestionPml.finSections("subsubsection"); } ;	


//======================= theoreme ==============================
chaineCroPure	:	L_CROCHET chainePure R_CROCHET
					;
chaineAccPure	:	L_ACCOLADE chainePure R_ACCOLADE
					;
begin	:	LE_BEGIN_PAR	{ maGestionPml.demarreIntitule(); } ;
end	:	LE_END_PAR { maGestionPml.finitIntitule(); } ;
intitule  	 :  begin chaineIntitule rAccolade { maGestionPml.intitule(); } ;
finIntitule  :  end chaineIntitule rAccolade { maGestionPml.finIntitule(); } ;
contexteTheoreme
 :    intitule 
      suiteGenerale
      finIntitule	;
  catch[RecognitionException ex] {
      System.err.println("Un contexteTheoreme exception: " + ex);
      maGestionPml.gereException(1);
   }

//========== les maths =======================   
laUneFormule		:	LA_UNE_FORMULE { maGestionPml.laUneFormule(); } ;
laUneGrandeFormule	:	LA_UNE_GRANDE_FORMULE  { maGestionPml.laUneGrandeFormule(); } ;
laUneGrandeFormuleEtoile	:	LA_UNE_GRANDE_FORMULE_ETOILE
									 { maGestionPml.laUneGrandeFormuleEtoile(); } ;
//============ citations ===========
citations	:	cite | eqref | ref  | label | source// | FIN_SOURCE// | biblio
		;
label	:	LABEL	 { maGestionPml.entreeCitation("label"); } 
			chaineAccSimple
			{ maGestionPml.citation("label"); } ;
cite	 :	CITE	 { maGestionPml.entreeCitation("cite"); } 
			chaineCrochettee?
			chaineAccSimple
			{ maGestionPml.citation("cite"); } ;
eqref	 :	REF_EQU { maGestionPml.entreeCitation("eqref"); } 
			chaineAccSimple
			{ maGestionPml.citation("eqref"); } ;

ref	 :	REF { maGestionPml.entreeCitation("ref"); } 
			chaineAccSimple
			{ maGestionPml.citation("ref"); } ;
source      :  	SOURCE  { maGestionPml.entreesource(); } 
				(chaineCroSimple  { maGestionPml.sourceCro(); } )?
               		chaineAccSimple  { maGestionPml.sourceAcc(); } 
               		suiteGenerale  { maGestionPml.sourceTexte(); } 
             		FIN_SOURCE  { maGestionPml.source(); } 
             	;	
             	
finFichier : EOF	;// { maGestionPml.finDuDocument(); } ;

chainePurePure 
	:	{ maGestionPml.nouvelleChaine(); }	
	(caractereSimple | blanc)+   ;

esperluete		:  ESPERLUETE        { maGestionPml.esperluete(); } ;
//============= Reserves =============
lesReserves		:	pourCent 	| accOuvrReserv | accFermReserv | dollar
					|	esperRes | indiceRes | moinsRes | diezeRes
					;

pourCent			:	POUR_CENT	{ maGestionPml.lettreAccentue('\u0025'); } ;
accOuvrReserv	:	ACC_OUVRANTE_RESERVE 	{ maGestionPml.caractere("{"); } ;
accFermReserv	:	ACC_FERMANTE_RESERVE	{ maGestionPml.caractere("}"); } ;
dollar				:	DOLLAR_RESERVE				{ maGestionPml.caractere("$"); } ;
esperRes			:	ESPER_RESERVE				{ maGestionPml.caractere("&"); } ;
indiceRes			:	INDICE_RESERVE				{ maGestionPml.caractere("_"); } ;
moinsRes			:	MOINS_RESERVE				{ maGestionPml.caractere("-"); } ;
diezeRes			:	DIEZE_RESERVE				{ maGestionPml.caractere("#"); } ;

hskip	:	L_ACCOLADE HSKIP						 { maGestionPml.hskip(); } 
			caractere+ R_ACCOLADE					 { maGestionPml.finHskip(); } ;
		
//======================= fin du parser =======================================
//======================= fin du parser =======================================

//======================= Debut du Lexer =======================================
//======================= Debut du Lexer =======================================


//CARACTERE_FORMULE	:	' '..'~'	;

BLANC       : ( ' '+)	;
BLANC_FORCE : '#blancForce' ;
QUAD	:	'\\quad' ;
QUAD2	:	'\\qquad' ;
BLANC_NEGATIF  	:  	'\\!' ;
BLANC_SPECIAL	:	'\\,' ;

//===================  accents ========================
CM_CEDILLE      :  '\\c C' |  '\\cC' ;//  |  '{\\c C}' ;
C_CEDILLE      :  '\\c c'  |  '\\cc' | '\\c\r\n'  ;//  |  '{\\c c}'    |  '{\\c\r\n}' ;

I_SANS_POINT	:	'\\i '  | '\\i\n' ; // | '{\\i}' 

ACCENT_GRAVE		:	'\\`' ;
ACCENT_AIGU			:	'\\\'' ;
ACCENT_CIRC			:	'\\^'  ;
ACCENT_TILDE		:	'\\~' ;
TREMA					:	'\\H'  | '\\\"' ;
ACCENT_ROND		:	'\\.' ;

//===================  d'hiver ========================
ESPERLUETE        :  '\\&'       ;

R_ACCOLADE     :  '}'         ;
L_ACCOLADE     :  '{'         ;
/*
R_PARENTHESE     :  ')'         ;
L_PARENTHESE     :  '('         ;
*/
R_CROCHET     :  ']'         ;
L_CROCHET     :  '['         ;

//DQUOTE	:	'\"' ;
//============= formes polices =================
PL_GRASSE  			:  	 '\\bf'   ;
PL_GRASSE_PAR  		:  	 '\\textbf{' | '\\emph{' ;	//'\\rm\\textbf' | '\\textbf' |
PL_PENCHEE		 	:  	'\\sl' ;
PL_PENCHEE_PAR	 	:  	'\\textsl{' ;
//ROMAN_GRAS		:	'{\\rm{\\textbf' ;
//============== tailles ===================
TAILLE_SCRIPT  :  '\\scriptstyle' ;

//================ polices math ============
PL_BLACKBOARD	 		:  '\\Bbb'  ;
PL_BLACKBOARD_PAR	:  '\\textbb{'   ;
//================ polices empilees ============
PL_ROMAN      			: 	'\\rm' ;
PL_ROMAN_PAR      		: 	'\\textrm{' ;
PL_ITALIC     				: 	'\\it' ;
PL_ITALIC_PAR    			:  	'\\textit{' ;
PL_GOTHIC     			:	'\\goth'   ;
PL_CALLIGRAPHIC  		:	'\\cal'      ;
PL_TYPEWRITER   			:	'\\tt'   ;
PL_TYPEWRITER_PAR		:	'\\texttt{'      ;
PL_SMALLCAP   			:	'\\sc' |  '\\Ptm'  ;
PL_SMALLCAP_PAR   		:	'\\textsc{'    ;
PL_CYRILLIC	  			:  	'\\cyr'       ;

// Divers ligne

LIGNE_CENTREE  	:  '\\centerline' 	;

FINPARAG    :	'<caRet/>';
ESPACE      :  '\\espace';

//============== formule ===============
LA_UNE_FORMULE						:	'#laUneFormule'	;
LA_UNE_GRANDE_FORMULE				:	'#laUneGrandeFormule'	;
LA_UNE_GRANDE_FORMULE_ETOILE		:	'#laUneGrandeFormuleEtoile'	;
//===============================
LE_BEGIN_PAR    :	'\\begin{'  ;
LE_END_PAR      :	'\\end{'    ;

//LE_RETOUR_CHARIOT	:	 '\r\n'  |  '\r'   | '\n'	;
LE_RETOUR_CHARIOT_MAC	:	 '\r'	;
LE_RETOUR_CHARIOT_WIN	:	 '\r\n' ;
LE_RETOUR_CHARIOT_LIN	:	 '\n'	;
LE_SAUT	:	 '\n\n' | '\\par'	;
// Whitespace -- ignored
WS :  (  '\t'
      	|  '\f'
     	 ) {skip();}// { _ttype = Token.SKIP; }
  	 ;
// Single-line comments
SL_COMMENT
	:	'%'

		(~('\n'|'\r'))* ('\n'|'\r'('\n')?)
		{skip();}	;

//========================= divers en-tete =======================
EMAIL		:	'\\email'	;
DATE		:	'\\date'	;
KEYWORDS	:	'\\keywords'	;
SUBJCLASS	:	'\\subjclass'	;
MAKETITLE	:	'\\maketitle'	;
TITRE		:	'\\title'		;
TITRE_COURANT	:	'\\titlerunning'	;
AUTEUR		:	'\\author'	;
ADRESSE		:	'\\address' ;

//JOURDHUI		:	'{\\today}'	;
//================== sections =================

CHAPITRE			:	'\\chapter' ;
PARAGRAPHE		:	'\\section' ;
SS_PARAGRAPHE	:	'\\subsection' ;
SS_SS_PARAGRAPHE	:	'\\subsubsection' ;
//============== singletons ========
ITEM	:	'\\item' ;
BLACKSQUARE	:	'\\blacksquare' ;
//DETROMPEURS	:	  '{\\'	;	

DB_BACKSLASH	:	'#RCforce' ;
BACKSLASH_VIDE	:	'\\\n' ;
//================ a virer ==============
NO_NUMBER		:	'\\noNumber' ;
NO_INDENT		:	'\\noindent' ;
HFILL				:	'\\hfill' ;
MEDSKIP			:	'\\medskip' ;
SELEC_LANGAGE	:	'\\selectlanguage' ;

HSKIP				:	'\\hskip' ;
//=========== tailles ===================
TINY				:	'\\tiny' ;			//BLANC? 
SCRIPT				:	'\\scriptsize' ;
FOOTNOTE		:	'\\footnotesize' ;
SMALL				:	'\\small' ;
NORMALE			:	'\\normalsize' ;
LARGE				:	'\\large' ;
LARGE2			:	'\\Large'	;
LARGE3			:	'\\LARGE'	;
HUGE				:	'\\huge' 	;
HUGE2				:	'\\Huge'	;

SAUT_DE_PAGE	:	'\\pagebreak' ;
//EMPHASE	:	'\\emph' ;
//============ citations ===========
LABEL			:	'\\label' ;
CITE			:	'\\cite' ;
REF_EQU		:	'\\eqref' ;
REF			:	'\\ref' ;
SOURCE          :	'\\bibitem'          ;
FIN_SOURCE	:	'\\finSource'          ;
//=============== Reserves ===============
POUR_CENT					:  	'#pourcent' ;
ACC_OUVRANTE_RESERVE 	:	'#vraieAccOuv' ;
ACC_FERMANTE_RESERVE 	: 	'#vraieAccFerm' ;
DOLLAR_RESERVE				:	'#dollar' ;
ESPER_RESERVE				:	'#esperRes' ;
INDICE_RESERVE				:	'#indiceRes' ;
MOINS_RESERVE				:	'#moinsRes' ;
DIEZE_RESERVE				:	'#diezeRes' ;

//===================================
DEBUT_DOCUMENT	:	'\\debutDocument' ;
FIN_DOCUMENT		:	'\\finDocument'	;


CARACTERE_RESERVE		:	'#'	| '$' |  '%' | '&' |'(' | ')'  | '/' | '[' | '\\' | ']'  | '^' | '_'  
							| 	'{' | '\|' | '}' ;
CARACTERE_ACCENTUE 	: '\u00A1'..'\u00FF' ;
CARACTERE_EXTRA		:     '\u0100' .. '\u02C7';
CARACTERE_SUIVANTS	:  '\u02C8' .. '\uFFFF';

//CARACTERE_SIMPLE	:	'A' .. 'Z' | 'a' .. 'z'	;

CARACTERE 		// ordinaires !
	:	'!' | '\"' | '\'' |'*' ..  '.' | '0' ..  'Z' | '`' .. 'z' | '~' | ' ' 

							;
DETROMPEUR	:	 '\\'	CARACTERE ;
	

