
grammar tex2pml;

@header {
package texToJoc;
}
@members{  GestionPml maGestionPml;
  }

@lexer::header {package texToJoc;}

expr 	:	enTete listExpressions ;

enTete : (debutDoc)? { maGestionPml.premiereChaine(); } ;

debutDoc : DEBUT_DOCUMENT { maGestionPml.debutDoc(); } ;

listExpressions :  (instruc)+ ;
instruc   :  chaineParagraphee ;
   
finParagraphe : FINPARAG   { maGestionPml.finParagraphe(); } ;

chaineParagraphee : { maGestionPml.chaineParagraphee(); }
      (chainePure | (petiteFormule)*) (finParagraphe) ;

blanc          :  BLANC         { maGestionPml.blanc(); } ;
blancForce     : (BLANC_FORCE | ESPACE) { maGestionPml.blancForce(); } ;
separateur	:	SEPARATEUR;

caractere
   : CARACTERE { maGestionPml.caractere($start.getText()); }
   ;
caractereAccentue
   : CARACTERE_ACCENTUE
               { maGestionPml.caractereAccentue($start.getText()); }
   ;
lettreAccentue : A_GRAVE         { maGestionPml.lettreAccentue('\u00E0'); }
               | A_AIGU          { maGestionPml.lettreAccentue('\u00E1'); }
               | A_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00E2'); }
               | A_TILDE         { maGestionPml.lettreAccentue('\u00E3'); }
               | A_TREMA         { maGestionPml.lettreAccentue('\u00E4'); }
               | A_ROND          { maGestionPml.lettreAccentue('\u00E5'); }

               | E_GRAVE         { maGestionPml.lettreAccentue('\u00E8'); }
               | E_AIGU          { maGestionPml.lettreAccentue('\u00E9'); }
               | E_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00EA'); }
               | E_TREMA         { maGestionPml.lettreAccentue('\u00EB'); }

               | I_GRAVE         { maGestionPml.lettreAccentue('\u00EC'); }
               | I_AIGU          { maGestionPml.lettreAccentue('\u00ED'); }
               | (I_CIRCONFLEXE |
                  I_CIRCONFLEXE_PAR) { maGestionPml.lettreAccentue('\u00EE'); }
               | I_TREMA         { maGestionPml.lettreAccentue('\u00EF'); }

               | O_GRAVE         { maGestionPml.lettreAccentue('\u00F2'); }
               | O_AIGU          { maGestionPml.lettreAccentue('\u00F3'); }
               | O_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00F4'); }
               | O_TILDE         { maGestionPml.lettreAccentue('\u00F5'); }
               | O_TREMA         { maGestionPml.lettreAccentue('\u00F6'); }

               | U_GRAVE         { maGestionPml.lettreAccentue('\u00F9'); }
               | U_AIGU          { maGestionPml.lettreAccentue('\u00FA'); }
               | U_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00FB'); }
               | U_TREMA         { maGestionPml.lettreAccentue('\u00FC'); }

               | C_CEDILLE       { maGestionPml.lettreAccentue('\u00E7'); }
               | N_TILDE         { maGestionPml.lettreAccentue('\u00F1'); }

               | AM_GRAVE         { maGestionPml.lettreAccentue('\u00C0'); }
               | AM_AIGU          { maGestionPml.lettreAccentue('\u00C1'); }
               | AM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00C2'); }
               | AM_TILDE         { maGestionPml.lettreAccentue('\u00C3'); }
               | AM_TREMA         { maGestionPml.lettreAccentue('\u00C4'); }
               | AM_ROND          { maGestionPml.lettreAccentue('\u00C5'); }

               | EM_GRAVE         { maGestionPml.lettreAccentue('\u00C8'); }
               | EM_AIGU          { maGestionPml.lettreAccentue('\u00C9'); }
               | EM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00CA'); }
               | EM_TREMA         { maGestionPml.lettreAccentue('\u00CB'); }

               | IM_GRAVE         { maGestionPml.lettreAccentue('\u00CC'); }
               | IM_AIGU          { maGestionPml.lettreAccentue('\u00CD'); }
               | IM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00CE'); }
               | IM_TREMA         { maGestionPml.lettreAccentue('\u00CF'); }

               | OM_GRAVE         { maGestionPml.lettreAccentue('\u00D2'); }
               | OM_AIGU          { maGestionPml.lettreAccentue('\u00D3'); }
               | OM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00D4'); }
               | OM_TILDE         { maGestionPml.lettreAccentue('\u00D5'); }
               | OM_TREMA         { maGestionPml.lettreAccentue('\u00D6'); }

               | UM_GRAVE         { maGestionPml.lettreAccentue('\u00D9'); }
               | UM_AIGU          { maGestionPml.lettreAccentue('\u00DA'); }
               | UM_CIRCONFLEXE   { maGestionPml.lettreAccentue('\u00DB'); }
               | UM_TREMA         { maGestionPml.lettreAccentue('\u00DC'); }

               | CM_CEDILLE       { maGestionPml.lettreAccentue('\u00C7'); }
               | NM_TILDE         { maGestionPml.lettreAccentue('\u00D1'); }
               ;

caractereComplet
   :  caractere | caractereAccentue | lettreAccentue | blanc
   | chaineParenthesee | chaineGraissee
   
   ;
   
mot 	:	 (caractereComplet)+ separateur+//(blanc | separateur)+
		//blanc
   ;
chainePure 
	:	{ maGestionPml.nouvelleChaine(); }	
	(mot)+
//     (caractereComplet)+
   ;
   
   
rAccolade   :  R_ACCOLADE           { maGestionPml.tailleNormale(); }
         ;   
   
chaineGraissee :
         PL_GRASSE_EMP  { maGestionPml.debChaineFormee(); }
         chainePure rAccolade { maGestionPml.chaineGraissee(); } 
         ;

chaineParenthesee :  { maGestionPml.chaineParentheseeEntree(); }
                     L_ACCOLADE chainePure rAccolade
                     { maGestionPml.chaineParenthesee(); } ;
                     
//========== les maths =======================   
ouvreEtFermePf	:	PETITE_FORMULE ;
caractereFormule	:	CARACTERE_FORMULE { maGestionPml.caractereAscii($start.getText()); };
petiteFormule	:	{ maGestionPml.petiteFormuleAscii(); }
	ouvreEtFermePf
   expressionMath
   ouvreEtFermePf
   ;
//caractereAscii	:	caractere |indice | exposant | blanc | blancForce | integrale   ;

expressionMath	: (caractereFormule)+ ;
/*
integrale       :  	INTEGRALE { maGestionPml.integraleAscii(); }   	;
indice		:	INDICE { maGestionPml.indiceAscii(); }		;
exposant	:	EXPOSANT { maGestionPml.exposantAscii(); }	;
*/
//======================= fin du parser =======================================
//======================= fin du parser =======================================

//======================= Dbut du Lexer =======================================
//======================= Dbut du Lexer =======================================


CARACTERE
:	'A'..'Z'
	| 'a'..'z'
	| '#'
	;

BLANC       :  ' '  ;

SEPARATEUR	:	',' | ';' | '.' | '!' | '?' ;

//BLANC       :  (' ' | '\\\r\n' {newline();} )
  //                            { if(enPf) $setType(Token.SKIP); } ;
BLANC_FORCE : ('\\ ' | '\\,' | '\\\r\n' );
ESPACE            :  ('\\espace' | '\\;');
// Whitespace -- ignored
WS :  (  '\t'
      |  '\f'
// handle newlines
      |  (  '\r\n'  // Evil DOS
      |  '\r'     // Macintosh
      |  '\n'  // Unix (the right way)
         )
      ) {skip();}// { _ttype = Token.SKIP; }
   ;


//CARACTERE_RESERVE  :  '&' | '~'  ;
//CARACTERE_DIEZE    : '#' ;
CARACTERE_ACCENTUE : '\u00A1'..'\u00FF' ;

//=================== lettres accentues ========================
A_GRAVE        : '\\`a' | '{\\`a}';
A_AIGU         : '\\\'a' ;
A_CIRCONFLEXE  : '\\^a' ;
A_TILDE        : '\\~a' ;
A_TREMA        : '\\\"a' ;
A_ROND         : '\\.a' ;

E_GRAVE        : '\\`e' ;
E_AIGU         : '\\\'e' ;
E_CIRCONFLEXE  : '\\^e' ;
E_TREMA        : '\\\"e' ;

I_GRAVE        : ('\\`i' | '\\`\\i')   ;
I_AIGU         : ('\\\'i' | '\\\'\\i') ;
I_CIRCONFLEXE  : ('\\^i'  | '\\^\\i')  ;
I_CIRCONFLEXE_PAR :  '{\\^\\i}' ;
I_TREMA        : ('\\\"i' | '{\\\"i}' | '\\\"\\i' | '{\\\"\\i}') ;

O_GRAVE        : '\\`o' ;
O_AIGU         : '\\\'o' ;
O_CIRCONFLEXE  : '\\^o' ;
O_TILDE        : '\\~o' ;
O_TREMA        : '\\\"o' ;

U_GRAVE        : '\\`u' | '{\\`u}' ;
U_AIGU         : '\\\'u' ;
U_CIRCONFLEXE  : '\\^u' ;
U_TREMA        : '\\\"u' ;

C_CEDILLE      :  ('\\c c' | '{\\c c}' | '\\c\r\nc') ;
N_TILDE        :  '\\~n' ;

AM_GRAVE        : '\\`A' ;
AM_AIGU         : '\\\'A' ;
AM_CIRCONFLEXE  : '\\^A' ;
AM_TILDE        : '\\~A' ;
AM_TREMA        : '\\\"A' ;
AM_ROND         : '\\.A' ;

EM_GRAVE        : '\\`E' ;
EM_AIGU         : '\\\'E' ;
EM_CIRCONFLEXE  : '\\^E' ;
EM_TREMA        : '\\\"E' ;

IM_GRAVE        : '\\`I' ;
IM_AIGU         : '\\\'I' ;
IM_CIRCONFLEXE  : '\\^I' ;
IM_TREMA        : '\\\"I' ;

OM_GRAVE        : '\\`O' ;
OM_AIGU         : '\\\'O' ;
OM_CIRCONFLEXE  : '\\^O' ;
OM_TILDE        : '\\~O' ;
OM_TREMA        : '\\\"O' ;

UM_GRAVE        : '\\`U' ;
UM_AIGU         : '\\\'U' ;
UM_CIRCONFLEXE  : '\\^U' ;
UM_TREMA        : '\\\"U' ;

CM_CEDILLE      :  '\\c C' ;
NM_TILDE        :  '\\~N' ;
//===================  fin lettres accentues ========================

R_ACCOLADE     :  '}'         ;
L_ACCOLADE     :  '{'         ;

//============= formes polices =================
PL_GRASSE_EMP  :  '{\\bf' | '\\textbf{' |  '\\mathbf{' ;

PL_PENCHEE_EMP :  '{\\sl'     ;
L_PENCHEE_EMP  :  '\\textsl{'
               |  '\\mathsl{' ;
L_GRASSE_PENCHEE_EMP   :  '\\textbf{\\textsl{'    ;
L_PENCHEE_GRASSE_EMP   :  '\\textsl{\\textbf{'    ;
PL_GRASSE_PENCHEE_EMP   :  '{\\bf{\\sl '    ;
PL_PENCHEE_GRASSE_EMP   :  '{\\sl{\\bf '    ;

DEBUT_DOCUMENT  : '\\begin{document}'  ;
FIN_DOCUMENT    : '\\end{document}'  ;
LE_END          : '\\end'  ;

FINPARAG       :	'\\par'         ;

//============== formule ===============
PETITE_FORMULE          :  	'$'    	;
CARACTERE_FORMULE	:	'!' .. '~'	;
//INDICE		:	'#ind'	;
//EXPOSANT	:	    '#exp'	;
//========================= trio ===========================
//INTEGRALE         :  '\\int'     ;

